#include "main.h"
#include "bjvid.h"
#include "globals.h"
#include "twk.h"


int tiledirty[16*16];
BYTE bjback[0x1000];
BYTE bjcols[256];
extern BYTE savepal[256*3];

BJPALETTE bjpal[128];


void initbj(void)
{
   int i;
   for(i=0;i<256;i++)
      bjpal[i].dirty=0;
}

void bjint(void)
{
   if(pCode[0xb000])
      mz80nmi();
}

void markbjdirty(int x,int y)
{
   int idx;
   static int xoff[]={0,1,0,1};
   static int yoff[]={0,0,1,1};

   x>>=4;
   y>>=4;
   for(idx=0;idx<4;idx++)
      tiledirty[x+xoff[idx]+((y+yoff[idx])<<4)]=-1;
}

void markbj32dirty(int x,int y)
{
   int idx;
   static int xoff[]={0,1,2,0,1,2,0,1,2};
   static int yoff[]={0,0,0,1,1,1,2,2,2};

   x>>=4;
   y>>=4;
   for(idx=0;idx<9;idx++)
      tiledirty[x+xoff[idx]+((y+yoff[idx])<<4)]=-1;
}


void bjupdatescreen(void)
{
   BYTE x,y,attr,col,prey1,dispprey,x1;
   int idx;
   int prey2,spr,bimage;
   int tile,toffs,tbase,yoff,big;
   int flpx,flpy;
   pBYTE pWork;
   pBYTE pWork2;
   pBYTE pWork3;

//fastclear();

   bimage=pCode[0x9e00];
   tbase=0x200*(bimage&0x07);
   if(realorient)
   {
      if(FlipScreen)
      {
//background
         if(bimage&0x10)
         {
            for(y=0;y<16;y++)
            {
               for(x=0;x<16;x++)
               {
                  toffs=tbase+(y<<4)+x;
                  tile=bjback[toffs];
                  attr=bjback[toffs+0x100];

                  if(tiledirty[x+(y<<4)]!=(tile|((attr&0xf)<<8)))
                  {
                     dispbjtile(15-x,15-y,tile,attr&0x0f,1,!(attr&0x80));
                     tiledirty[x+(y<<4)]=(tile|((attr&0xf)<<8));
                     pacdirty[(x<<1)+((y<<1)<<5)]=-1;
                     pacdirty[(x<<1)+1+((y<<1)<<5)]=-1;
                     pacdirty[(x<<1)+1+(((y<<1)+1)<<5)]=-1;
                     pacdirty[(x<<1)+(((y<<1)+1)<<5)]=-1;
                  }
               }
            }
         }

//chars
         pWork2=&pCode[0x9000];
         pWork3=&pCode[0x9400];

         if(bimage&0x10)
         {
            for(y=0;y<31;y++)
            {
               dispprey=(31-y)<<3;
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[x+(y<<5)]!=(spr|(col<<8)))
                  {
                     if(x>2&&x<30)
                        disptranschar((31-x)<<3,dispprey,spr,col&0xf);
                     else
                        dispchar((31-x)<<3,dispprey,spr,col&0xf);
                     pWork+=8;
                     if(pacdirty[x+(y<<5)]!=-1)
                        tiledirty[(x>>1)+((y>>1)<<4)]=-1;
                     pacdirty[x+(y<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
         else
         {
            for(y=0;y<31;y++)
            {
               dispprey=(31-y)<<3;
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[x+(y<<5)]!=(spr|(col<<8)))
                  {
                     dispchar((31-x)<<3,dispprey,spr,col&0xf);
                     pacdirty[x+(y<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
//sprites
         for(idx=92;idx>=0;idx-=4)
         {
            x=pCode[0x9820+idx+3];
            if(x)
            {
               big=pCode[0x9820+idx]&0x80;
               yoff=241-(big>>3);
               y=yoff-pCode[0x9820+idx+2];
               if(!big)
               {
                  sprblit(240-x,239-y,pCode[0x9820+idx]&0x7f,pCode[0x9820+idx+1]&0x0f,!(pCode[0x9820+idx+1]&0x40),!(pCode[0x9820+idx+1]&0x80));
                  markbjdirty(x,y);
               }
               else
               {
                  disp32sprite(223-x,224-y,pCode[0x9820+idx]&0x1f,pCode[0x9820+idx+1]&0x0f,!(pCode[0x9820+idx+1]&0x40),!(pCode[0x9820+idx+1]&0x80));
                  markbj32dirty(x,y);
               }
            }
         }
      }
      else
      {
         if(bimage&0x10)
         {
            for(y=0;y<16;y++)
            {
               for(x=0;x<16;x++)
               {
                  toffs=tbase+(16*y)+x;
                  tile=bjback[toffs];
                  attr=bjback[toffs+0x100];

                  if(tiledirty[x+(y<<4)]!=(tile|((attr&0xf)<<8)))
                  {
                     dispbjtile(x,y,tile,attr&0x0f,0,attr&0x80);
                     tiledirty[x+(y<<4)]=(tile|((attr&0xf)<<8));
                     pacdirty[(x<<1)+((y<<1)<<5)]=-1;
                     pacdirty[(x<<1)+1+((y<<1)<<5)]=-1;
                     pacdirty[(x<<1)+1+(((y<<1)+1)<<5)]=-1;
                     pacdirty[(x<<1)+(((y<<1)+1)<<5)]=-1;
                  }
               }
            }
         }

//chars
         pWork2=&pCode[0x9000];
         pWork3=&pCode[0x9400];

         if(bimage&0x10)
         {
            for(y=0;y<32;y++)
            {
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[x+(y<<5)]!=(spr|(col<<8)))
                  {
                     if(x>2&&x<30)
                        disptranschar(x<<3,y<<3,spr,col&0xf);
                     else
                        dispchar(x<<3,y<<3,spr,col&0xf);
                     pWork+=8;
                     if(pacdirty[x+(y<<5)]!=-1)
                        tiledirty[(x>>1)+((y>>1)<<4)]=-1;
                     pacdirty[x+(y<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
         else
         {
            for(y=0;y<32;y++)
            {
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[x+(y<<5)]!=(spr|(col<<8)))
                  {
                     dispchar(x<<3,y<<3,spr,col&0xf);
                     pacdirty[x+(y<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
//sprites
         for(idx=92;idx>=0;idx-=4)
         {
            x=pCode[0x9820+idx+3];
            if(x)
            {
               big=pCode[0x9820+idx]&0x80;
               yoff=241-(big>>3);
               y=yoff-pCode[0x9820+idx+2];
               if(!big)
               {
                  sprblit(x,y,pCode[0x9820+idx]&0x7f,pCode[0x9820+idx+1]&0x0f,pCode[0x9820+idx+1]&0x40,pCode[0x9820+idx+1]&0x80);
                  markbjdirty(x,y);
               }
               else
               {
                  disp32sprite(x,y,pCode[0x9820+idx]&0x1f,pCode[0x9820+idx+1]&0x0f,pCode[0x9820+idx+1]&0x40,pCode[0x9820+idx+1]&0x80);
                  markbj32dirty(x,y);
               }
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
//background
         if(bimage&0x10)
         {
            for(y=0;y<16;y++)
            {
               prey1=15-y;
               prey2=prey1<<1;
               dispprey=y-1;
               for(x=0;x<16;x++)
               {
                  toffs=tbase+(y<<4)+x;
                  tile=bjback[toffs];
                  attr=bjback[toffs+0x100];

                  if(tiledirty[prey1+(x<<4)]!=(tile|((attr&0xf)<<8)))
                  {
                     dispbjtile(dispprey,15-x,tile,attr&0x0f,!(attr&0x80),1);
                     tiledirty[prey1+(x<<4)]=(tile|((attr&0xf)<<8));
                     pacdirty[prey2+((x<<1)<<5)]=-1;
                     pacdirty[prey2+1+((x<<1)<<5)]=-1;
                     pacdirty[prey2+1+(((x<<1)+1)<<5)]=-1;
                     pacdirty[prey2+(((x<<1)+1)<<5)]=-1;
                  }
               }
            }
         }

//chars
         pWork2=&pCode[0x9000];
         pWork3=&pCode[0x9400];

         if(bimage&0x10)
         {
            for(y=0;y<30;y++)
            {
               prey1=30-y;
               dispprey=(y<<3)-8;

               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[prey1+(x<<5)]!=(spr|(col<<8)))
                  {
                     if(y>2&&y<30)
                        disptranschar(dispprey,248-(x<<3),spr,col&0xf);
                     else
                        dispchar(dispprey,248-(x<<3),spr,col&0xf);
                     pWork+=8;
                     if(pacdirty[prey1+(x<<5)]!=-1)
                        tiledirty[(prey1>>1)+((x>>1)<<4)]=-1;
                     pacdirty[prey1+(x<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
         else
         {
            for(y=0;y<32;y++)
            {
               prey1=31-y;
               dispprey=(y<<3)-8;
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[prey1+(x<<5)]!=(spr|(col<<8)))
                  {
                     dispchar(dispprey,248-(x<<3),spr,col&0xf);
                     pacdirty[prey1+(x<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
//sprites
         for(idx=92;idx>=0;idx-=4)
         {
            x=pCode[0x9820+idx+3];
            if(x)
            {
               big=pCode[0x9820+idx]&0x80;

               if(big)
                  y=(pCode[0x9820+idx+2]+(big>>4))-16;
               else
                  y=pCode[0x9820+idx+2];


               if(!big)
               {
                  sprblit(231-y,240-x,pCode[0x9820+idx]&0x7f,pCode[0x9820+idx+1]&0x0f,!(pCode[0x9820+idx+1]&0x80),!(pCode[0x9820+idx+1]&0x40));
                  markbjdirty(y-8,x);
               }
               else
               {
                  disp32sprite(209-y,224-x,pCode[0x9820+idx]&0x1f,pCode[0x9820+idx+1]&0x0f,1,1);
                  markbj32dirty(y-1,x);
               }
            }
         }
      }
      else
      {
//background
         if(bimage&0x10)
         {
            for(y=0;y<16;y++)
            {
               prey1=15-y;
               prey2=prey1<<1;
               for(x=0;x<16;x++)
               {
                  toffs=tbase+(y<<4)+x;
                  tile=bjback[toffs];
                  attr=bjback[toffs+0x100];

                  if(tiledirty[prey1+(x<<4)]!=(tile|((attr&0xf)<<8)))
                  {
                     dispbjtile(prey1,x,tile,attr&0x0f,attr&0x80,0);
                     tiledirty[prey1+(x<<4)]=(tile|((attr&0xf)<<8));
                     pacdirty[prey2+((x<<1)<<5)]=-1;
                     pacdirty[prey2+1+((x<<1)<<5)]=-1;
                     pacdirty[prey2+1+(((x<<1)+1)<<5)]=-1;
                     pacdirty[prey2+(((x<<1)+1)<<5)]=-1;
                  }
               }
            }
         }

//chars
         pWork2=&pCode[0x9000];
         pWork3=&pCode[0x9400];

         if(bimage&0x10)
         {
            for(y=0;y<30;y++)
            {
               prey1=30-y;

               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[prey1+(x<<5)]!=(spr|(col<<8)))
                  {
                     if(y>2&&y<30)
                        disptranschar(240-(y<<3),x<<3,spr,col&0xf);
                     else
                        dispchar(240-(y<<3),x<<3,spr,col&0xf);
                     pWork+=8;
                     if(pacdirty[prey1+(x<<5)]!=-1)
                        tiledirty[(prey1>>1)+((x>>1)<<4)]=-1;
                     pacdirty[prey1+(x<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
         else
         {
            for(y=0;y<32;y++)
            {
               prey1=31-y;
               for(x=0;x<32;x++,pWork2++,pWork3++)
               {
                  col=*pWork3;
                  spr=*pWork2+((col&0x10)<<4);
                  if(pacdirty[prey1+(x<<5)]!=(spr|(col<<8)))
                  {
                     dispchar(240-(y<<3),x<<3,spr,col&0xf);
                     pacdirty[prey1+(x<<5)]=(spr|(col<<8));
                  }
               }
            }
         }
//sprites
         for(idx=92;idx>=0;idx-=4)
         {
            x=pCode[0x9820+idx+3];
            if(x)
            {
               big=pCode[0x9820+idx]&0x80;

               y=pCode[0x9820+idx+2]-(big>>4);

               if(!big)
               {
                  sprblit(y-8,x,pCode[0x9820+idx]&0x7f,pCode[0x9820+idx+1]&0x0f,pCode[0x9820+idx+1]&0x80,pCode[0x9820+idx+1]&0x40);
                  markbjdirty(y-8,x);
               }
               else
               {
                  disp32sprite(y-1,x,pCode[0x9820+idx]&0x1f,pCode[0x9820+idx+1]&0x0f,0,0);
                  markbj32dirty(y-1,x);
               }
            }
         }
      }
   }
}

void dispbjtile(int x,int y,int value,int col,int flipx,int flipy)
{
   int x1,y1,dummy1,dummy2,dummy3,temp;
   int ymove,xmove;
   pBYTE pWork;
   pBYTE pWork2;

   x+=2;
   y+=2;

   pWork=pScreen+(x<<4)+(y<<13);
   pWork2=&Tiles[COL_TILE+(value<<8)];

   xmove=1;


   if(flipy)
   {
      pWork+=0x1e00;
      ymove=-0x210;
   }
   else
      ymove=0x1f0;


   if(flipx)
   {
      pWork+=15;
      xmove=-1;
      ymove+=32;

      __asm__ __volatile__
      (
         ".align 4 \n"
//save es and set our selector
         "pushw      %%es  \n"
         "movw    %%ax,%%es \n"
         "cld \n"
         "movl    $16,%%ecx \n"
         "movl    %%ecx,%%edx \n"
//height loop
"1:\n"
         "pushl   %%ecx \n"
//width loop
"2:\n"
         "movb    (%%esi),%%al \n"
         "movb    %%al,(%%edi) \n"
         "addl    %3,%%edi \n"
         "incl    %%esi \n"
         "loop    2b \n"
//move onto next line
         "addl    %4,%%edi \n"
//get width size back and loop
         "popl    %%ecx \n"
         "decl    %%edx \n"
         "jnz     1b \n"

         "popw    %%es \n"

//outputs (clobbered inputs)
         : "=a" (dummy1),
            "=S" (dummy2),
            "=D" (dummy3)
// inputs -
         : "g" (xmove),
           "g" (ymove),
           "0" (DataSeg),
           "1" (pWork2),
         "2" (pWork)
// registers modified
         :  "cx","dx","cc", "memory"
      );
   }
   else
   {
      __asm__ __volatile__
      (
         ".align 4 \n"
//save es and set our selector
         "pushw      %%es  \n"
         "movw    %%ax,%%es \n"
         "cld \n"
         "movl    $16,%%edx \n"
         "movl    $4,%%ecx \n"
//height loop
"1:\n"
         "pushl   %%ecx \n"
//width loop
         "rep \n"
         "movsl \n"
//move onto next line
         "addl    %3,%%edi \n"
//get width size back and loop
         "popl    %%ecx \n"
         "decl    %%edx \n"
         "jnz     1b \n"

         "popw    %%es \n"

//outputs (clobbered inputs)
         : "=a" (dummy1),
            "=S" (dummy2),
            "=D" (dummy3)
// inputs -
         : "g" (ymove),
           "0" (DataSeg),
           "1" (pWork2),
         "2" (pWork)
// registers modified
         :  "cx","dx","cc", "memory"
      );

   }
}
void clearbj(void)
{
}

void bjdecodegfx(pBYTE pIn,int nType)
{
//get the background (layout+colours)
   memcpy(bjback,pIn+0xf000,0x1000);
}

void bjsetpal(pBYTE pIn)
{
}



void bjpalwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;
   BYTE newcol;
   int r,g,b;

   int newidx;
   work=offset-mwb->lowAddr;

   bjcols[work]=value;
   newidx=work>>1;
   work-=work&1;
   newcol=bjcols[work];

   r=newcol&0x0f;
   g=(newcol>>4)&0x0f;
   b=bjcols[work+1]&0x0f;

   bjpal[newidx].dirty=1;
   bjpal[newidx].r=(r|r<<4)>>2;
   bjpal[newidx].g=(g|g<<4)>>2;
   bjpal[newidx].b=(b|b<<4)>>2;

}

void bjpalupd(void)
{
   int idx,old;
   old=240;
   if(uiactive)
   {
      for(idx=0;idx<128;idx++)
      {
         if(bjpal[idx].dirty)
         {
            bjpal[idx].dirty=0;
            if(old!=idx)
               outportb(0x3c8,idx);
            savepal[idx*3]=bjpal[idx].r;
            savepal[(idx*3)+1]=bjpal[idx].g;
            savepal[(idx*3)+2]=bjpal[idx].b;
            outportb(0x3c9,(int)(((float)bjpal[idx].r/100.0f)*40.0f));
            outportb(0x3c9,(int)(((float)bjpal[idx].g/100.0f)*40.0f));
            outportb(0x3c9,(int)(((float)bjpal[idx].b/100.0f)*40.0f));
            old=idx+1;
         }
      }
   }
   else
   {
      for(idx=0;idx<128;idx++)
      {
         if(bjpal[idx].dirty)
         {
            bjpal[idx].dirty=0;
            if(old!=idx)
               outportb(0x3c8,idx);
            outportb(0x3c9,bjpal[idx].r);
            outportb(0x3c9,bjpal[idx].g);
            outportb(0x3c9,bjpal[idx].b);
            old=idx+1;
         }
      }
   }
}

UINT8 readbjp1(UINT32 offset, struct MemoryReadByte *mrb)
{
   return pCode[0xb000]|pCode[0x10001];
}
