#ifndef _BOARDS_H_
#define _BOARDS_H_

#define  ORIG_ROT_LEFT  0
#define  ORIG_ROT_RIGHT 1

typedef struct boardioTAG
{
   int baseno;
   struct MemoryReadByte *memread;
   struct MemoryWriteByte *memwrite;
   struct z80PortRead *portread;
   struct z80PortWrite *portwrite;
   void (*inter)(void);
   int noints;
} BOARDIO;

typedef struct boardromTAG
{
   pROMSTRUCT coderoms;
   pROMSTRUCT gfxroms;
   pROMSTRUCT palroms;
   pROMSTRUCT soundroms;
} BOARDROM;

typedef struct boardscreenTAG
{
   int xsize;
   int ysize;
   int xoff;
   int yoff;
   int xscroff;
   int yscroff;
   int mode;
} BOARDSCREEN;

typedef struct boardsampleTAG
{
   char sample[16];
} BOARDSAMPLE;

typedef BOARDSAMPLE *pBOARDSAMPLE;

//board structure
typedef struct boardTAG
{
   char name[16];
   char game[64];
   char basename[16];
   int  nocpus;
   BOARDIO boardIO[3];
   BOARDROM boardROM[3];
   char samplename[16];
   BOARDSAMPLE boardSample[64];
   int streams;
   int pre;
   pBYTE pal;
   BOARDSCREEN boardScreen[2];
   pINPUTS pInputs;
   pBYTE pScreen;
   void (*initgame)(void);
   void (*cleargame)(void);
   void (*decodegfx)(pBYTE,int);
   pGFXDETAILS gfxdetails;
   int nochars;
   int nocharcols;
   int nosprites;
   int nosprcols;
   int nobigsprites;
   int nobigsprcols;
   int notiles;
   int notilecols;
   int rottiles;
   void (*setpal)(pBYTE);
   void (*palupdate)(void);
   void (*initvid)(void);
   void (*updatescreen)(void);
   DIPSWITCH dipsetting[MAX_DIPS];
   void (*forcedreset)(void);
   void (*menuclear)(void);
   int background;
   int dirtyblit;
   int dirtyupd;
   int origrot;
   void (*preswap)(void);
   void (*postswap)(void);
   int interval;
   void (*initsound)(void);
   void (*soundupdate)(void);
   int mutex;
   int scaler;
} BOARD;

typedef BOARD * pBOARD;

typedef struct gaminfoTAG
{
   char name[16];
   char game[64];
   char basename[16];
   int index;
} GAMEINFO;

typedef GAMEINFO *pGAMEINFO;


pBOARD getboard(int argc,char **argv);
int gamesort(const void *a,const void *b);
int gamesortshort(const void *a,const void *b);
void setoptions(int argc,char **argv);
void saveoptions(void);
void banner(void);
void disphelp(void);
void getfileopts(void);
void setrotations(void);
void markthorttle(void);
void listroms(char *pTitle,int CPU,pROMSTRUCT pROMS);
void listsamples(pBOARDSAMPLE pSample,char *pSetName);

void genaosconfiles(void);
void genaosfile(char *name,char **info);


#endif
