#include "main.h"
#include "globals.h"



DIPSWITCH   dipswitch[MAX_DIPS];

void readdip(void)
{
   int i,j;
   BYTE inidx;
   FILE *fdip;
   static char buffer[256];
//default
   memcpy(dipswitch,pBoard->dipsetting,sizeof(DIPSWITCH)*MAX_DIPS);
//file
   sprintf(buffer,"dips\\%s.dip",pBoard->name);
   fdip=fopen(buffer,"rb");
   if(fdip)
   {
      for(i=0;i<MAX_DIPS;i++)
      {
         for(j=0;j<8;j++)
         {
            cleardipset(i,j);
            fread(&inidx,1,1,fdip);
            dipswitch[i].dipsetting[j].valuesetting[inidx].thisvalue=1;
         }
      }
      fclose(fdip);
   }

   updatedip();
}

void writedip(void)
{
   FILE *fdip;
   int i,j,k;
   BYTE outidx;
   static char buffer[256];
   sprintf(buffer,"dips\\%s.dip",pBoard->name);
   fdip=fopen(buffer,"wb");
   if(fdip)
   {
      for(i=0;i<MAX_DIPS;i++)
      {
         for(j=0;j<8;j++)
         {
            outidx=0;
            for(k=0;k<16;k++)
            {
               if(dipswitch[i].dipsetting[j].valuesetting[k].thisvalue)
               {
                  outidx=(BYTE)k;
                  break;
               }
            }
            fwrite(&outidx,1,1,fdip);
         }
      }
      fclose(fdip);
   }
}

void updatedip(void)
{
   int i,j,k,outval;
   for(i=0;i<MAX_DIPS;i++)
   {
      dipswitch[i].setting=dipswitch[i].basevalue;
      if(!dipswitch[i].id)
         break;
      for(j=0;j<32;j++)
      {
         if(!*dipswitch[i].dipsetting[j].szName)
            break;

         outval=dipswitch[i].dipsetting[j].defsetting;
         for(k=0;k<16;k++)
         {
            if(!*dipswitch[i].dipsetting[j].valuesetting[k].szValue)
               break;
            if(dipswitch[i].dipsetting[j].valuesetting[k].thisvalue)
            {
               outval=dipswitch[i].dipsetting[j].valuesetting[k].nValue;
               break;
            }
         }
         dipswitch[i].dipsetting[j].cursetting=outval;
         dipswitch[i].setting|=dipswitch[i].dipsetting[j].cursetting;


         for(k=0;k<16;k++)
         {
            if(!*dipswitch[i].dipsetting[j].valuesetting[k].szValue)
               break;
            if(dipswitch[i].dipsetting[j].valuesetting[k].nValue==outval)
            {
               dipswitch[i].dipsetting[j].valuesetting[k].thisvalue=1;
               break;
            }
         }

      }
   }
}

void cleardipset(int dip,int dipsub)
{
   int i;
   for(i=0;i<16;i++)
   {
      if(!*dipswitch[dip].dipsetting[dipsub].valuesetting[i].szValue)
         break;
      dipswitch[dip].dipsetting[dipsub].valuesetting[i].thisvalue=0;
   }
}

int intdip1(void)
{
   int retval;
   retval=0;

   if(dipswitch[0].exfunc)
      retval|=dipswitch[0].exfunc();


   retval|=dipswitch[0].setting;
/*
   PORT_START
	PORT_DIPNAME( 0x03, 0x03, DEF_STR( Lives ) )
	PORT_DIPSETTING(    0x03, "3" )
	PORT_DIPSETTING(    0x02, "4" )
	PORT_DIPSETTING(    0x01, "5" )
	PORT_DIPSETTING(    0x00, "6" )
	PORT_DIPNAME( 0x04, 0x04, DEF_STR( Unknown ) )
	PORT_DIPSETTING(    0x04, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
	PORT_DIPNAME( 0x08, 0x08, DEF_STR( Unknown ) )
	PORT_DIPSETTING(    0x08, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
	PORT_DIPNAME( 0x10, 0x10, DEF_STR( Difficulty ) )
	PORT_DIPSETTING(    0x10, "Easy" )
	PORT_DIPSETTING(    0x00, "Hard" )
	PORT_DIPNAME( 0x20, 0x20, DEF_STR( Unknown ) )
	PORT_DIPSETTING(    0x20, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
	PORT_DIPNAME( 0x40, 0x00, DEF_STR( Cabinet ) )
	PORT_DIPSETTING(    0x00, DEF_STR( Upright ) )
	PORT_DIPSETTING(    0x40, DEF_STR( Cocktail ) )
	PORT_DIPNAME( 0x80, 0x80, "Freeze" )
	PORT_DIPSETTING(    0x80, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
*/
  // retval=3|4|8|0x10|0x20|0x80;
//   loginfo("dip1 read =0x%x",retval);
   return retval;
}

int intdip2(void)
{
   int retval;

   retval=0;

   if(dipswitch[1].exfunc)
      retval|=dipswitch[1].exfunc();


   retval|=dipswitch[1].setting;
/*
	PORT_DIPNAME( 0x07, 0x07, DEF_STR( Coin_A ) )
	PORT_DIPSETTING(    0x02, DEF_STR( 2C_1C ) )
	PORT_DIPSETTING(    0x01, DEF_STR( 3C_2C ) )
	PORT_DIPSETTING(    0x07, DEF_STR( 1C_1C ) )
	PORT_DIPSETTING(    0x06, DEF_STR( 1C_2C ) )
	PORT_DIPSETTING(    0x05, DEF_STR( 1C_3C ) )
	PORT_DIPSETTING(    0x04, DEF_STR( 1C_4C ) )
	PORT_DIPSETTING(    0x03, DEF_STR( 1C_6C ) )
	PORT_DIPSETTING(    0x00, DEF_STR( Free_Play ) )
	PORT_DIPNAME( 0x38, 0x38, DEF_STR( Coin_B ) )
	PORT_DIPSETTING(    0x00, DEF_STR( 5C_1C ) )
	PORT_DIPSETTING(    0x08, DEF_STR( 4C_1C ) )
	PORT_DIPSETTING(    0x10, DEF_STR( 3C_1C ) )
	PORT_DIPSETTING(    0x18, DEF_STR( 2C_1C ) )
	PORT_DIPSETTING(    0x38, DEF_STR( 1C_1C ) )
	PORT_DIPSETTING(    0x20, DEF_STR( 3C_4C ) )
	PORT_DIPSETTING(    0x30, DEF_STR( 1C_2C ) )
	PORT_DIPSETTING(    0x28, DEF_STR( 1C_3C ) )
	PORT_DIPNAME( 0x40, 0x40, DEF_STR( Unknown ) )
	PORT_DIPSETTING(    0x40, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
	PORT_DIPNAME( 0x80, 0x80, DEF_STR( Unknown ) )
	PORT_DIPSETTING(    0x80, DEF_STR( Off ) )
	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
*/
//   retval=7|0x38|0x40|0x80;
  // loginfo("dip2 read =0x%x",retval);
   return retval;
}

UINT8 dip1(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;


   if(dipswitch[0].force)
      retval=0;
   else
      retval=pCode[offset];


   if(dipswitch[0].exfunc)
      retval|=dipswitch[0].exfunc();


   retval|=dipswitch[0].setting;
   return retval;
}

UINT8 dip2(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[1].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[1].exfunc)
      retval|=dipswitch[1].exfunc();

   return retval|dipswitch[1].setting;
}

UINT8 dip3(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[2].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[2].exfunc)
      retval|=dipswitch[2].exfunc();

   retval|=dipswitch[2].setting;

   return retval;
}

UINT8 dip4(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[3].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[3].exfunc)
      retval|=dipswitch[3].exfunc();

   return retval|dipswitch[3].setting;
}


UINT16 portdip1(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[0].exfunc)
      retval=dipswitch[0].exfunc();

   return retval|dipswitch[0].setting;

}

UINT16 portdip2(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[1].exfunc)
      retval=dipswitch[1].exfunc();

   return retval|dipswitch[1].setting;

}

UINT16 portdip3(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[2].exfunc)
      retval=dipswitch[2].exfunc();

   return retval|dipswitch[2].setting;
}

UINT16 portdip4(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[3].exfunc)
      retval=dipswitch[3].exfunc();

   return retval|dipswitch[3].setting;
}
