#include "main.h"
#include "globals.h"
#include "dksnd.h"


static int val14del;

void dkupdatesound(void)
{
   if(val14del)
   {
      val14del--;
      if(!val14del)
         playsample(3,11,5,DEFAULT_FREQ); //start of end of game
   }
}

void dkjrupdatesound(void)
{
   static int lastval1;
   static int lastval2;
   int newval;

   if(pCode[0x7d04]!=lastval1||pCode[0x7d05]!=lastval2)
   {
      newval=pCode[0x7d04]|(pCode[0x7d05]<<8);
      switch(newval)
      {
         case 256:   //coin
            playsample(6,7,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 1:     //snapper kill
            playsample(6,18,ONE_SHOT,DEFAULT_FREQ);
            break;
      }
      lastval1=pCode[0x7d04];
      lastval2=pCode[0x7d05];
   }
}

void dkdeadw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   DK_STOP_SOUND(3,15,1)
}

void dkcoinw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(3,16)
}

void dkprizew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(5,17)
}

void dkfallw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(4,13)
}


void dkjrtunew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval;
   static int cheep;
   if(lastval!=value)
   {
      switch(value)
      {
         case 1:  //first level background
            playsample(1,9,LOOP,DEFAULT_FREQ);
            break;
         case 3:  //third level background
            playsample(1,15,LOOP,DEFAULT_FREQ);
            break;
         case 4:  //fourth level background
            playsample(1,17,LOOP,DEFAULT_FREQ);
            break;
         case 6:  //cut scene
            playsample(1,14,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 8:  //intro tune
            playsample(1,8,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 9:  //end of level 1
            playsample(1,10,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 10: //end of level 2
            playsample(1,13,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 11: //end of level 3
            playsample(1,16,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 12: //end of level 4
            playsample(1,20,ONE_SHOT,DEFAULT_FREQ);
            break;

      }
   }
   switch(value)
   {

      case 2:  //second level background
         if(!channel[1].playing)
         {
            cheep++;
            if(cheep==4)
            {
               playsample(1,11,ONE_SHOT,DEFAULT_FREQ);
               cheep=0;
            }
         }
         break;
      case 7:  //second level background
         playsample(1,12,ONE_SHOT,DEFAULT_FREQ);
         cheep=0;
         break;
      case 14: //end of all levels 'scream'
         playsample(1,19,ONE_SHOT,DEFAULT_FREQ);
         break;
   }
   lastval=value;
}

void dkjrsoundcoinw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(0,7);
}

void dkjrsoundhitw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   DK_SOUND(0,18);
}

void dktunew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval;
   static int val14count;

   if(value==14)
      val14count++;
   else
      val14count=0;

   if(lastval!=value)
   {
      switch(value)
      {
         case 1:
            playsample(3,3,ONE_SHOT,DEFAULT_FREQ); //dk climibing ladder intro
            break;
         case 2:
            playsample(3,5,ONE_SHOT,DEFAULT_FREQ); //how high can you try
            break;
         case 6:
            playsample(4,14,ONE_SHOT,DEFAULT_FREQ);   //hammer hit
            break;
         case 4:
            playsample(3,7,LOOP,DEFAULT_FREQ);    //'hammer'
            break;
         case 7:
            playsample(3,8,2,DEFAULT_FREQ);        //end of level
            queuesample(3,4,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 8:
            playsample(3,6,LOOP,DEFAULT_FREQ);    //first level background
            break;
         case 9:
            playsample(3,9,LOOP,DEFAULT_FREQ);    //second level background
            break;
         case 11:
            playsample(3,10,LOOP,DEFAULT_FREQ);   //fourth level background
            break;
         case 12:
            playsample(3,12,ONE_SHOT,DEFAULT_FREQ);   //end of levels
            break;
         case 13:
            playsample(5,17,ONE_SHOT,DEFAULT_FREQ);   //rivet
            break;
         case 15:
            playsample(3,4,ONE_SHOT,DEFAULT_FREQ); //noise/growl
            break;
      }
   }
   if(value==14&&val14count==3)
      val14del=50;


   lastval=value;
}

void dkjrsoundclimbw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval;

   if(value!=lastval&&value)
   {
      if(pCode[0x7d07]==1)
         playsample(3,6,ONE_SHOT,DEFAULT_FREQ);
      if(pCode[0x7d07]==0)
         playsample(3,3,ONE_SHOT,DEFAULT_FREQ);
   }
   lastval=value;

}

void dkjrsoundjumpw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(6,0)
}

void dkjrsoundlandw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_STOP_SOUND(4,1,7)
}

void dkjrsoundroarw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(7,2)
}

void dkjrsoundsnapjaww(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   if(value)
      stopsample(1);
}


void dkjrsounddeathw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   DK_STOP_SOUND(6,4,1)
   if(value)
      stopsample(7);
}

void dkjrsounddropw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   DK_SOUND(7,5);
}


void dksoundw1(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval[4];
   int work=offset-mwb->lowAddr;

   if(value&&lastval[work]!=value)
      playsample(work,work,ONE_SHOT,DEFAULT_FREQ);
   lastval[work]=value;
}

