#ifndef _DOCASTLE_BRD_H_
#define _DOCASTLE_BRD_H_

ROMSTRUCT docastlecode[]=
{
   {"01p_a1.bin",0x0000,0x2000,0x0000},
   {"01n_a2.bin",0x2000,0x2000,0x0000},
   {"01l_a3.bin",0x4000,0x2000,0x0000},
   {"01k_a4.bin",0x6000,0x2000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT docastlecode2[]=
{
   {"07n_a0.bin",0x0000,0x4000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT docastlegfx[]=
{
   {"03a_a5.bin",0x0000,0x4000,0x0000},
   {"04m_a6.bin",0x4000,0x2000,0x0000},
   {"04l_a7.bin",0x6000,0x2000,0x0000},
   {"04j_a8.bin",0x8000,0x2000,0x0000},
   {"04h_a9.bin",0xa000,0x2000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT docastlecol[]=
{
   {"09c.bin",0x0000,0x0200,0x0000},
   {"01d.bin",0x0200,0x0200,0x0000},
   {"",0,0,0}
};

ROMSTRUCT jjackcode[]=
{
   {"j1.bin",0x0000,0x2000,0x0000},
   {"j3.bin",0x4000,0x2000,0x0000},
   {"j4.bin",0x6000,0x2000,0x0000},
   {"j2.bin",0x8000,0x2000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT jjackgfx[]=
{
   {"j5.bin",0x0000,0x4000,0x0000},
   {"j6.bin",0x4000,0x2000,0x0000},
   {"j7.bin",0x6000,0x2000,0x0000},
   {"j8.bin",0x8000,0x2000,0x0000},
   {"j9.bin",0xa000,0x2000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT jjackcol[]=
{
   {"bprom1.bin",0x0000,0x0200,0x0000},
   {"bprom2.bin",0x0200,0x0200,0x0000},
   {"",0,0,0}
};


ROMSTRUCT jjackcode2[]=
{
   {"j0.bin",0x0000,0x4000,0x0000},
   {"",0,0,0}
};


//layout of sprites
SPRLAYOUT docastleslayout={32,256,4,{0,1,2,3},
   {56,60,48,52,40,44,32,36,24,28,16,20,8,12,0,4},
   {15*8,14*8,13*8,12*8,11*8,10*8,9*8,8*8,7*8,6*8,5*8,4*8,3*8,2*8,1*8,0*8},
   128};


//layout of chars
SPRLAYOUT docastleclayout={32,512,4,{0,1,2,3},
   {24,28,16,20,8,12,0,4},
   {7*4,6*4,5*4,4*4,3*4,2*4,1*4,0*4},
   32};


GFXDETAILS docastlegfxs[]=
{
   {0,0,8,8,&docastleclayout,0,TYPE_CHAR}, //background chars
   {0,512,8,8,&docastleclayout,2,TYPE_CHAR}, //foreground chars
   {0x4000,0,16,16,&docastleslayout,1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};

GFXDETAILS jjackgfxs[]=
{
   {0,0,8,8,&docastleclayout,0,TYPE_CHAR}, //background chars
   {0,512,8,8,&docastleclayout,3,TYPE_CHAR}, //foreground chars
   {0x4000,0,16,16,&docastleslayout,1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};


INPUTS docastleinputs[]=
{
   {K_PL1_RIGHT,0xc003,0x01,0,0},
   {K_PL1_UP,0xc003,0x02,0,0},
   {K_PL1_LEFT,0xc003,0x04,0,0},
   {K_PL1_DOWN,0xc003,0x08,0,0},
   {K_PL2_RIGHT,0xc003,0x10,0,0},
   {K_PL2_UP,0xc003,0x20,0,0},
   {K_PL2_LEFT,0xc003,0x40,0,0},
   {K_PL2_DOWN,0xc003,0x80,0,0},

   {K_PL1_B1,0xc005,0x01,0,0},
   {K_NO_MATCH,0xc005,0x02,0,0},
   {K_NO_MATCH,0xc005,0x04,0,0},
   {K_PL1_START,0xc005,0x08,0,0},
   {K_PL2_B1,0xc005,0x10,0,0},
   {K_NO_MATCH,0xc005,0x20,0,0},
   {K_NO_MATCH,0xc005,0x40,0,0},
   {K_PL2_START,0xc005,0x80,0,0},

   {K_NO_MATCH,0xc007,0x01,0,0},
   {K_NO_MATCH,0xc007,0x02,0,0},
   {K_COIN3,0xc007,0x04,0,32},
   {K_COIN2,0xc007,0x10,0,0},
   {K_COIN1,0xc007,0x20,0,0},
   {K_NO_MATCH,0xc007,0x40,0,0},
   {K_NO_MATCH,0xc007,0x80,0,0},

   {-1,-1,0,0,0}
};


#define DOCASTLEDIPS \
   { \
   {1,0,0,docin1,1, \
      { \
         {DIP_FREEZE,8,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,8} \
            } \
         } \
      } \
   }, \
   {2,0,8,0,0, \
      { \
         {DIP_DIFFICULTY,3,0, \
            { \
               {DIP_EASY,0,3},{DIP_MEDIUM,0,2},{DIP_HARD,0,1},{DIP_HARDEST,0,0} \
            } \
         }, \
         {DIP_RACK,4,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,4} \
            } \
         }, \
         {"Extra",0x10,0, \
            { \
               {DIP_EASY,0,0x10},{DIP_HARD,0,0} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,0x20} \
            } \
         }, \
         {DIP_LIVES,0xc0,0, \
            { \
               {"2",0,0},{"3",0,0xc0},{"4",0,0x80},{"5",0,0x40} \
            } \
         } \
      } \
   }, \
   {3,0,0,0,0, \
      { \
         {DIP_COINB,0x0f,0, \
            { \
               {DIP_4C_1C,0,0x06},{DIP_3C_1C,0,0x08},{DIP_2C_1C,0,0x0a}, \
               {DIP_3C_2C,0,0x07},{DIP_1C_1C,0,0x0f},{DIP_2C_3C,0,0x09}, \
               {DIP_1C_2C,0,0x0e},{DIP_1C_3C,0,0x0d},{DIP_1C_4C,0,0x0c}, \
               {DIP_1C_5C,0,0x0b},{DIP_FREE,0,0x00} \
            } \
         }, \
         {DIP_COINA,0xf0,0, \
            { \
               {DIP_4C_1C,0,0x60},{DIP_3C_1C,0,0x80},{DIP_2C_1C,0,0xa0}, \
               {DIP_3C_2C,0,0x70},{DIP_1C_1C,0,0xf0},{DIP_2C_3C,0,0x90}, \
               {DIP_1C_2C,0,0xe0},{DIP_1C_3C,0,0xd0},{DIP_1C_4C,0,0xc0}, \
               {DIP_1C_5C,0,0xb0},{DIP_FREE,0,0x00} \
            } \
         } \
      } \
   } \
   }


#define JJACKDIPS \
   { \
   {1,0,0,docin1,1, \
      { \
         {DIP_FREEZE,8,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,8} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_DIFFICULTY,3,0, \
            { \
               {DIP_EASY,0,3},{DIP_MEDIUM,0,2},{DIP_HARD,0,1},{DIP_HARDEST,0,0} \
            } \
         }, \
         {DIP_RACK,4,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,4} \
            } \
         }, \
         {"Flip Screen",0x08,0, \
            { \
               {DIP_ON,0,0x00},{DIP_OFF,0,8} \
            } \
         }, \
         {"Extra",0x10,0, \
            { \
               {DIP_EASY,0,0x10},{DIP_HARD,0,0} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,0x20} \
            } \
         }, \
         {DIP_LIVES,0xc0,0, \
            { \
               {"2",0,0},{"3",0,0xc0},{"4",0,0x80},{"5",0,0x40} \
            } \
         } \
      } \
   }, \
   {3,0,0,0,0, \
      { \
         {DIP_COINB,0x0f,0, \
            { \
               {DIP_4C_1C,0,0x06},{DIP_3C_1C,0,0x08},{DIP_2C_1C,0,0x0a}, \
               {DIP_3C_2C,0,0x07},{DIP_1C_1C,0,0x0f},{DIP_2C_3C,0,0x09}, \
               {DIP_1C_2C,0,0x0e},{DIP_1C_3C,0,0x0d},{DIP_1C_4C,0,0x0c}, \
               {DIP_1C_5C,0,0x0b},{DIP_FREE,0,0x00} \
            } \
         }, \
         {DIP_COINA,0xf0,0, \
            { \
               {DIP_4C_1C,0,0x60},{DIP_3C_1C,0,0x80},{DIP_2C_1C,0,0xa0}, \
               {DIP_3C_2C,0,0x70},{DIP_1C_1C,0,0xf0},{DIP_2C_3C,0,0x90}, \
               {DIP_1C_2C,0,0xe0},{DIP_1C_3C,0,0xd0},{DIP_1C_4C,0,0xc0}, \
               {DIP_1C_5C,0,0xb0},{DIP_FREE,0,0x00} \
            } \
         } \
      } \
   } \
   }


#endif
