#ifndef _FROG_BRD_H_
#define _FROG_BRD_H_


ROMSTRUCT frogcode[]=
{
   {"frogger.26",0x0000,0x1000,0x0000},
   {"frogger.27",0x1000,0x1000,0x0000},
   {"frsm3.7",0x2000,0x1000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT froggfx[]=
{
   {"frogger.606",0x0000,0x0800,0x0000},
   {"frogger.607",0x0800,0x0800,0x0000},
   {"",0,0,0}
};


ROMSTRUCT frogcol[]=
{
   {"pr-91.6l",0x0000,0x0020,0x0000},
   {"",0,0,0}
};

ROMSTRUCT frogsndcode[]=
{
   {"frogger.608",0x0000,0x0800,0x0000},
   {"frogger.609",0x0800,0x0800,0x0000},
   {"frogger.610",0x1000,0x0800,0x0000},
   {"",0,0,0}
};


//layout of chars
SPRLAYOUT frogclayout={16,256,2,{0,256*8*8},{7,6,5,4,3,2,1,0},{0,1,2,3,4,5,6,7},8};

//layout of sprites
SPRLAYOUT frogslayout={16,64,2,{0,256*8*8},
   {7,6,5,4,3,2,1,0,8*8+7,8*8+6,8*8+5,8*8+4,8*8+3,8*8+2,8*8+1,8*8},
   {0,1,2,3,4,5,6,7,16,17,18,19,20,21,22,23},32};

GFXDETAILS froggfxs[]=
{
   {0,0,8,8,&frogclayout,-1,TYPE_CHAR},
   {0,0,16,16,&frogslayout,-1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};

INPUTS froginputs[]=
{
   {K_PL2_UP,0xe000,0x01,0,0},
   {K_NO_MATCH,0xe000,0x02,0,0},
   {K_COIN3,0xe000,0x04,0,0},
   {K_NO_MATCH,0xe000,0x08,0,0},
   {K_PL1_RIGHT,0xe000,0x10,0,0},
   {K_PL1_LEFT,0xe000,0x20,0,0},
   {K_COIN2,0xe000,0x40,0,0},
   {K_COIN1,0xe000,0x80,0,0},

   {K_NO_MATCH,0xe002,0x04,0,0},
   {K_NO_MATCH,0xe002,0x08,0,0},
   {K_PL2_RIGHT,0xe002,0x10,0,0},
   {K_PL2_LEFT,0xe002,0x20,0,0},
   {K_PL2_START,0xe002,0x40,0,0},
   {K_PL1_START,0xe002,0x80,0,0},


   {K_PL2_DOWN,0xe004,0x01,0,0},
   {K_PL1_UP,0xe004,0x10,0,0},
   {K_NO_MATCH,0xe004,0x20,0,0},
   {K_PL1_DOWN,0xe004,0x40,0,0},
   {K_NO_MATCH,0xe004,0x80,0,0},

   {-1,-1,0,0,0}
};


#define FROGDIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_LIVES,0,0, \
            { \
               {"3",0,0},{"5",0,1},{"7",0,2},{"255",0,3} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_CREDIT,6,0, \
            { \
               {"A 2/1 B 2/1 C 2/1",0,2},{"A 2/1 B 1/3 C 2/1",0,4}, \
               {"A 1/1 B 1/1 C 1/1",0,0},{"A 1/1 B 1/6 C 1/1",0,6} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,0x8} \
            } \
         } \
      } \
   } \
   }
#endif
