#include "main.h"
#include "globals.h"
#include "frogsnd.h"

static struct AY8910interface ayinterface =
{
   1,
   14318000/8,
   { 15,15},
   {0,0},
   { sound_command_r },
   { frogger_portB_r },
	{ 0 },
	{ 0 }
};

void initfrogsnd(void)
{
   AY8910_sh_start(&ayinterface);
}

static int frogger_timer[10] =
{
	0x00, 0x10, 0x08, 0x18, 0x40, 0x90, 0x88, 0x98, 0x88, 0xd0
};


int frogger_portB_r(void)
{
	/* need to protect from totalcycles overflow */
	static int last_totalcycles = 0;

	/* number of Z80 clock cycles to count */
	static int clock;

	int current_totalcycles;

   current_totalcycles = getcurrentcycles();
	clock = (clock + (current_totalcycles-last_totalcycles)) % 5120;

	last_totalcycles = current_totalcycles;

	return frogger_timer[clock/512];
}

