#include "main.h"
#include "frogvid.h"
#include "galvid.h"
#include "amdvid.h"
#include "globals.h"

void initfrog(void)
{
   int idx;
   pBYTE pWork;
   pWork=context[1].z80Base;

   for(idx=0;idx<0x0800;idx++)
      pWork[idx]=(pWork[idx]&0xfc)|((pWork[idx]&1)<<1)|((pWork[idx]&2)>>1);

}

void clearfrog(void)
{
}

void frogint(void)
{
   if(pCode[0xb808])
      mz80nmi();
}


void updatefrogscreen(void)
{
   int idx;
   BYTE x,y,col,spr,flpx,flpy,s;
   BYTE y1;
   pBYTE pIn;
   pBYTE pWork;

   frogclear();

   pIn=&pCode[0xa800];


   if(realorient)
   {
      if(FlipScreen)
      {
         for(y=0;y<30;y++)
         {
            for(x=0;x<32;x++,pIn++)
            {
               s=pCode[0xb000+(x<<1)];
               s=(((s<<4)&0xf0)|((s>>4)&0x0f));
               y1=(y<<3)-s;
               if(y1<248&&*pIn!=16)
               {
                  col=pCode[0xb001+(x<<1)]&0x07;
                  col=((col>>1)&0x03)|((col<<2)&0x04);

                  if(x<16)
                     disptranschar(255-(x<<3),247-y1,*pIn,col);
                  else
                     dispchar(255-(x<<3),247-y1,*pIn,col);

               }
            }
         }
         pWork=&pCode[0xb040];

         for(idx=0;idx<32;idx+=4)
         {
            y=pWork[idx];
            y=(((y<<4)&0xf0)|((y>>4)&0x0f));
            spr=pWork[idx+1];
            flpx=!((spr>>6)&1);
            flpy=!((spr>>6)&2);
            col=pWork[idx+2]&7;
            col=((col>>1)&0x03)|((col<<2)&0x04);
            spr&=0x3f;

            x=248-pWork[idx+3];
            if(spr)
               sprblit(x,y,spr,col,flpx,flpy);
         }

      }
      else
      {

         for(y=0;y<30;y++)
         {
            for(x=0;x<32;x++,pIn++)
            {
               s=pCode[0xb000+(x<<1)];
               s=(((s<<4)&0xf0)|((s>>4)&0x0f));
               y1=(y<<3)-s;
               if(y1<248&&*pIn!=16)
               {
                  col=pCode[0xb001+(x<<1)]&0x07;
                  col=((col>>1)&0x03)|((col<<2)&0x04);

                  if(x<16)
                     disptranschar((x<<3),y1,*pIn,col);
                  else
                     dispchar((x<<3),y1,*pIn,col);

               }
            }
         }

         pWork=&pCode[0xb040];

         for(idx=0;idx<32;idx+=4)
         {
            y=pWork[idx];
            y=240-(((y<<4)&0xf0)|((y>>4)&0x0f));
            spr=pWork[idx+1];
            flpx=(spr>>6)&1;
            flpy=(spr>>6)&2;
            col=pWork[idx+2]&7;
            col=((col>>1)&0x03)|((col<<2)&0x04);
            spr&=0x3f;

            x=pWork[idx+3];
            if(spr)
               sprblit(x,y,spr,col,flpx,flpy);
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         for(y=0;y<30;y++)
         {
            for(x=0;x<32;x++,pIn++)
            {
               s=pCode[0xb000+(x<<1)];
               s=(((s<<4)&0xf0)|((s>>4)&0x0f));
               y1=((y<<3)-s);
               if(y1<248&&*pIn!=16)
               {
                  col=pCode[0xb001+(x<<1)]&0x07;
                  col=((col>>1)&0x03)|((col<<2)&0x04);

                  if(x<16)
                     disptranschar(y1+8,255-(x<<3),*pIn,col);
                  else
                     dispchar(y1+8,255-(x<<3),*pIn,col);

               }
            }
         }
         pWork=&pCode[0xb040];

         for(idx=0;idx<32;idx+=4)
         {
            y=pWork[idx];
            y=(((y<<4)&0xf0)|((y>>4)&0x0f))+8;
            spr=pWork[idx+1];
            flpx=!((spr>>6)&1);
            flpy=!((spr>>6)&2);
            col=pWork[idx+2]&7;
            col=((col>>1)&0x03)|((col<<2)&0x04);
            spr&=0x3f;

            x=pWork[idx+3];
            if(x&&y&&spr)
               sprblit(255-y,247-x,spr,col,flpy,flpx);
         }

      }
      else
      {
         for(y=0;y<30;y++)
         {
            for(x=0;x<32;x++,pIn++)
            {
               s=pCode[0xb000+(x<<1)];
               s=(((s<<4)&0xf0)|((s>>4)&0x0f));
               y1=255-((y<<3)-s);
               if(y1<248&&*pIn!=16)
               {
                  col=pCode[0xb001+(x<<1)]&0x07;
                  col=((col>>1)&0x03)|((col<<2)&0x04);

                  if(x<16)
                     disptranschar(y1,x<<3,*pIn,col);
                  else
                     dispchar(y1,x<<3,*pIn,col);

               }
            }
         }

         pWork=&pCode[0xb040];

         for(idx=0;idx<32;idx+=4)
         {
            y=pWork[idx];
            y=(((y<<4)&0xf0)|((y>>4)&0x0f))+8;
            spr=pWork[idx+1];
            flpx=(spr>>6)&1;
            flpy=(spr>>6)&2;
            col=pWork[idx+2]&7;
            col=((col>>1)&0x03)|((col<<2)&0x04);
            spr&=0x3f;

            x=pWork[idx+3];
            if(x&&y&&spr)
               sprblit(y,x,spr,col,flpy,flpx);
         }
      }
   }
}

void dispfrogchar(int x,int y,BYTE value,BYTE col)
{
   int x1,y1;
   pBYTE pWork;
   pBYTE pWork2;
   int ymove;
   if(x>scr_x_size-8||y>248)
      return;

   pWork=pScreen+x+(y*scr_x_size);
   ymove=scr_x_size-8;

   pWork2=&Gfx[COL_CHAR+(value<<6)];
   for(y1=0;y1<8;y1++)
   {
      for(x1=0;x1<8;x1++,pWork2++,pWork++)
      {
         if(*pWork2)
            *pWork=*pWork2;
      }
      pWork+=ymove;
   }

}


void frogdecodegfx(pBYTE pIn,int nType)
{
   int idx;
   PRECALC_RETURN
   for (idx=0;idx<0x0800;idx++)
      pIn[idx]=(pIn[idx]&0xfc)|((pIn[idx]&1)<<1)|((pIn[idx]&2)>>1);
}

void frogsetpal(pBYTE pIn)
{
}

void frogclear(void)
{
   int dummy1,dummy2,dummy3,dummy4;

   if(realorient)
   {

      if(FlipScreen)
      {
	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
      "pushw   %%es  \n"

		"movw		%%ax,%%es \n"
      "movl    $512,%%ebx \n"
      "subl    %%ecx,%%ebx \n"
      "cld \n"
      "shrl    $3,%%ecx \n"
//height loop
"1:\n"
      "pushl   %%ecx \n"
      "xorl    %%eax,%%eax \n"
//width loop
      "rep \n"
      "stosl \n"
      "popl    %%ecx \n"
      "pushl   %%ecx \n"
      "movl    $0x21212121,%%eax \n"
      "rep \n"
      "stosl \n"

//move onto next line
      "addl    %%ebx,%%edi \n"
//get width size back and loop
      "popl    %%ecx \n"
      "decl    %%edx \n"
      "jnz     1b \n"

      "popw    %%es \n"

//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=D" (dummy2),
        "=c" (dummy3),
        "=d" (dummy4)
// inputs -
      :"0" (DataSeg),
       "1" (pBoard->pScreen),
       "2" (pBoard->boardScreen[realorient].xsize),
       "3" (pBoard->boardScreen[realorient].ysize)
// registers modified
      :  "bx","cc", "memory"
	);

      }
      else
      {
	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
      "pushw   %%es  \n"

		"movw		%%ax,%%es \n"
      "movl    $512,%%ebx \n"
      "subl    %%ecx,%%ebx \n"
      "cld \n"
      "shrl    $3,%%ecx \n"
//height loop
"1:\n"
      "pushl   %%ecx \n"
//width loop
      "movl    $0x21212121,%%eax \n"
      "rep \n"
      "stosl \n"
      "popl    %%ecx \n"
      "pushl   %%ecx \n"
      "xorl    %%eax,%%eax \n"
      "rep \n"
      "stosl \n"

//move onto next line
      "addl    %%ebx,%%edi \n"
//get width size back and loop
      "popl    %%ecx \n"
      "decl    %%edx \n"
      "jnz     1b \n"

      "popw    %%es \n"

//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=D" (dummy2),
        "=c" (dummy3),
        "=d" (dummy4)
// inputs -
      :"0" (DataSeg),
       "1" (pBoard->pScreen),
       "2" (pBoard->boardScreen[realorient].xsize),
       "3" (pBoard->boardScreen[realorient].ysize)
// registers modified
      :  "bx","cc", "memory"
	);

      }
   }
   else
   {
      if(FlipScreen)
      {
      __asm__ __volatile__
      (
         ".align 4 \n"
//save es and set our selector
         "pushw   %%es  \n"
         "movw    %%ax,%%es \n"
         "movl    $512,%%ebx \n"
         "subl    %%ecx,%%ebx \n"
         "cld \n"
         "shrl    $2,%%ecx \n"
         "xorl    %%eax,%%eax \n"
//height loop
"1:\n"
         "pushl   %%ecx \n"
//width loop
         "rep \n"
         "stosl \n"
//move onto next line
         "addl    %%ebx,%%edi \n"
//get width size back and loop
         "popl    %%ecx \n"
         "cmpl    $129,%%edx \n"
         "jne     2f \n"
         "movl    $0x21212121,%%eax \n"
"2:\n"
         "decl    %%edx \n"
         "jnz     1b \n"

         "popw    %%es \n"

//outputs (clobbered inputs)
         : "=a" (dummy1),
         "=D" (dummy2),
         "=c" (dummy3),
         "=d" (dummy4)
// inputs -
         :"0" (DataSeg),
         "1" (pBoard->pScreen),
         "2" (pBoard->boardScreen[realorient].xsize),
         "3" (pBoard->boardScreen[realorient].ysize)
// registers modified
         :  "bx","cc", "memory"
      );
      }
      else
      {
      __asm__ __volatile__
      (
         ".align 4 \n"
//save es and set our selector
         "pushw   %%es  \n"
         "movw    %%ax,%%es \n"
         "movl    $512,%%ebx \n"
         "subl    %%ecx,%%ebx \n"
         "cld \n"
         "shrl    $2,%%ecx \n"
         "movl    $0x21212121,%%eax \n"
//height loop
"1:\n"
         "pushl   %%ecx \n"
//width loop
         "rep \n"
         "stosl \n"
//move onto next line
         "addl    %%ebx,%%edi \n"
//get width size back and loop
         "popl    %%ecx \n"
         "cmpl    $129,%%edx \n"
         "jne     2f \n"
         "xorl    %%eax,%%eax \n"
"2:\n"
         "decl    %%edx \n"
         "jnz     1b \n"

         "popw    %%es \n"

//outputs (clobbered inputs)
         : "=a" (dummy1),
         "=D" (dummy2),
         "=c" (dummy3),
         "=d" (dummy4)
// inputs -
         :"0" (DataSeg),
         "1" (pBoard->pScreen),
         "2" (pBoard->boardScreen[realorient].xsize),
         "3" (pBoard->boardScreen[realorient].ysize)
// registers modified
         :  "bx","cc", "memory"
      );
      }
   }
}
