#include "main.h"
#include "globals.h"
#include "pacvid.h"
#include "galagvid.h"
#include "galvid.h"
#include "twk.h"
#include "pacvid.h"

#define COL_TRIM  0x0f

static int custnmi;
static int custmode;
static BYTE custcmd;
static int nocredits;
static int coins;
static BYTE inten1;
static BYTE inten2;
static BYTE inten3;
static int coincred;
static int credcoin;
extern int starsblink;

void initgalaga(void)
{
   struct MemoryWriteByte mwb;
   precalcstars();
   galagahaltw(0,0,&mwb);
   StarSpeed=1;
}

void cleargalaga(void)
{
}

void galagapre(void)
{
   *((short int *)(pBaseCode[CurrentCPU]+THING+1))=*((short int *)&pCode[THING+1]);
}

void galagapost(void)
{
   *((short int *)&pCode[THING+1])=*((short int *)(pBaseCode[CurrentCPU]+THING+1));
}



void galaginten1(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   inten1=value&1;
}

void galaginten2(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   inten2=value&1;
}

void galaginten3(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   inten3=!(value&1);
}

void galagahaltw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   if((value&1))
   {
      mz80GetContext(&context[CurrentCPU]);
      if(!CPURunning[1])
      {
         mz80SetContext(&context[1]);
         mz80reset();
         mz80GetContext(&context[1]);
      }
      if(!CPURunning[2])
      {
         mz80SetContext(&context[2]);
         mz80reset();
         mz80GetContext(&context[2]);
      }

      mz80SetContext(&context[CurrentCPU]);

      CPURunning[1]=1;
      CPURunning[2]=1;
   }
   else if (!value)
   {
      CPURunning[1]=0;
      CPURunning[2]=0;
   }
}


UINT8 galagadswr(UINT32 offset, struct MemoryReadByte *mrb)
{
   int bit0,bit1;
   int work;

   int d1=dip1(offset,mrb);
   int d2=dip2(offset,mrb);

   work=offset-mrb->lowAddr;

   bit0 = (d1 >> work) & 1;
   bit1 = (d2 >> work) & 1;



	return bit0 | (bit1 << 1);
}


void galagasharew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   WRITE_MEM
}

UINT8 galagasharer(UINT32 offset, struct MemoryReadByte *mrb)
{
   return pCode[offset];
}

UINT8 galagacustcmdr(UINT32 offset, struct MemoryReadByte *mrb)
{
   return custcmd;
}

UINT8 galagacustr(UINT32 offset, struct MemoryReadByte *mrb)
{

   if(custcmd==0x71||custcmd==0xb1)
   {
      switch(offset)
      {
         case 0x7000:
            if(custmode==SWITCH_MODE)
               return pCode[0x10002];
            else
            {

               if((pCode[0x10002]&0x10)!=0x10)
               {
                  coins++;
                  if(coins>=coincred)
                  {
                     coins=0;
                     nocredits++;
                  }
               }

               if(!(pCode[0x10002]&0x04)&&nocredits>0)
                  nocredits--;
               if(!(pCode[0x10002]&0x08)&&nocredits>1)
                  nocredits-=2;
            }
            return BCD(nocredits);

         case 0x7001:
            return pCode[0x10000];  //pl1
         case 0x7002:
            return pCode[0x10001];  //pl2
      }
	}

   return 0xff;
}


void galagacustcmdw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   custcmd=value;

   custnmi=1;


   switch (value)
	{
		case 0x10:
         custnmi=0;
         break;
      case 0xa1:
         custmode=SWITCH_MODE;
			break;
      case 0xe1:
         custmode=NORMAL_MODE;
			break;
	}

}



void galagacustw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   if(custcmd==0xe1&&offset==0x7007)
   {
      coincred=pCode[0x7001];
      credcoin=pCode[0x7002];
   }

   if(custcmd==0xa8&&value==0x20)
   {

      playsample(3,3,ONE_SHOT,DEFAULT_FREQ);
      setvol(3,15);
   }
}



void galagaint(void)
{
   static int trip=0;
   static int count;

   trip++;
   if(trip==GALAGA_NMI_SLICE)
   {
      if(inten1)
         mz80int(0xff);
      trip=0;
   }
   else
   {
      if(custnmi)
      {
         mz80ClearPendingInterrupt();
         mz80nmi();
      }
   }
}

void galagaint2(void)
{
   if(inten2)
      mz80int(0xff);
}

void galagaint3(void)
{
   if(inten3)
      mz80nmi();
}


void galagaupdatescreen(void)
{
   int y,x,prey1,prey2,prey3;
   int code,color,flipx,flipy,sx,sy;
   int x1,idx;
   pBYTE pWork1;
   pBYTE pWork2;
   pBYTE pWork3;
   pBYTE pWork4;

   clearstars();

   if(realorient)
   {
      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey1=y<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
               dispchar(280-((x+2)<<3),248-prey1,pCode[0x8000+x+prey2]&127,pCode[0x8400+x+prey2]&COL_TRIM);
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            for(x=2;x<30;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar((35-y)<<3,248-(x<<3),pCode[0x8000+x+prey1]&127,pCode[0x8400+x+prey1]&COL_TRIM);
               dispchar((1-y)<<3,248-(x<<3),pCode[0x8000+x+prey2]&127,pCode[0x8400+x+prey2]&COL_TRIM);
            }
         }

         if(ror)
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = !(pCode[0x9b80+idx] & 1);
                  flipy = !(pCode[0x9b80+idx] & 2);
                  sx = 312-(pCode[0x9381+idx] + ((pCode[0x9b81+idx] & 1)<<8));
                  sy = pCode[0x9380+idx];

                  if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                  {
                     sprblit(sx-16,sy+16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx-16,sy,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy+16,(code)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&8)
                  {
                     sprblit(sx,sy+16,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&4)
                  {
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else
                  {
                     sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = !(pCode[0x9b80+idx] & 1);
                  flipy = !(pCode[0x9b80+idx] & 2);
                  sx = pCode[0x9381+idx] - 40 + ((pCode[0x9b81+idx] & 1)<<8);
                  sy = 240-pCode[0x9380+idx];

                  if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                  {
                     sprblit(sx,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy-16,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,(code)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy-16,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&8)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy-16,code&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&4)
                  {
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else
                  {
                     sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                  }
               }
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey1=y<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               dispchar((x+2)<<3,prey1,pCode[0x8000+x+prey2]&127,pCode[0x8400+x+prey2]&COL_TRIM);
            }
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               dispchar(y<<3,x<<3,pCode[0x8000+x+prey1]&127,pCode[0x8400+x+prey1]&COL_TRIM);
               dispchar((y+34)<<3,x<<3,pCode[0x8000+x+prey2]&127,pCode[0x8400+x+prey2]&COL_TRIM);
            }
         }
         if(ror)
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = pCode[0x9b80+idx] & 1;
                  flipy = pCode[0x9b80+idx] & 2;

                  sx = 312-(pCode[0x9381+idx] + ((pCode[0x9b81+idx] & 1)<<8));
                  sy = pCode[0x9380+idx];

                  if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                  {
                     sprblit(sx,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy+16,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx-16,sy,(code)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx-16,sy+16,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&8)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy+16,code&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&4)
                  {
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx-16,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else
                  {
                     sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = pCode[0x9b80+idx] & 1;
                  flipy = pCode[0x9b80+idx] & 2;
                  sx = pCode[0x9381+idx] - 40 + ((pCode[0x9b81+idx] & 1)<<8);
                  sy = 240-pCode[0x9380+idx];
                  if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy-16,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy-16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&8)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy-16,code&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&4)
                  {
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else
                  {
                     sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                  }
               }
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey1=255-(y<<3);
            prey2=y<<5;
            prey3=(31-y);
            pWork1=&pCode[0x8000+prey2];
            pWork2=&pCode[0x8400+prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar(262-prey1,280-((x+2)<<3),*pWork1&127,*pWork2&COL_TRIM);

         }

         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            pWork1=&pCode[0x8000+prey1];
            pWork2=&pCode[0x8400+prey1];
            pWork3=&pCode[0x8000+prey2];
            pWork4=&pCode[0x8400+prey2];

            for(x=0;x<30;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar((x<<3)+7,(35-y)<<3,*pWork1&127,*pWork2&COL_TRIM);
               dispchar((x<<3)+7,(1-y)<<3,*pWork3&127,*pWork4&COL_TRIM);
            }
         }

         if(flipxy)
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = !(pCode[0x9b80+idx] & 2);
                  flipy = !(pCode[0x9b80+idx] & 1);
                  sy = 274-(pCode[0x9381+idx] - 40 + ((pCode[0x9b81+idx] & 1)<<8));
                  sx = 248-pCode[0x9380+idx];

                  if(sy>15&&sy<288)
                  {
                     if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                     {
                        sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx-16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx,sy-16,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx-16,sy-16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else if (pCode[0x9b80+idx]&8)
                     {
                        sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx-16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else if (pCode[0x9b80+idx]&4)
                     {
                        sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx,sy-16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else
                     {
                        sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<128;idx+=2)
            {
               if(!(pCode[0x9b81+idx]&2))
               {
                  code = pCode[0x8b80+idx];
                  color = pCode[0x8b81+idx];
                  flipx = !(pCode[0x9b80+idx] & 2);
                  flipy = !(pCode[0x9b80+idx] & 1);
                  sy = (pCode[0x9381+idx] - 40 + ((pCode[0x9b81+idx] & 1)<<8))+8;
                  sx = pCode[0x9380+idx]+7;
                  if(sy>15&&sy<288)
                  {
                     if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                     {
                        sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx+16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx,sy+16,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx+16,sy+16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else if (pCode[0x9b80+idx]&8)
                     {
                        sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx+16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else if (pCode[0x9b80+idx]&4)
                     {
                        sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                        sprblit(sx,sy+16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                     }
                     else
                     {
                        sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                     }
                  }
               }
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey1=255-(y<<3);
            prey2=y<<5;
            prey3=(31-y);
            pWork1=&pCode[0x8000+prey2];
            pWork2=&pCode[0x8400+prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar(prey1,((x+2)<<3),*pWork1&127,*pWork2&COL_TRIM);

         }

         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            prey3=y<<3;
            pWork1=&pCode[0x8000+prey1];
            pWork2=&pCode[0x8400+prey1];
            pWork3=&pCode[0x8000+prey2];
            pWork4=&pCode[0x8400+prey2];

            for(x=0;x<30;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar(255-(x<<3),prey3,*pWork1&127,*pWork2&COL_TRIM);
               dispchar(255-(x<<3),(y+34)<<3,*pWork3&127,*pWork4&COL_TRIM);
            }
         }

         for(idx=0;idx<128;idx+=2)
         {
            if(!(pCode[0x9b81+idx]&2))
            {
               code = pCode[0x8b80+idx];
               color = pCode[0x8b81+idx];
               flipx = pCode[0x9b80+idx] & 2;
               flipy = pCode[0x9b80+idx] & 1;
               sy = pCode[0x9381+idx] - 40 + ((pCode[0x9b81+idx] & 1)<<8);
               sx = pCode[0x9380+idx]+7;
               if(sy>15&&sy<288)
               {
                  if ((pCode[0x9b80+idx]&0x0c)==0x0c)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy+16,(code+3)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy+16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&8)
                  {
                     sprblit(sx,sy,(code+2)&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx+16,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else if (pCode[0x9b80+idx]&4)
                  {
                     sprblit(sx,sy,code&0x7f,color&COL_TRIM,flipx,flipy);
                     sprblit(sx,sy+16,(code+1)&0x7f,color&COL_TRIM,flipx,flipy);
                  }
                  else
                  {
                     sprblit(sx,sy,code&127,color&COL_TRIM,flipx,flipy);
                  }
               }
            }
         }
      }
   }

   if(pCode[0xa005])
      drawstars(TRUE,FALSE);

}

void galagasetpal(pBYTE pIn)
{
   int i;
   BYTE pal[32][3];
   for (i = 0;i < 32;i++)
	{
		int bit0,bit1,bit2;

      outportb(0x3c8,i);
      bit0 = (pIn[31-i] >> 0) & 0x01;
      bit1 = (pIn[31-i] >> 1) & 0x01;
      bit2 = (pIn[31-i] >> 2) & 0x01;

      outportb(0x3c9,(0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);
      pal[i][0]=((0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);

      bit0 = (pIn[31-i] >> 3) & 0x01;
      bit1 = (pIn[31-i] >> 4) & 0x01;
      bit2 = (pIn[31-i] >> 5) & 0x01;
      outportb(0x3c9,(0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);
      pal[i][1]=((0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);
		bit0 = 0;
      bit1 = (pIn[31-i] >> 6) & 0x01;
      bit2 = (pIn[31-i] >> 7) & 0x01;
      outportb(0x3c9,(0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);
      pal[i][2]=((0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2)>>2);
	}
   pIn+=32;
   for(i=0;i<128;i++)
      collookups[0][i]=(15-(*(pIn++)&0x0f));

   pIn+=128;
   for(i=0;i<128;i++)
	{
      collookups[1][i]=15-(*(pIn++)&0x0f)+0x10;
      if(!pal[collookups[1][i]][0]&&
            !pal[collookups[1][i]][1]&&
            !pal[collookups[1][i]][2])
      {
         collookups[1][i]=transcol;
      }
	}
}


