#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include "boards.h"


//segments
extern short CodeSeg;
extern short DataSeg;
extern short DosDataSeg;
//code being emulated
extern pBYTE pCode;
extern pBYTE pBaseCode[3];
extern pBYTE pSoundData[3];
extern int baseoffset;
//screen
extern pBYTE pScreen;
extern int scr_x_size;
extern int scr_y_size;
extern BYTE genpal[32];
extern BYTE bigpal[1024*3];
extern int realorient;
extern int rol;
extern int ror;
extern int flipxy;
extern int scanlines;
extern int scrollingpos;
extern int VESAAvail;
extern int UsingVESA;
extern int VESADouble;
extern int VESAx;
extern int VESAy;
extern int VertScan;

//log
extern FILE *fLogFile;
extern int logging;

//blit stuff
extern pBYTE pCharMem;
extern pBYTE pAttrMem;
extern int blnkchar;
extern int maxchar;
extern int startchar;
extern int colmask;
extern int bankchar;
extern int pacdirty[36*32];
extern int gendirty[48][48];
extern int jrdirty[32*64];
extern int jrdirty2[32*4];
extern int transcol;
extern int background;
extern int FlipScreen;
extern int noflip;
extern int staroff;
extern int sdirt0;
extern int sdirt1;
extern int sdirt2;
extern int sdirt3;
extern int dyoff;
extern int frameskip;

//context(cpus)
extern CONTEXTMZ80 context[3];
extern int CPURunning[3];
extern int CurrentCPU;
extern long TotalCycles[3];
extern long CyclesPerFrame[3];
extern long CyclesThisFrame[3];


//board being run
extern pBOARD pBoard;
extern int  BoardIdx;
//sound
extern CHANNEL channel[NO_CHANNELS];
extern int actsamples;
extern int sampperframe;
//input
extern int record;
extern int playback;
extern BYTE scancodes[NO_OF_KEYS];
extern BYTE defcodes[NO_OF_KEYS];
extern char *keynames[NO_OF_KEYS];
extern int keycodebase;

//ui
extern int uiactive;
extern int paused;
extern int syspaused;
extern BYTE uikeys[NO_OF_KEYS];
extern int escpressed;
extern int throttle;
//joystick/keyboard
extern int joytype;
extern int GameHasSetKeys;
extern int GameHasSetJoy;

//screen
extern int centerx;
extern int centery;
extern int ShowFPS;
extern int StarSpeed;

//sound
extern int soundcard;
extern int samplerate;
extern int sampleidx;
// sprite mod routine
extern void (*sprmodify)(int *sprtomod);
//base code
extern pBYTE z80Base;
#endif
