#ifndef _JRPAC_BRD_H_
#define _JRPAC_BRD_H_

ROMSTRUCT jrpaccode[]=
{
   {"jrp8d.bin",0x0000,0x2000,0x0000},
   {"jrp8e.bin",0x2000,0x2000,0x0000},
   {"jrp8h.bin",0x8000,0x2000,0x0000},
   {"jrp8j.bin",0xa000,0x2000,0x0000},
   {"jrp8k.bin",0xc000,0x2000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT jrpacgfx[]=
{
   {"jrp2c.bin",0x0000,0x2000,0x0000},
   {"jrp2e.bin",0x2000,0x2000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT jrpaccol[]=
{
   {"jrprom.9e",0x0000,0x0020,0x0000},
   {"jrprom.9f",0x0020,0x0020,0x0000},
   {"jrprom.9p",0x0040,0x0100,0x0000},
   {"",0,0,0}
};

ROMSTRUCT jrpacsound[]=
{
   {"jrprom.7p",0x0000,0x0100,0x0000},
   {"jrprom.5s",0x0100,0x0100,0x0000},
   {"",0,0,0}
};



INPUTS jrpacinputs[]=
{
   {K_PL1_UP,0x5000,0x01,0,0},
   {K_PL1_LEFT,0x5000,0x02,0,0},
   {K_PL1_RIGHT,0x5000,0x04,0,0},
   {K_PL1_DOWN,0x5000,0x08,0,0},
   {K_COIN1,0x5000,0x20,0,0},
   {K_COIN2,0x5000,0x40,0,0},
   {K_COIN3,0x5000,0x80,0,0},

   {K_PL2_UP,0x5040,0x01,0,0},
   {K_PL2_LEFT,0x5040,0x02,0,0},
   {K_PL2_RIGHT,0x5040,0x04,0,0},
   {K_PL2_DOWN,0x5040,0x08,0,0},
   {K_PL1_START,0x5040,0x20,0,0},
   {K_PL2_START,0x5040,0x40,0,0},

   {-1,-1,0,0,0}
};



//layout of chars
SPRLAYOUT jrpacclayout={1,512,2,{0,4},
   {67,66,65,64,3,2,1,0},
   {0,1,2,3,4,5,6,7},16};

//layout of sprites
SPRLAYOUT jrpacslayout={1,128,2,{0,4},
   {67,66,65,64,131,130,129,128,195,194,193,192,3,2,1,0},
   {0,1,2,3,4,5,6,7,32,33,34,35,36,37,38,39},64};

GFXDETAILS jrpacgfxs[]=
{
   {0,0,8,8,&jrpacclayout,-1,TYPE_CHAR},
   {0x2000,0,16,16,&jrpacslayout,-1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};

#define JRPACDIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_RACK,0x10,0, \
            { \
               {DIP_OFF,0,0x10},{DIP_ON,0,0} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_SERVICE,0x10,0, \
            { \
               {DIP_OFF,0,0x10},{DIP_ON,0,0} \
            } \
         }, \
         {DIP_CABINET,0x80,0, \
            { \
               {DIP_UPRIGHT,0,0x80},{DIP_COCKTAIL,0,0} \
            } \
         } \
      } \
   }, \
   {3,0,0x80,0,0, \
      { \
         {DIP_CREDIT,1,0, \
            { \
               {DIP_FREE,0,0},{DIP_1C_1C,0,1},{DIP_1C_2C,0,2},{DIP_2C_1C,0,3} \
            } \
         }, \
         {DIP_LIVES,8,0, \
            { \
               {"1",0,0},{"2",0,4},{"3",0,8},{"5",0,0x0c} \
            } \
         }, \
         {DIP_BONUS,0,0, \
            { \
               {"10000",0,0},{"15000",0,0x10},{"20000",0,0x20},{"30000",0,0x30} \
            } \
         }, \
         {DIP_DIFFICULTY,0x40,0, \
            { \
               {DIP_NORMAL,0,0x40},{DIP_HARD,0,0} \
            } \
         } \
      } \
   }, \
   {4,0,0,0,0, \
      { \
         {"Speed Up",0,0, \
            { \
               {DIP_ON,0,1},{DIP_OFF,0,0} \
            } \
         } \
      } \
   } \
   }


#endif
