#include	"main.h"
#include "nkeys.h"
#include "key_lc.h"
#include	"keyasm.h"
#include "globals.h"
#include "control.h"
#include  <sys/segments.h>


#define MAX_KEYS  256

__dpmi_paddr old_vector;
void _akey_handler(void);
void _akey_handler_end(void);
BYTE scancodes[NO_OF_KEYS];
BYTE defcodes[NO_OF_KEYS];
BYTE lowkeys[NO_OF_KEYS+1];
BYTE uikeys[NO_OF_KEYS];
BYTE pulses[MAX_KEYS];
BYTE ptrip[MAX_KEYS];
BYTE activekey[NO_OF_KEYS];
BYTE pforce[MAX_KEYS];


char *keynames[NO_OF_KEYS];


pINPUTS pInputs;

BYTE KeyPressed;


void replace(void)
{
	__dpmi_paddr addr;
//lock the new handler
	_go32_dpmi_lock_code((void *)_akey_handler,(long)_akey_handler_end-(long)_akey_handler);
//get the old vector
	__dpmi_get_protected_mode_interrupt_vector(9,&old_vector);
//then set the new one
   addr.selector = CodeSeg;
	addr.offset32 = (long)_akey_handler;
	__dpmi_set_protected_mode_interrupt_vector(9,&addr);

}

void putback(void)
{

//set the old one back
	__dpmi_set_protected_mode_interrupt_vector(9,&old_vector);

}

void initkey(pINPUTS pIn)
{
   pInputs=pIn;
   memset(lowkeys,0,NO_OF_KEYS+1);
   memset(pulses,0,MAX_KEYS);
   memset(ptrip,0,MAX_KEYS);
   KeyPressed=0;
}

void mutalexlude(pBYTE pInKeys)
{
   int i;
   for(i=0;i<4;i++)
   {
      if(pInKeys[mutekeys[i].key1]==128&&pInKeys[mutekeys[i].key2]==128)
         pInKeys[mutekeys[i].key1]=0;
   }
}

void readkeys(pBYTE pInKeys)
{
   int n;
   static BYTE autorep[NO_OF_KEYS];
   static BYTE autorep2[NO_OF_KEYS];
   static BYTE typeamatic[NO_OF_KEYS];
   static BYTE typea[NO_OF_KEYS];
   int pulsed;


   if(!playback)
      escpressed=0;
//non-auto repeating escape
   if(pInKeys[K_ESCAPE])
   {
      if(!autorep[K_ESCAPE])
      {
         escpressed=1;
         autorep[K_ESCAPE]=1;
      }
   }
   else
      autorep[K_ESCAPE]=0;



   n=0;
   if(pBoard->mutex)
      mutalexlude(pInKeys);
//handle in game inputs
   while(pInputs[n].idx!=-1)
   {
//handle pulsed inputs
      activekey[n]=pInputs[n].active;

      pulsed=(pInputs[n].pulse&&pInputs[n].pulse!=KEY_ON_ONLY&&pInputs[n].pulse!=KEY_OFF_ONLY);

      if(pInputs[n].active==128)
      {
         if(pInKeys[pInputs[n].idx]==pInputs[n].active&&pulsed)
         {
            if(pulses[n])
               activekey[n]=!pInputs[n].active;
            else
            {
               ptrip[n]+=1;
               if(ptrip[n]>=pInputs[n].pulse)
               {
                  ptrip[n]=0;
                  pulses[n]=1;
               }
               activekey[n]=pInputs[n].active;
            }
         }
         else
         {
            ptrip[n]=0;
            pulses[n]=0;
         }
      }
      else
      {
         if((pInKeys[pInputs[n].idx]!=pInputs[n].active||pforce[n])&&pulsed)
         {
            if(pInputs[n].pulse>8&&!pforce[n])
               pforce[n]=pInputs[n].pulse;

            if(pulses[n])
            {
               activekey[n]=128;
            }
            else
            {
               ptrip[n]+=1;
               if(ptrip[n]>=pInputs[n].pulse)
               {
                  ptrip[n]=0;
                  pulses[n]=1;
               }
               activekey[n]=pInputs[n].active;
               if(pforce[n])
                  activekey[n]=!pInKeys[pInputs[n].idx];
            }
         }
         else
         {
            ptrip[n]=0;
            pulses[n]=0;
         }
         if(pforce[n])
            pforce[n]--;

      }



      if(pInKeys[pInputs[n].idx]==activekey[n])
      {
         if(pInputs[n].pulse!=KEY_OFF_ONLY)
            pBaseCode[keycodebase][pInputs[n].offset]|=pInputs[n].value;
      }
      else
      {
         if(pInputs[n].pulse!=KEY_ON_ONLY)
            pBaseCode[keycodebase][pInputs[n].offset]&=~pInputs[n].value;
      }

      n++;
   }

//handle ui keys
   for(n=0;n<NO_UI_KEYS;n++)
   {
      if(pInKeys[uiids[n]])
      {
         if(!autorep2[uiids[n]])
         {
            autorep2[uiids[n]]=1;
            uikeys[uiids[n]]=1;
         }
         else
         {
            if(typeamatic[uiids[n]]>TYPEAMATIC_DELAY)
            {
               typea[uiids[n]]+=1;
               if(typea[uiids[n]]>TYPEAMATIC_RATE)
               {
                  uikeys[uiids[n]]=1;
                  typea[uiids[n]]=0;
               }
               typeamatic[uiids[n]]=32;
            }
            else
            {
               typeamatic[uiids[n]]+=1;
               uikeys[uiids[n]]=0;
            }
         }
      }
      else
      {
         autorep2[uiids[n]]=0;
         uikeys[uiids[n]]=0;
         typeamatic[uiids[n]]=0;
         typea[uiids[n]]=0;

      }
   }
}

void getcfgcodes(void)
{
   int n,i;
   FILE *fKeys;
   static char buffer[256];
//set to default
	for(n=0;n<NO_OF_KEYS;n++)
   {
      scancodes[n]=sdef[n].nDefault;
      defcodes[n]=sdef[n].nDefault;
      keynames[n]=sdef[n].szIdent;
   }
//try to open up default keyboard file
   fKeys=fopen("keys\\default.key","rb");
   if(fKeys)
   {
      fread(scancodes,1,NO_OF_KEYS,fKeys);
      memcpy(defcodes,scancodes,NO_OF_KEYS);
      fclose(fKeys);
   }
//then get keys for this game
   sprintf(buffer,"keys\\%s.key",pBoard->name);
   fKeys=fopen(buffer,"rb");
   if(fKeys)
   {
      fread(scancodes,1,NO_OF_KEYS,fKeys);
      fclose(fKeys);
      GameHasSetKeys=TRUE;
   }
   getdefjoy();
}


//save default key settings
void savedefkeys(void)
{
   FILE *fDefKeys;
   fDefKeys=fopen("keys\\default.key","wb");
   if(fDefKeys)
   {
      fwrite(defcodes,1,NO_OF_KEYS,fDefKeys);
      fclose(fDefKeys);
   }
   savedefjoy();
}
//save key settings for this game
void savegamekeys(void)
{
   FILE *fGameKeys;
   char buffer[256];

   if(GameHasSetKeys)
   {
      sprintf(buffer,"keys\\%s.key",pBoard->name);
      fGameKeys=fopen(buffer,"wb");
      if(fGameKeys)
      {
         fwrite(scancodes,1,NO_OF_KEYS,fGameKeys);
         fclose(fGameKeys);
      }
   }
   savegamejoy();
}

char *scantoname(int scan)
{
   if(scan<89)
      return scannames[scan];
   else
      return scannames[0];
}

