#ifndef _KEY_H_
#define _KEY_H_

//player 1 keys
#define K_PL1_UP     0
#define K_PL1_DOWN   1
#define K_PL1_LEFT   2
#define K_PL1_RIGHT  3
#define K_PL1_B1     4
#define K_PL1_B2     5
#define K_PL1_B3     6
#define K_PL1_START  7
//player 2 keys
#define K_PL2_UP     8
#define K_PL2_DOWN   9
#define K_PL2_LEFT   10
#define K_PL2_RIGHT  11
#define K_PL2_B1     12
#define K_PL2_B2     13
#define K_PL2_B3     14
#define K_PL2_START  15
//coins
#define K_COIN1      16
#define K_COIN2      17
#define K_COIN3      18
//general
#define K_ESCAPE     19
#define K_PAUSE      20
#define K_UI         21
#define K_UI_UP      22
#define K_UI_DOWN    23
#define K_UI_LEFT    24
#define K_UI_RIGHT   25
#define K_UI_SELECT  26
#define K_RESET      27
#define K_THROTTLE   28
#define K_SCREENSHOT 29
#define K_FPS        30
#define K_FRAMESKIP  31

#define K_NO_MATCH   32 //key is never matched, allows forced high/low states of bits in input


#define KEY_ON_ONLY  -99   //used for keys sharing the same bit
#define KEY_OFF_ONLY -98


typedef struct
{
	char	szIdent[16];
	int	nDefault;
} SCANCODE;

typedef SCANCODE * pSCANCODE;

typedef struct inputsTAG
{
   int idx;
   int offset;
   BYTE value;
	int active;
   int pulse;
} INPUTS;

typedef INPUTS * pINPUTS;


void replace(void);
void putback(void);
void initkey(pINPUTS pIn);
void readkeys(pBYTE pInKeys);
void getcfgcodes(void);
char *scantoname(int scan);
void savedefkeys(void);
void savegamekeys(void);

#endif
