#ifndef _KEY_LC_H
#define _KEY_LC_H

#define TYPEAMATIC_DELAY   32
#define TYPEAMATIC_RATE    2



typedef struct mutekeysTAG
{
   int key1;
   int key2;
} MUTEKEYS;

typedef MUTEKEYS *pMUTEKEYS;
//scancode to key conversion
static char scannames[][8]=
{
   "",
   "Esc","1","2","3","4","5","6","7","8","9","0","-","=","BkSpc",
   "Tab","Q","W","E","R","T","Y","U","I","O","P","[","]","Return",
   "Ctrl","A","S","D","F","G","H","J","K","L",";","'","`","LShift","#",
   "Z","X","C","V","B","N","M",",",".","/","RShift","*",
   "Alt","Space","CapsLk",
   "F1","F2","F3","F4","F5","F6","F7","F8","F9","F10",
   "NumLk","ScrLk",
   "Home","Up","PgUp","-",
   "Left","5","Right","+",
   "End","Down","PgDn","Ins","Del",
   "","","",
   "F11","F12"
};


//default key scancode values
static SCANCODE sdef[NO_OF_KEYS]=
{
   {"P1 Up",72},
   {"P1 Down",80},
   {"P1 Left",75},
   {"P1 Right",77},
   {"P1 Butt1",29},
   {"P1 Butt2",56},
   {"P1 Butt3",57},
   {"P1 Start",2},
   {"P2 Up",19},
   {"P2 Down",33},
   {"P2 Left",32},
   {"P2 Right",34},
   {"P2 Butt1",30},
   {"P2 Butt2",31},
   {"P2 Butt3",16},
   {"P2 Start",3},
   {"Coin 1",6},
   {"Coin 2",7},
   {"Coin 3",8},
   {"Exit",1},
   {"Pause",25},
   {"UI",15},
   {"UI Up",72},
   {"UI Down",80},
   {"UI Left",75},
   {"UI Right",77},
   {"UI Select",28},
   {"Reset",61},
   {"Throttle",68},
   {"ScreenShot",88},
   {"FPS",87},
   {"FrameSkip",67}
};
//ui keys
int uiids[NO_UI_KEYS]=
{
   K_ESCAPE,K_PAUSE,K_UI,K_UI_UP,K_UI_DOWN,
   K_UI_LEFT,K_UI_RIGHT,K_UI_SELECT,K_RESET,
   K_THROTTLE,K_SCREENSHOT,K_FPS,K_FRAMESKIP
};

//mutex keys
static MUTEKEYS mutekeys[4]=
{
   {K_PL1_LEFT,K_PL1_RIGHT},
   {K_PL1_UP,K_PL1_DOWN},
   {K_PL2_LEFT,K_PL2_RIGHT},
   {K_PL2_UP,K_PL2_DOWN}
};

#endif
