#include "main.h"
#include "twk.h"
#include "boards.h"
#include "nkeys.h"
#include "control.h"
#include "invvid.h"
#include "fskip.h"

int VESAx;
int VESAy;

int VertScan=FALSE;
int VESADouble=FALSE;
int dirtyups;
int ShowFPS;
short CodeSeg;
short DataSeg;
short DosDataSeg;
extern int scr_x_size;
extern int scr_y_size;
int escpressed=0;
int staroff=0;
int BoardIdx=0;
int realorient=0;
int rol=0;
int ror=0;
int flipxy;
int scanlines=0;
int throttle=1;
int record=0;
int playback=0;
int logging=0;
int noflip=0;
int FlipScreen=0;
int arcade=0;
int GameHasSetKeys=FALSE;
int GameHasSetJoy=FALSE;

int soundcard=0;
int samplerate=22050;
int sampleidx=SAMPLE_22050;
int frameskip=0;

int VESAAvail;
int UsingVESA=1;
int baseoffset=0;

FILE *fLogFile;
int joytype=0;
int centerx=0;
int centery=0;
int vsync=0;
int scrolling=0;
int scale=0;
int crop=0;
int StarSpeed=0;

pBYTE pCode;
pBYTE pBaseCode[3];
pBYTE pSoundData[3];
pBYTE Gfx;
pBYTE Mask;
pBYTE FlipGfx;
pBYTE FlipMask;
pBYTE Sprites;
pBYTE BigSprites;

pBYTE Tiles;

pBYTE pScreen;
pBOARD pBoard;
CONTEXTMZ80 context[3];
int CPURunning[3];
int CurrentCPU=0;
long TotalCycles[3];
long CyclesPerFrame[3];
long CyclesThisFrame[3];

int keycodebase;

extern BYTE lowkeys[NO_OF_KEYS+1];
BYTE filekeys[NO_OF_KEYS+1];

int uiactive;
int paused;
int syspaused;

int pacdirty[36*32];

char rompath[512];
char samplepath[512];
char snappath[512];

FILE *frecord;
FILE *fplayback;
int upd=TRUE;
int precalculate=FALSE;
void sndtest(void);
int main(int argc,char **argv)
{
   int finished=FALSE;
   int countno[3];
   int baseno[3];
   int noints[3];
   int vcount=0;
   int NoCPUs=0;
   int idx,interleave;
   long scraddr;
   char cWork[512];
   int startfps=0;
   int startfpscnt=0;
   int startrip=0;
   int lastframe=0;
   int osfps=0;
   int savecnt;
   int skipidx=0;



   UINT32 diff,dwResult,prior,frames,lastSec;
   UINT32 mz80clockticks=0;
   pBYTE pTemp;

   pBYTE pWork;
   pBYTE pWork2;
   int x,y,index,slcs,i,cpu;
   double fps=0.0;
   uclock_t tick1;
   uclock_t tick2;
   uclock_t tick3;
   uclock_t tick4;
   uclock_t tick5;
   uclock_t tick6;
   uclock_t tick7;
   uclock_t genclock;

   int cpufin[3];
   int cpucnt[3];
   int cpubase[3];

   static int step=0;

   int vmode;
//def paths
   strcpy(rompath,"roms");
   strcpy(samplepath,"sounds");
   strcpy(snappath,"snapshot");

   uiactive=paused=syspaused=0;

//get the segments
   CodeSeg=_my_cs();
   DataSeg=_my_ds();
   DosDataSeg=_dos_ds;


   memset(context,0,sizeof(CONTEXTMZ80)*3);

   pScreen=calloc(0x40000,1);
   if(!pScreen)
   {
      printf("Unable to allocate screen memory\n");
      return 1;
   }
   pTemp=myalloc(0xb0000);
   if(!pTemp)
   {
      printf("Unable to allocate temporary GFX workspace\n");
      return 1;
   }


//get defaults from the file
   getfileopts();
//get the game asked for
   pBoard=getboard(argc,argv);
   if(!pBoard)
      return 1;

   VESAAvail=getvesainfo();
   if(!VESAAvail)
   {
      if(UsingVESA)
         loginfo("VESA 2.0 not available - using tweaked VGA modes");
      UsingVESA=FALSE;
   }
   if(arcade)
   {
      if(UsingVESA)
      {
         loginfo("VESA turned off as Arcade monitor mode selected");
         UsingVESA=0;
      }
   }

   if(UsingVESA)
   {
//no point scaling/cropping in SVGA mode
      scale=crop=0;
      loginfo("Attempting to use VESA 2.0 video modes");
   }

//adjust sample rate
   if(samplerate<=11025)
   {
      sampleidx=SAMPLE_11025;
      samplerate=11025;
   }
   else
   {
      if(samplerate<=22050)
      {
         sampleidx=SAMPLE_22050;
         samplerate=22050;
      }
      else
      {
         sampleidx=SAMPLE_44100;
         samplerate=44100;
      }
   }
//adjust frameskip
   if(frameskip<0)
      frameskip=0;
   if(frameskip>=MAX_SKIPS)
      frameskip=MAX_SKIPS-1;

//find the right video mode
   choosetweakmode(pBoard->boardScreen[realorient].mode);


   keycodebase=0;
//check joystick requested exits
   checkcontroller();

//flip for right rotations
   if(ror)
      FlipScreen=1;

   memset(pacdirty,0,sizeof(int)*36*32);


   getcfgcodes();

   initui();

   if(record)
   {
      sprintf(cWork,"io\\%s.io",pBoard->name);
      frecord=fopen(cWork,"wb");
   }
   else
   {
      if(playback)
      {
         sprintf(cWork,"io\\%s.io",pBoard->name);
         fplayback=fopen(cWork,"rb");
      }
   }
//load the font
   if(!loadfont())
   {
      printf("Unable to load VAntAGE's Font\nCheck file VANTAGE.FNT is not present or corrupted\n");
      return 1;
   }

   initgfx();


   initsound(pBoard->streams);


   NoCPUs=pBoard->nocpus;

   interleave=1;
   for(i=0;i<NoCPUs;i++)
   {
      if(!i)
         pBaseCode[i]=calloc(0x30000,1);
      else
         pBaseCode[i]=calloc(0x10000,1);

      if(!pBaseCode[i])
      {
         printf("Unable to allocate space for Code base\n");
         return 1;
      }
      pSoundData[i]=calloc(0x10000,1);
      if(!pSoundData[i])
      {
         printf("Unable to allocate space for Sound data\n");
         return 1;
      }

      context[i].z80Base=pBaseCode[i];
      context[i].z80MemRead=pBoard->boardIO[i].memread;
      context[i].z80MemWrite=pBoard->boardIO[i].memwrite;
      context[i].z80IoRead=pBoard->boardIO[i].portread;
      context[i].z80IoWrite=pBoard->boardIO[i].portwrite;

      CyclesPerFrame[i]=pBoard->boardIO[i].baseno;

      baseno[i]=CyclesPerFrame[i]/pBoard->boardIO[i].noints;
      noints[i]=pBoard->boardIO[i].noints;
      countno[i]=baseno[i];

   }
   pCode=pBaseCode[0];

//load in the roms
   for(i=0;i<NoCPUs;i++)
   {
      if(!loadroms(pBoard->basename,pBoard->boardROM[i].coderoms,pBaseCode[i]))
         return 1;
      if(pBoard->boardROM[i].gfxroms)
         if(!loadroms(pBoard->basename,pBoard->boardROM[i].gfxroms,pTemp))
            return 1;
      if(pBoard->boardROM[i].palroms)
         if(!loadroms(pBoard->basename,pBoard->boardROM[i].palroms,pBoard->pal))
            return 1;
      if(pBoard->boardROM[i].soundroms)
         if(!loadroms(pBoard->basename,pBoard->boardROM[i].soundroms,pSoundData[i]))
            return 1;

   }


//set the z80 context(s)
   for(cpu=NoCPUs-1;cpu>=0;cpu--)
   {
      mz80SetContext(&context[cpu]);
      mz80reset();
      mz80GetContext(&context[cpu]);
      CPURunning[cpu]=1;
      TotalCycles[cpu]=0;
   }

//init game
   CALLFUNC(initgame);

//set logical screen address
   pBoard->pScreen=pScreen+pBoard->boardScreen[realorient].xoff+(pBoard->boardScreen[realorient].yoff<<9);
//clip border
   pBoard->pScreen+=(32+(32<<9));
//read in the dip switch settings
   readdip();
   frames=0;

//replace the keyboard handler
   initkey(pBoard->pInputs);
   replace();
//set the video mode
   if(UsingVESA)
   {
      int mmode,xx,yy,xsize,ysize;

      if(getvesamode(&xsize,&ysize,&mmode))
      {
         setvesamode(mmode);
         if(VESADouble||scanlines)
         {
            xx=((xsize-(scr_x_size<<1))>>1)+(pBoard->boardScreen[realorient].xscroff<<1);
            yy=((ysize-(scr_y_size<<1))>>1)+(pBoard->boardScreen[realorient].yscroff<<1);
         }
         else
         {
            xx=((xsize-scr_x_size)>>1)+(pBoard->boardScreen[realorient].xscroff);
            yy=((ysize-scr_y_size)>>1)+(pBoard->boardScreen[realorient].yscroff);
         }

         scraddr=(xx)+(yy*xsize);
         VESAx=xsize;
         VESAy=ysize;
      }
      else
      {
         loginfo("Unable to find suitable VESA mode");
         UsingVESA=FALSE;
         settweakmode();
         scraddr=0xa0000+pBoard->boardScreen[realorient].xscroff+(pBoard->boardScreen[realorient].yscroff*scr_x_size);
      }
   }
   else
   {
      settweakmode();
      scraddr=0xa0000+pBoard->boardScreen[realorient].xscroff+(pBoard->boardScreen[realorient].yscroff*scr_x_size);
   }

//setup the pallete
   pBoard->setpal(pBoard->pal);
   baseuipal();
//decode the graphics
   gendecodegfx(pTemp);

   myfree(pTemp);

   CALLFUNC(initvid);

   CALLFUNC(initsound);

   setupdirty(pBoard->boardScreen[realorient].ysize);

   prior=0;

//load the samples
   if(soundcard)
      loadsamples();

   mz80GetElapsedTicks(TRUE);
   dwResult=0;


   for(idx=0;idx<NoCPUs;idx++)
   {
      if(pBoard->interval<20)
         cpucnt[idx]=(CyclesPerFrame[idx]/pBoard->interval)/noints[idx];
      else
         cpucnt[idx]=pBoard->interval;
      cpubase[idx]=cpucnt[idx];
   }



   tick1=0.0f;

   tick3=uclock();
   tick6=tick3;
   tick7=tick6;

   readkeys(lowkeys);

   dirtyups=pBoard->dirtyupd;

   while(!finished)
	{

      if(!startfps)
      {
         startfpscnt++;
         if(startfpscnt==10)
         {
            tick1=uclock();
            startfps=1;
         }
      }
      if(!syspaused)
      {
         int cnt;
         if(NoCPUs==1)
         {
            CyclesThisFrame[0]=0;
//avoid context swapping for simple case of 1 CPU
            for(slcs=0;slcs<noints[0];slcs++)
            {
               if(pBoard->pre&&pBoard->boardIO[0].inter)
                  pBoard->boardIO[0].inter();

               savecnt=exec(countno[0]);


               TotalCycles[0]+=savecnt;
               CyclesThisFrame[0]+=savecnt;
               countno[0]-=savecnt;
               if(countno[0]<=0)
                  countno[0]+=baseno[0];
               if(!pBoard->pre&&pBoard->boardIO[0].inter)
                  pBoard->boardIO[0].inter();
            }
         }
         else
         {
//interlace the CPUs

            int ix;

            for(idx=0;idx<NoCPUs;idx++)
            {
               CyclesThisFrame[idx]=0;
               cpufin[idx]=noints[idx];
            }


            CurrentCPU=0;
            while(TRUE)
            {
               if(CPURunning[CurrentCPU]&&cpufin[CurrentCPU]>0)
               {
                  CALLFUNC(preswap);
                  mz80SetContext(&context[CurrentCPU]);
                  savecnt=exec(cpucnt[CurrentCPU]);

                  CyclesThisFrame[CurrentCPU]+=savecnt;
                  TotalCycles[CurrentCPU]+=savecnt;

                  countno[CurrentCPU]-=savecnt;
                  cpucnt[CurrentCPU]-=savecnt;
                  if(cpucnt[CurrentCPU]<=0)
                     cpucnt[CurrentCPU]+=cpubase[CurrentCPU];

                  if(countno[CurrentCPU]<=0)
                  {
                     countno[CurrentCPU]+=baseno[CurrentCPU];
                     if(pBoard->boardIO[CurrentCPU].inter)
                        pBoard->boardIO[CurrentCPU].inter();
                     cpufin[CurrentCPU]-=1;
                  }
                  mz80GetContext(&context[CurrentCPU]);
                  CALLFUNC(postswap);
               }

               CurrentCPU++;

               if(CurrentCPU==NoCPUs)
               {

                  int xcnt=0;

                  CurrentCPU=0;
                  for(ix=0;ix<NoCPUs;ix++)
                  {
                     if(!CPURunning[ix]||cpufin[ix]==0)
                        xcnt++;
                     else
                        break;
                  }
                  if(xcnt==NoCPUs)
                     break;
               }
            }
         }
      }
      genclock=uclock();
      if(!throttle)
      {
         upd=FALSE;
         tick4=genclock;
         tick5=tick4-tick3;
         if(tick5>(UCLOCKS_PER_SEC/60L))
         {
            CALLFUNC(updatescreen);
            upd=TRUE;
            tick3=tick4;
         }
      }
      else
      {
         CALLFUNC(updatescreen);
         upd=TRUE;
      }

      if(ShowFPS)
      {
         if((genclock-tick7)>=UCLOCKS_PER_SEC)
         {
            osfps=frames-lastframe;
            lastframe=frames;
            tick7=genclock;
         }
         if(upd)
            showfps(osfps);
      }

      CALLFUNC(soundupdate);
      updatesound();

      handlejoystick();



      if(playback)
      {
         if(lowkeys[K_ESCAPE])
            escpressed=1;
         if(lowkeys[K_THROTTLE])
            throttle=!throttle;
         fread(lowkeys,1,NO_OF_KEYS+1,fplayback);
      }


      readkeys(lowkeys);

      if(record)
         fwrite(lowkeys,1,NO_OF_KEYS+1,frecord);


      if(throttle)
      {
         if(vsync)
         {
            waitsync();
         }
         else
         {
            tick4=genclock;
            tick5=tick4-tick6;
            while(tick5<(UCLOCKS_PER_SEC/60L))
            {
               tick4=uclock();
               tick5=tick4-tick6;
            }
            tick6=tick4;
         }
      }




      CALLFUNC(palupdate);



      uireadkeys();

      if(uiactive)
         uidispmenu();
      else
         finished=escpressed;


      if(upd&&showthisframe[frameskip][skipidx++])
      {
         if(UsingVESA)
         {
            if(pBoard->dirtyblit)
            {
               if(scanlines)
               {
                  if(!realorient&&VertScan)
                     putvesadirtyvertscan(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
                  else
                     putvesadirtyscan(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);

               }
               else
               {
                  if(VESADouble)
                     putvesadirtydbl(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
                  else
                     putvesadirty(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
               }
            }
            else
            {
               if(scanlines)
               {
                  if(!realorient&&VertScan)
                     putvesavertscan(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
                  else
                     putvesascan(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);

               }
               else
               {
                  if(VESADouble)
                     putvesadbl(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
                  else
                     putvesa(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr);
               }
            }
         }
         else
         {
            if(pBoard->dirtyblit)
               putdirty(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr,DosDataSeg);
            else
            {
               if(scale)
                  putscale(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr,DosDataSeg);
               else
                  put(pBoard->pScreen,pBoard->boardScreen[realorient].xsize,pBoard->boardScreen[realorient].ysize,scraddr,DosDataSeg);
            }
         }

      }
      if(skipidx>=MAX_SKIPS)
         skipidx=0;

      frames++;
      if(!ShowFPS)
         lastframe=frames;

      if(!UsingVESA&&vsync&&throttle&&scanlines)
         waitsync2();

      if(!syspaused&&(startrip|StarSpeed))
      {
         staroff++;
         staroff&=511;
      }
      startrip=!startrip;
	}

   if(startfps)
   {
      tick2=uclock();
      fps=(double)frames/(float)((float)(tick2-tick1)/UCLOCKS_PER_SEC);
   }
   else
      fps=0.0F;


   putback();

//free the roms up
   for(i=0;i<NoCPUs;i++)
   {
      myfree(pBaseCode[i]);
      myfree(pSoundData[i]);
   }

   if(record)
      fclose(frecord);
   if(playback)
      fclose(fplayback);

   myfree(pScreen);
   myfree(Gfx);
   myfree(FlipGfx);
   myfree(Sprites);
   myfree(BigSprites);
   myfree(Tiles);
   myfree(Mask);
   myfree(FlipMask);


//shutdown sound system
   clearsound();

//write out the dips
   writedip();
//free the font
   clearfont();

   clearui();
//save the default keyboard set
   savedefkeys();
//save the game keyboard set
   savegamekeys();
//write out the config file
   saveoptions();

//test mode
   setgmode(0x03);
//tidyup VESA
   clearvesa();
//all done
   printf("FPS :%f\n",fps);
   loginfo("FPS :%f\n",fps);

   return 0;
}

void exitptn(void)
{
   fflush(fLogFile);
   fclose(fLogFile);
   fflush(stdout);
}

void unlockdpmidata(void *addr, int size)
{
   unsigned long baseaddr;
   __dpmi_meminfo mem;

   __dpmi_get_segment_base_address(DataSeg,&baseaddr);

   mem.address=baseaddr+(unsigned long)addr;
   mem.size=size;

   __dpmi_unlock_linear_region(&mem);
}

void gendecodegfx(pBYTE pTemp)
{
   char buffer[512];
   FILE *fin;
   int preload=0;
   int col;
   int noallocchars=1024;
   int noallocsprs=512;
   int noallocbig=128;
   int noalloctile=512;

   if(pBoard->nochars>1024)
   {
      noallocchars=pBoard->nochars;
      pBoard->nocharcols=1;
   }

   if(pBoard->nosprites>512)
   {
      noallocsprs=pBoard->nosprites;
      pBoard->nosprcols=1;
   }

   if(pBoard->nobigsprites>128)
   {
      noallocbig=pBoard->nobigsprites;
      pBoard->nobigsprcols=1;
   }

   if(pBoard->notiles>512)
   {
      noalloctile=pBoard->notiles;
      pBoard->notilecols=1;
   }



   FlipGfx=myalloc(pBoard->nocharcols*noallocchars*8*8);
   FlipMask=myalloc(pBoard->nochars*8*8);

//try to load in precalculated graphics
   if(realorient)
      sprintf(buffer,"precalc\\gfx%d.pre",BoardIdx);
   else
      sprintf(buffer,"precalc\\rgfx%d.pre",BoardIdx);

   fin=fopen(buffer,"rb");
   if(fin)
   {
      Gfx=myalloc(pBoard->nocharcols*noallocchars*8*8);
      Mask=myalloc(pBoard->nochars*8*8);
      if(pBoard->nosprites)
         Sprites=myalloc(pBoard->nosprcols*noallocsprs*16*16);
      else
         Sprites=0;
      if(pBoard->nobigsprites)
         BigSprites=myalloc(pBoard->nobigsprcols*noallocbig*32*32);
      else
         BigSprites=0;

      if(pBoard->notiles)
         Tiles=myalloc(pBoard->notilecols*noalloctile*16*16);
      else
         Tiles=0;
      preload=2-realorient;

      for(col=0;col<pBoard->nocharcols;col++)
      {
         fread(&Gfx[COL_CHAR],1,(64*pBoard->nochars),fin);
         fread(&FlipGfx[COL_CHAR],1,(64*pBoard->nochars),fin);
      }
      for(col=0;col<pBoard->nosprcols;col++)
         fread(&Sprites[COL_SPRITE],1,(256*pBoard->nosprites),fin);
      for(col=0;col<pBoard->nobigsprcols;col++)
         fread(&BigSprites[COL_BIG],1,(32*32*pBoard->nobigsprites),fin);
      for(col=0;col<pBoard->notilecols;col++)
         fread(&Tiles[COL_TILE],1,(256*pBoard->notiles),fin);
      fread(Mask,1,(64*pBoard->nochars),fin);
      fread(FlipMask,1,(64*pBoard->nochars),fin);

      fclose(fin);
   }
   else
   {
      Gfx=calloc(pBoard->nocharcols*noallocchars*8*8,1);
      loginfo("Allocated %d chars, %d cols (0x%x)",noallocchars,pBoard->nocharcols,(int)Gfx);
      Mask=myalloc(pBoard->nochars*8*8);
      memset(Mask,255,pBoard->nochars*8*8);
      if(pBoard->nosprites)
      {
         Sprites=calloc(pBoard->nosprcols*noallocsprs*16*16,1);
         loginfo("Allocated %d sprites, %d cols (0x%x)",noallocsprs,pBoard->nosprcols,(int)Sprites);
      }
      else
         Sprites=0;
      if(pBoard->nobigsprites)
      {
         BigSprites=calloc(pBoard->nobigsprcols*noallocbig*32*32,1);
         loginfo("Allocated %d big sprites, %d cols (0x%x)",noallocbig,pBoard->nobigsprcols,(int)BigSprites);
      }
      else
         BigSprites=0;
      if(pBoard->notiles)
      {
         Tiles=calloc(pBoard->notilecols*noalloctile*16*16,1);
         loginfo("Allocated %d tiles, %d cols (0x%x)",noalloctile,pBoard->notilecols,(int)Tiles);
      }
      else
         Tiles=0;
   }

//call decode (just incase it does anthing non-standard)
   if(pBoard->decodegfx)
      pBoard->decodegfx(pTemp,preload);

   readgfxs(pTemp,preload);


//if we haven't got them alread, write out precalculated graphics
   if(!preload)
   {
      if(!realorient)
      {
         rotchars(pBoard->nocharcols,pBoard->nochars);
         rotsprites(pBoard->nosprcols,pBoard->nosprites);
         rotbigsprites(pBoard->nobigsprcols,pBoard->nobigsprites);
         if(pBoard->rottiles)
            rottiles(pBoard->notilecols,pBoard->notiles);
      }
      else
         flipchars(pBoard->nocharcols,pBoard->nochars);

      if(precalculate)
      {
         fin=fopen(buffer,"wb");
         if(fin)
         {
            for(col=0;col<pBoard->nocharcols;col++)
            {
               fwrite(&Gfx[COL_CHAR],1,(64*pBoard->nochars),fin);
               fwrite(&FlipGfx[COL_CHAR],1,(64*pBoard->nochars),fin);
            }
            for(col=0;col<pBoard->nosprcols;col++)
               fwrite(&Sprites[COL_SPRITE],1,(256*pBoard->nosprites),fin);
            for(col=0;col<pBoard->nobigsprcols;col++)
               fwrite(&BigSprites[COL_BIG],1,(32*32*pBoard->nobigsprites),fin);
            for(col=0;col<pBoard->notilecols;col++)
               fwrite(&Tiles[COL_TILE],1,(256*pBoard->notiles),fin);
            fwrite(Mask,1,(64*pBoard->nochars),fin);
            fwrite(FlipMask,1,(64*pBoard->nochars),fin);
            fclose(fin);
         }
      }
   }
}

int getcurrentcycles(void)
{
   return TotalCycles[CurrentCPU]+mz80GetElapsedTicks(FALSE);
}

int getcyclesthisframe(void)
{
   return CyclesThisFrame[CurrentCPU]+mz80GetElapsedTicks(FALSE);
}

int getcyclesperframe(void)
{
   return CyclesPerFrame[CurrentCPU];
}


int exec(int cycles)
{
   DWORD dwResult;
   int ret=0;
   int nodone;
   int brk=0;
   UINT32 ipc;



   while(TRUE)
   {
      dwResult=mz80exec(cycles);
      nodone=mz80GetElapsedTicks(TRUE);
      ret+=nodone;
      if(dwResult==0x80000000)
         break;
      loginfo("Illegal instruction at 0x%x",(int)dwResult);
//illegal instruction, skip it
      cycles-=nodone;
      if(cycles>0)
      {
         if(brk==5)
            break;
         ipc=mz80GetRegisterValue(NULL,CPUREG_PC);
         ipc++;
         mz80SetRegisterValue(NULL,CPUREG_PC,ipc);
         loginfo("Skipping instruction, now at 0x%x",ipc);
         brk++;
      }
      else
         break;
   }
   return ret;
}

void causenmi(int cpu)
{
   mz80GetContext(&context[CurrentCPU]);
   mz80SetContext(&context[cpu]);
   mz80nmi();
   mz80GetContext(&context[cpu]);
   mz80SetContext(&context[CurrentCPU]);
}

//logging
void openlogfile(void)
{
   if(logging)
   {
      fLogFile=fopen("vantage.log","wt");
      if(!fLogFile)
         logging=0;
      atexit(exitptn);
   }
}


void setbasecode(int offset)
{
   mz80GetContext(&context[CurrentCPU]);
   context[CurrentCPU].z80Base=&pBaseCode[CurrentCPU][offset];
   mz80SetContext(&context[CurrentCPU]);
   baseoffset=offset;
}
