#include "main.h"
#include "mcrstvid.h"
#include "galvid.h"
#include "amdvid.h"
#include "globals.h"
#include "twk.h"
#include "blit.h"

int gfxext=0;



void initmcrst(void)
{
   precalcstars();
   gfxext=0;
   mcrstdecode();
   blnkchar=36;
   maxchar=32;
   startchar=2;
   pCharMem=&pCode[0x9000];
   pAttrMem=&pCode[0x9800];
   sprmodify=mcrstmod;
}

void clearmcrst(void)
{
}

void mcrstint(void)
{
   mz80nmi();
}

void checkmanint(void)
{
   if(pCode[0xb001])
      mz80nmi();
}

void moongfxextw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;
   work=offset-mwb->lowAddr;

   if(value)
      gfxext|=(1<<work);
   else
      gfxext&=~(1<<work);
}

void updatemcrstscreen(void)
{
   int x,y,y1,idx;

   pBYTE pWork;
   pBYTE pWork2;


   fastclear();

   moondispchars();

   pWork=&pCode[0x9860];
   if(realorient)
   {
      for(idx=0;idx<32;idx+=4)
      {
         if(FlipScreen)
         {
            if(ror)
            {
               y=pWork[idx+1];
               x=pWork[idx+3]-11;
            }
            else
            {
               y=pWork[idx+1];
               x=240-pWork[idx+3];
            }

            if(x>0&&x<240&&y>0&&y<240)
            {
               x+=32;
               y+=32;
               pWork2=pScreen+x+(y<<9);
               memset(pWork2,25,3);
            }
         }
         else
         {
            if(ror)
            {
               y=(255-pWork[idx+1]);
               x=pWork[idx+3]+11;
            }
            else
            {
               y=(255-pWork[idx+1]);
               x=(252-pWork[idx+3]);
            }

            if(x>0&&x<240&&y>0&&y<240)
            {
               x+=32;
               y+=32;
               pWork2=pScreen+x+(y<<9);
               memset(pWork2,25,3);
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         for(idx=0;idx<32;idx+=4)
         {
            if(flipxy)
            {
               y=(262-pWork[idx+1]);
               x=pWork[idx+3]-15;
            }
            else
            {
               y=(262-pWork[idx+1]);
               x=(242-pWork[idx+3]);
            }

            if(x>0&&x<240&&y>0&&y<240)
            {
               x+=32;
               y+=32;
               pWork2=pScreen+y+(x<<9);
               for(y1=0;y1<3;y1++,pWork2+=512)
                  *pWork2=25;
            }
         }
      }
      else
      {
         for(idx=0;idx<32;idx+=4)
         {
            if(flipxy)
            {
               y=pWork[idx+1]+7;
               x=pWork[idx+3]+11;
            }
            else
            {
               y=pWork[idx+1]+7;
               x=263-pWork[idx+3];
            }
            if(x>0&&x<240&&y>0&&y<240)
            {
               x+=32;
               y+=32;
               pWork2=pScreen+y+(x<<9);
               for(y1=0;y1<3;y1++,pWork2+=512)
                  *pWork2=25;
            }
         }
      }
   }
   drawsprites(0x9840,32);
   if(pCode[0xb004])
      drawstars(TRUE,TRUE);

}

//decode encrypted roms - taken from MAME
void mcrstdecode(void)
{
   int idx;
   BYTE out;
   for(idx=0;idx<0x10000;idx++)
   {
      out=pCode[idx];
      if(out&0x02)
         out^=0x40;
      if(out&0x20)
         out^=0x04;
      if(!(idx&1))
         out=(out&0xbb)|((out&0x40)>>4)|((out&0x04)<<4);
      pCode[idx]=out;
   }
}


void initmoonqsr(void)
{
   precalcstars();
   gfxext=0;
   mcrstdecode();
   blnkchar=36;
   maxchar=32;
   startchar=2;
   pCharMem=&pCode[0x9000];
   pAttrMem=&pCode[0x9800];
   sprmodify=moonqsrmod;

   setbasecode(0x2000);
//   z80pc = 0x2000;
//   context[0].z80Base[offset]=0x2000;

//	unsigned char *rom = memory_region(REGION_CPU1);
//	int diff = memory_region_length(REGION_CPU1) / 2;


//	memory_set_opcode_base(0,rom+diff);
}
