#include "main.h"
#include "globals.h"

static BYTE saveregs[64];
static NAMCOCHANNEL namcochannel[3];
static pBYTE pWaveData[3];
static int nochannels=3;
static int wave[3];

static BYTE namlktab[16];

static int freqshifter;

void namcostartsound(void)
{
   int i;
   int max=0x40;
   int val,step;
//create 3 empty samples and set them going
   for(i=0;i<nochannels;i++)
   {
      pWaveData[i]=createemptysample(NAMCO_SIZE,&wave[i],TRUE);
      setvol(i,10);
      playsample(i,wave[i],LOOP,DEFAULT_FREQ);
   }
//precalc signed samples
   val=0;
   step=max>>3;
   for(i=0;i<8;i++)
   {
      namlktab[7+i]=val;
      namlktab[7-i]=-val;
      val+=step;
   }
   namlktab[15]=max;

   for(i=0;i<0x100;i++)
      pSoundData[0][i]=namlktab[pSoundData[0][i]&0x0f];
//freq shift
   freqshifter=2+sampleidx;
}

void namcoupdatesound(void)
{
   int idx,i;
   int brk=0;
   int namvol,namfreq;
   pBYTE lastsamp[3];


   for(idx=0;idx<nochannels;idx++)
	{
      namfreq=namcochannel[idx].freq;
      namvol=namcochannel[idx].vol;
      if(namvol&&namfreq)
      {
         setfreq(idx,namfreq>>freqshifter);
         if(lastsamp[idx]!=namcochannel[idx].wave)
         {
            for(i=0;i<NAMCO_SIZE;i++)
               pWaveData[idx][i]=namcochannel[idx].wave[i&0x1f];
            lastsamp[idx]=namcochannel[idx].wave;
            updateDMA(wave[idx]);
         }

         setvol(idx,namvol);
		}
      else
         setvol(idx,0);

	}
//sync up a bit
   if(throttle)
   {
      while(TRUE)
      {
         LONG pos;
         getvoicepos(0,&pos);
         if(pos<6)
            break;
         AUpdateAudioEx(40);
         brk++;
         if(brk==3)
            break;
      }
   }
}

void namcosndw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int newx;
   int idx;
	int base;

   newx=offset-mwb->lowAddr;
   saveregs[newx]=value&0x0f;

   for(base=0,idx=0;idx<nochannels;idx++,base+=5)
	{

      namcochannel[idx].freq=saveregs[0x14+base];
      namcochannel[idx].freq=NAMFREQ_SHIFT+saveregs[0x13+base];
      namcochannel[idx].freq=NAMFREQ_SHIFT+saveregs[0x12+base];
      namcochannel[idx].freq=NAMFREQ_SHIFT+saveregs[0x11+base];
      if(!idx)
         namcochannel[idx].freq=NAMFREQ_SHIFT+saveregs[0x10+base];
      else
         namcochannel[idx].freq=NAMFREQ_SHIFT;

      namcochannel[idx].vol=saveregs[0x15+base];
      namcochannel[idx].wave=&pSoundData[0][(saveregs[0x05+base]&7)<<5];
	}
}

