#include "main.h"
#include "globals.h"
#include "pacsnd.h"
#include "twk.h"

extern int scrolling;

static int eatwav[]={2,10};
static int coinin=0;
static int ingame=0;
static int startg=0;
static int grun=0;
static int ghide=0;
static int gstate[4];
static int fthere=0;
static int eatpos=0;
static int level=0;
static int dcount=1;
static int waitd=1;
static int pacd=0;
static int curpacc=0;
static int strip=0;
static int eaten=0;
static int lastxval=0;
static int lastyval=0;
static int setg=0;

extern BYTE pacvram[2048];
extern int pacdots;
extern int chasefreq;


void pacreset(void)
{
   coinin=0;
   ingame=0;
   startg=0;
   grun=0;
   ghide=0;
   memset(gstate,0,sizeof(int)*4);
   fthere=0;
   eatpos=0;
   level=0;
   dcount=1;
   waitd=1;
   pacd=0;
   curpacc=0;
   strip=0;
   eaten=0;
   lastxval=0;
   lastyval=0;

}

void pacfruit(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   WRITE_MEM
   if(offset==0x4c90&&!value)
      fthere=0;

   if(value==137)
      fthere=1;

   if(fthere&&value==84)
   {
      fthere=0;
      playsample(7,9,ONE_SHOT,DEFAULT_FREQ);
   }
}

void mspacfruit(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   BYTE work;
   WRITE_MEM


   work=pCode[0x4ffc];

   if(!pacd&&channel[0].playing)
   {
      if(ingame&&value>19)
      {

         if(!(work&128)&&work>31)
         {
            if(!eaten)
            {
               playsample(7,9,ONE_SHOT,DEFAULT_FREQ);
               eaten=1;
            }
         }
         else
         {
            if(!strip)
            {
               if(pCode[0x4c3d]!=lastyval||value!=lastxval)
                  playsample(7,11,ONE_SHOT,DEFAULT_FREQ);
               lastyval=pCode[0x4c3d];
               lastxval=value;
            }
            strip++;
            if(strip==16)
               strip=0;
         }
      }
   }
   if((work&127)<32)
      eaten=0;

}

void paclevel(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval=0;
   int idx;
   WRITE_MEM

   dcount=1;
   if(value==15)
   {
      startg=0;
      fthere=0;
      stopsample(0);
   }
   if(value==33)
      stopsample(5);

   if(ingame&&value==32&&lastval)
      playsample(5,8,LOOP,DEFAULT_FREQ+63);

   waitd=1;
   lastval=value;
}

void mpaclevel(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int lastval=0;
   WRITE_MEM



   dcount=1;
   if(value==15)
   {
      startg=0;
      fthere=0;
      stopsample(0);
   }
   if(value==33)
      stopsample(5);

   if(ingame&&value==32&&lastval)
   {
      int x=17;
      while(pacvram[x]==64&&x)
         x--;
      switch(x)
      {
         case 7:
            playsample(5,8,ONE_SHOT,DEFAULT_FREQ-40);
            break;
         case 13:
            playsample(5,12,ONE_SHOT,DEFAULT_FREQ);
            break;
         case 17:
            playsample(5,13,ONE_SHOT,DEFAULT_FREQ);
            break;
      }
   }
   waitd=1;
   lastval=value;
}

void paceat(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   WRITE_MEM

   if(ingame&&value&&pCode[0x4c36]!=7)
   {
      playsample(2,eatwav[eatpos++],0,DEFAULT_FREQ);
      if(eatpos==2)
         eatpos=0;
      if(value==pacdots)
         stopsample(0);
   }
}

void pacdeath(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   WRITE_MEM
   if(ingame&&!pacd&&!startg)
   {
      if(waitd&&value!=8)
         waitd=0;
      if(!waitd&&value==8)
      {
         if(channel[0].playing)
         {
            pacd=1;
            fthere=0;
            stopsample(0);
            curpacc=pCode[0x4ffa];
         }
      }
      setg=0;
   }
}
void paccoin(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   if(value==1)
   {
      coinin=1;
      playsample(6,1,ONE_SHOT,DEFAULT_FREQ);
   }
}

void pacghoststate(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   static int gid[4]={1,3,5,7};
   int idx;

   WRITE_MEM

   if(channel[5].playing)
      return;



   idx=offset-0x4c03;
   idx>>=1;

   if(ingame)
   {
      if(value==17&&gstate[idx]==0)
      {
         gstate[idx]=1;
         grun++;
         if(idx==0)
            playsample(0,5,LOOP,DEFAULT_FREQ-chasefreq);
      }

      if(value==gid[idx]&&gstate[idx])
      {
         grun--;

         if(grun<=0)
         {
            ghide=0;
            if(channel[0].playing)
               playsample(0,4,LOOP,DEFAULT_FREQ);
         }
         else
         {
            if(gstate[idx]>1)
            {
               ghide--;
               if(ghide<=0&&channel[0].playing)
                  playsample(0,5,LOOP,DEFAULT_FREQ);
            }
         }
         gstate[idx]=0;
      }
      if(value==24&&gstate[idx]==1)
      {
         playsample(3,6,ONE_SHOT,DEFAULT_FREQ);
         gstate[idx]=2;
      }

      if(value==25&&gstate[idx]==2)
      {
         gstate[idx]=3;
         if(!ghide)
            playsample(0,7,LOOP,DEFAULT_FREQ);
         ghide++;
      }


   }
}
void pacsoundtrig(void)
{
//a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u  v  w  x  y  z
//65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
//0x4c3b
// 20 -> 244
   int idx;

   if(pacvram[658]==71&&pacvram[652]!=80)
   {
      stopsample(0);
      ingame=0;
      if(scrolling)
         pandisplay();
   }
   if(coinin&&!ingame&&pacvram[652]==80)
   {
      playsample(6,0,ONE_SHOT,DEFAULT_FREQ);
      dcount=1;
      ingame=1;
      startg=0;
   }


   if(startg&&pacvram[594]!=82)
   {
      play1sample(0,4,LOOP,DEFAULT_FREQ);
      startg=0;
      grun=0;
      ghide=0;
      pacd=0;
      waitd=1;
      setg=1;
      memset(gstate,0,sizeof(int)*4);
   }

   if(ingame&&pacd&&pCode[0x4ffa]!=curpacc)
   {
      pacd++;
      if(pacd>=3)
      {
         if(!channel[1].playing&&!channel[5].playing)
            playsample(1,3,ONE_SHOT,DEFAULT_FREQ);
         pacd=0;
      }
      curpacc=pCode[0x4ffa];

   }

   if(ingame&&pacvram[594]==82)
   {
      if(scrolling)
         pandisplay();
      startg=1;
   }

}

