#include "main.h"
#include "phnxvid.h"
#include "twk.h"
#include "globals.h"
#include "phnxsnd.h"
#include "math.h"

static int vblank;
static int baseflip;
static int curplayer;
static pBYTE phoenixvid1;
static pBYTE phoenixvid2;
static pBYTE phoenixvid;
static pBYTE vidpages[2];
static int vidpage;
static int scrollpos;
static int phoenixpbank;
static pBYTE pBackground;

pBYTE pBackOut2;
pBYTE pBackIn2;

extern DIPSWITCH   dipswitch[MAX_DIPS];
void initphoenix(void)
{
   phoenixvid1=&pCode[0x11000];
   phoenixvid2=&pCode[0x12000];

   pBackground=calloc(0x10000,1);
   vidpages[0]=phoenixvid1;
   vidpages[1]=phoenixvid2;
   phoenixvid=vidpages[0];

   vidpage=0;
   phoenixsetupsound();
   baseflip=FlipScreen;

}

void clearphoenix(void)
{
   myfree(pBackground);
}

void phoenixint(void)
{
   vblank=1;
}


UINT8 phoenixvblank(void)
{
   if(vblank)
   {
      vblank=0;
      return 0x80;
   }
   return 0x00;
}

UINT8 phnxinp(UINT32 offset, struct MemoryReadByte *mrb)
{
   if(curplayer)
      return pCode[0x10002];
   else
      return pCode[0x10001];
}

void phoenixvidw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   WRITE_MEM

   phoenixvid[(int)(offset-0x4000)]=value;
}


UINT8 phoenixvidr(UINT32 offset, struct MemoryReadByte *mrb)
{
   if(offset>=0x4bf8&&offset<0x4c00)
      return pCode[offset];

   return phoenixvid[(int)(offset-0x4000)];
}

void phoenixbscrollw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   scrollpos=value;
}

void phoenixvbankw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   if(vidpage!=(value&1))
   {
      vidpage=value&1;
      memcpy((vidpages[!vidpage]+0xbf8),&pCode[0x4bf8],8);
      phoenixvid=vidpages[vidpage];
      if(dipswitch[1].setting==1)
      {
         if(vidpage==1)
         {
            curplayer=1;
            FlipScreen=!baseflip;
         }
         else
         {
            curplayer=0;
            FlipScreen=baseflip;
         }
         markalldirty();
      }
   }
   phoenixpbank=((value>>1)&1)<<3;

}



void phoenixupdatescreen(void)
{
   int x,y,col,prey,prey2;
   pBYTE pBack;
   pBYTE pWork;
   static int lastback;

   if(lastback!=background)
   {
      markalldirty();
      lastback=background;
   }



   pBack=phoenixvid+0x800;
   pWork=phoenixvid;


   phoenixupdatesound();

   if(realorient)
   {
      if(background)
      {
         if(FlipScreen)
         {
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pBack++)
               {
                  if(pacdirty[x+(y<<5)]!=*pBack)
                  {
                     disppbackchar(31-x,25-y,*pBack);
                     pacdirty[x+(y<<5)]=*pBack;
                  }
               }
            }
            drawpbackground();
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pWork++)
                  disppsprite(31-x,25-y,*pWork);
            }
         }
         else
         {
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pBack++)
               {
                  if(pacdirty[x+(y<<5)]!=*pBack)
                  {
                     disppbackchar(x,y,*pBack);
                     pacdirty[x+(y<<5)]=*pBack;
                  }
               }
            }
            drawpbackground();
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pWork++)
                  disppsprite(x,y,*pWork);
            }
         }
      }
      else
      {
         if(FlipScreen)
         {
            for(y=0;y<26;y++)
            {
               prey=(25-y)<<3;
               for(x=0;x<32;x++,pWork++)
               {
                  col=(*pWork>>5)|phoenixpbank;
                  if(*pWork)
                     dispchar((31-x)<<3,prey,*pWork|0x100,col);
               }
            }
         }
         else
         {
            for(y=0;y<26;y++)
            {
               prey=y<<3;
               for(x=0;x<32;x++,pWork++)
               {
                  col=(*pWork>>5)|phoenixpbank;
                  if(*pWork)
                     dispchar(x<<3,prey,*pWork|0x100,col);
               }
            }
         }
      }
   }
   else
   {
      if(background)
      {
         if(FlipScreen)
         {
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pBack++)
               {
                  if(pacdirty[x+(y<<5)]!=*pBack)
                  {
                     disppbackchar(y,31-x,*pBack);
                     pacdirty[x+(y<<5)]=*pBack;
                  }
               }
            }
            drawpbackground();
            for(y=0;y<26;y++)
            {
               for(x=0;x<32;x++,pWork++)
                  disppsprite(y,31-x,*pWork);
            }
         }
         else
         {
            for(y=0;y<26;y++)
            {
               prey=25-y;
               for(x=0;x<32;x++,pBack++)
               {
                  if(pacdirty[x+(y<<5)]!=*pBack)
                  {
                     disppbackchar(prey,x,*pBack);
                     pacdirty[x+(y<<5)]=*pBack;
                  }
               }
            }
            drawpbackground();
            for(y=0;y<26;y++)
            {
               prey=25-y;
               for(x=0;x<32;x++,pWork++)
                  disppsprite(prey,x,*pWork);
            }
         }
      }
      else
      {
         if(FlipScreen)
         {
            for(y=0;y<26;y++)
            {
               prey=y<<3;
               prey2=y<<5;
               for(x=0;x<32;x++,pWork++)
               {
                  col=(*pWork>>5)|phoenixpbank;
                  if(pacdirty[x+prey2]!=*pWork)
                  {
                     dispchar(prey,(31-x)<<3,*pWork|0x100,col);
                     pacdirty[x+prey2]=*pWork;
                  }
               }
            }
         }
         else
         {
            for(y=0;y<26;y++)
            {
               prey2=y<<5;
               prey=(25-y)<<3;
               for(x=0;x<32;x++,pWork++)
               {
                  col=(*pWork>>5)|phoenixpbank;
                  if(pacdirty[x+prey2]!=*pWork)
                  {
                     dispchar(prey,x<<3,*pWork|0x100,col);
                     pacdirty[x+prey2]=*pWork;
                  }
               }
            }
         }
      }
   }
}


void disppbackchar(int x,int y,int value)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int col=(value>>5)|phoenixpbank;

   if(FlipScreen)
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
   else
      pWork=&Gfx[COL_CHAR+(value<<6)];

   x<<=3;
   y<<=3;

	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
      "movw    %%ax,%%es \n"
//x,y
      "addl    %%ebx,%%edi \n"
      "shll    $8,%%ecx \n"
      "addl    %%ecx,%%edi \n"

      "movl    $252,%%edx \n"

//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"

      "popw    %%es \n"


//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pBackground),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);
}

void drawpbackground(void)
{
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   pBYTE pOut;
   pBYTE pIn;
   int i,idx;
   int cpy1;
   int cpy2;

   pOut=pBoard->pScreen;


   if(realorient)
   {
      if(FlipScreen)
      {
         cpy2=256-scrollpos;
         cpy1=256-cpy2;
         pIn=pBackground+(255-scrollpos);
      }
      else
      {
         cpy1=256-scrollpos;
         cpy2=256-cpy1;
         pIn=pBackground+scrollpos;
      }
      pBackOut2=pOut+cpy1;
      pBackIn2=pBackground;

      __asm__ __volatile__
      (
         ".align 4 \n"
//setup es
         "pushw   %%es  \n"
         "movw    %%ax,%%es \n"

         "movl    $208,%%edx \n"
//height loop
"1:\n"
//save copy2
         "pushl   %%ecx \n"
//double words
         "movl    %%ebx,%%ecx \n"
         "shrl    $2,%%ecx \n"
         "rep \n"
         "movsl \n"
//words
         "movl    %%ebx,%%ecx \n"
         "andl    $3,%%ecx \n"
         "shrl    $1,%%ecx \n"
         "jz      2f \n"
         "rep \n"
         "movsw \n"
"2:\n"
//byte
         "movl    %%ebx,%%ecx \n"
         "andl    $1,%%ecx \n"
         "jz      3f \n"
         "movsb \n"
"3:\n"
         "addl    $512,%%edi \n"
         "subl    %%ebx,%%edi \n"
         "addl    $256,%%esi \n"
         "subl    %%ebx,%%esi \n"
//get cpy2 back
         "popl    %%ecx \n"
         "pushl   %%ecx \n"
//anything there ?
         "cmpl    $0,%%ecx \n"
         "je      6f \n"
//save 1st 'page'
         "pushl   %%ebx \n"
         "pushl   %%esi \n"
         "pushl   %%edi \n"
//setup 2nd 'page'
         "movl    %%ecx,%%ebx \n"
         "movl    _pBackIn2,%%esi \n"
         "movl    _pBackOut2,%%edi \n"


//double words
         "shrl    $2,%%ecx \n"
         "rep \n"
         "movsl \n"
//words
         "movl    %%ebx,%%ecx \n"
         "andl    $3,%%ecx \n"
         "shrl    $1,%%ecx \n"
         "jz      4f \n"
         "rep \n"
         "movsw \n"
"4:\n"
//byte
         "movl    %%ebx,%%ecx \n"
         "andl    $1,%%ecx \n"
         "jz      5f \n"
         "movsb \n"
"5:\n"
         "addl    $512,%%edi \n"
         "subl    %%ebx,%%edi \n"
         "addl    $256,%%esi \n"
         "subl    %%ebx,%%esi \n"


//save changes to 2nd page
         "movl    %%esi,_pBackIn2 \n"
         "movl    %%edi,_pBackOut2 \n"
//get back first page
         "popl    %%edi \n"
         "popl    %%esi \n"
         "popl    %%ebx \n"
"6:\n"
//end of height loop
         "popl    %%ecx \n"
         "decl    %%edx \n"
         "jnz     1b \n"
         "popw    %%es \n"
//outputs (clobbered inputs)
         : "=a" (dummy1),
           "=S" (dummy2),
           "=D" (dummy3),
           "=b" (dummy4),
           "=c" (dummy5)
// inputs -
         : "0" (DataSeg),
           "1" (pIn),
           "2" (pOut),
           "3" (cpy1),
           "4" (cpy2)

// registers modified
         :  "dx","cc", "memory"
      );
   }
   else
   {
      if(FlipScreen)
         idx=255-scrollpos;
      else
         idx=scrollpos;
      cpy1=256-idx;
      pIn=pBackground+(idx<<8);
      __asm__ __volatile__
      (
         ".align 4 \n"
//setup es
         "pushw   %%es  \n"
         "movw    %%ax,%%es \n"

         "movl    $256,%%edx \n"
//height loop
"1:\n"
         "movl    $52,%%ecx \n"
         "rep \n"
         "movsl \n"
         "addl    $512-208,%%edi \n"
         "addl    $256-208,%%esi \n"
//check for wrap
         "decl    %%ebx \n"
         "jnz     2f \n"
         "movl    _pBackground,%%esi \n"
"2:\n"
//end of height loop
         "decl    %%edx \n"
         "jnz     1b \n"
         "popw    %%es \n"
//outputs (clobbered inputs)
         : "=a" (dummy1),
           "=S" (dummy2),
           "=D" (dummy3),
           "=b" (dummy4)
// inputs -
         : "0" (DataSeg),
           "1" (pIn),
           "2" (pOut),
           "3" (cpy1)
// registers modified
         :  "cx","dx","cc", "memory"
      );

   }

}

void disppsprite(int x,int y,BYTE value)
{
   int col,cmp;

   if(realorient)
   {
      if(FlipScreen)
         cmp=31-x;
      else
         cmp=x;

   }
   else
   {
      if(FlipScreen)
         cmp=31-y;
      else
         cmp=y;

   }

   if(value||cmp<1)
   {
      col=(value>>5)|phoenixpbank;

      if(cmp>1)
         disptranschar(x<<3,y<<3,value|0x100,col);
      else
         dispchar(x<<3,y<<3,value|0x100,col);
   }
}



void phoenixsetpal(pBYTE pIn)
{
   int idx,bit0,bit1,i,j;

   for(idx=0;idx<256;idx++)
   {
      outportb(0x3c8,idx);

      bit0=(*pIn&0x01)*0x55;
      bit1=(pIn[256]&0x01)*0xaa;

      outportb(0x3c9,(bit0+bit1)>>2);


      bit0=((*pIn>>2)&0x01)*0x55;
      bit1=((pIn[256]>>2)&0x01)*0xaa;

      outportb(0x3c9,(bit0+bit1)>>2);

      bit0=((*pIn>>1)&0x01)*0x55;
      bit1=((pIn[256]>>1)&0x01)*0xaa;

      outportb(0x3c9,(bit0+bit1)>>2);
      pIn++;
	}
   /* first bank of characters use colors 0-31 and 64-95 */
   for (i = 0;i < 8;i++)
	{
		for (j = 0;j < 2;j++)
		{
         collookups[0][4*i + j*4*8] = i + j*64;
         collookups[0][4*i + j*4*8 + 1] = 8 + i + j*64;
         collookups[0][4*i + j*4*8 + 2] = 2*8 + i + j*64;
         collookups[0][4*i + j*4*8 + 3] = 3*8 + i + j*64;
		}
	}

	/* second bank of characters use colors 32-63 and 96-127 */
	for (i = 0;i < 8;i++)
	{
		for (j = 0;j < 2;j++)
		{
         collookups[1][4*i + j*4*8] = i + 32 + j*64;
         collookups[1][4*i + j*4*8 + 1] = 8 + i + 32 + j*64;
         collookups[1][4*i + j*4*8 + 2] = 2*8 + i + 32 + j*64;
         collookups[1][4*i + j*4*8 + 3] = 3*8 + i + 32 + j*64;
		}
	}
   collookups[0][0]=0;
   collookups[1][0]=0;

}


