#ifndef _PSXPAD_H_
#define _PSXPAD_H_

struct sPSXPAD
{
	unsigned long int dwPSXPAD[6];	/* Up to 6 PSXPAD's */
};

/* Function prototypes */

//extern unsigned long int GetPSXPADStatus(struct sPSXPAD *);

/* Bitwise codes in the dwSidewinder[A-D] structures */

#define	PSX_SELECT					0x00004000	/* Select Button */
#define	PSX_START					0x00002000	/* Start button */
#define	PSX_R2						0x00001000	/* R2 button */
#define	PSX_L2						0x00000800	/* L2button */
#define	PSX_R1						0x00000400	/* R1 Button */
#define	PSX_L1						0x00000200	/* L1 Button */
#define	PSX_CIRCLE					0x00000100	/* Circle Button */
#define	PSX_TRIANGLE				0x00000080	/* Triangle Button */
#define	PSX_SQUARE					0x00000040	/* Square Button */
#define	PSX_CROSS					0x00000020	/* Cross Button */
#define	PSX_LEFT					0x00000010	/* Left direction */
#define	PSX_RIGHT					0x00000008	/* Right direction */
#define	PSX_DOWN					0x00000004	/* Down direction */
#define	PSX_UP						0x00000002	/* Up direction */


extern int psx_init(int base);
extern int psx1_init(void);
extern void psx1_exit(void);
extern void psx_clk(int base, int on);
extern void psx_sel(int base, int conport, int on);
extern void psx_cmd(int base, int on);
extern int psx_dat(int base, int conport);
extern int psx_ack(int base, int conport);
extern void psx_delay(int base);
extern unsigned char psx_sendbyte(int base, int conport, unsigned char byte, int wait);
extern void psx_sendinit(int base, int conport);
extern void psx_sendclose(int base, int conport);
extern void psx_sendstring(int base, int conport, int string[]);
extern void psx_vibrate_init(int base, int conport, int tap);
extern int psx_detect(int base, int conport, int tap);
extern void psx_poll(int base, int conport, int tap, int type, int joynum,struct sPSXPAD *tt);
extern int psx1_poll(struct sPSXPAD *);

#endif
