#include "main.h"
#include "globals.h"
#include "sound.h"
#include "math.h"

int actsamples;
fixed fixsamples;
static int usestreams=0;
static LONG streampos=0;
static int streamlen;

int curload=0;
SAMPLIST samplist[NO_SAMPLES];
pSAMPITEM sampstart[NO_SAMPLES];
int sampleloaded[NO_SAMPLES];

CHANNEL channel[NO_CHANNELS];
static LPAUDIOWAVE lpWave[NO_SAMPLES];
static HAC hVoice[NO_CHANNELS];

#define NUMVOICES    12
#define NUMSTREAMS   9

LPAUDIOWAVE lpStreamWave[NUMSTREAMS];
STREAM Streams[NUMSTREAMS];
int sampperframe;
static int basechannel=0;

int vol=15;
#define BUF_PAGES 4



#define QUEUE_LENGTH 10

static int command_queue[QUEUE_LENGTH+1];
int pending_commands=0;
int *pread;
int *pwrite;

void startstreams(void)
{
   int i,x;
   FILE *ff;

   LONG position;
   LONG chunkPosition=0;
   uclock_t t1,t2;

   SILENCE_CHECK

   streamlen=actsamples*BUF_PAGES;

   for (i = 0; i < NUMSTREAMS; i++)
   {
      Streams[i].bUpdated=FALSE;
      Streams[i].nVol=15;
      Streams[i].pStreamUpdate=myalloc(actsamples);

      lpStreamWave[i] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE));

      lpStreamWave[i]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
      lpStreamWave[i]->nSampleRate = samplerate;
      lpStreamWave[i]->dwLength = streamlen;
      lpStreamWave[i]->dwLoopStart=0;
      lpStreamWave[i]->dwLoopEnd=lpStreamWave[i]->dwLength;
      ACreateAudioData(lpStreamWave[i]);
      memset(lpStreamWave[i]->lpData,0,streamlen);
      AWriteAudioData(lpStreamWave[i],0,streamlen);
      APrimeVoice(hVoice[i],lpStreamWave[i]);
      APlayVoice(hVoice[i],lpStreamWave[i]);
      setvol(i,15);
   }
   basechannel=NUMSTREAMS;
   streampos=actsamples*(BUF_PAGES/2);
}

void stopstreams(void)
{
   int i;
   for (i = 0; i < NUMSTREAMS; i++)
      myfree(Streams[i].pStreamUpdate);
}

static int updatestream(int channel)
{
   memcpy(&lpStreamWave[channel]->lpData[streampos],Streams[channel].pStreamUpdate,actsamples);
   AWriteAudioData(lpStreamWave[channel],streampos,actsamples);
   Streams[channel].bUpdated=FALSE;

   return TRUE;
}



void updatestreams(void)
{
   int i;
   LONG pos=0;
   LONG fpos;
   LONG workpos;
   int fplp=FALSE;
   int start,end,buflen;
   int chk;
   int wt=0;

   SILENCE_CHECK

   buflen=streamlen;
   start=streampos;
   end=start+actsamples;
   if(end>buflen)
      end-=buflen;

//stream sync
   if(throttle)
	{
      while(TRUE)
		{
			LONG curpos;

			AGetVoicePosition(hVoice[0],&curpos);
         if(start<end)
			{
            if(curpos<start||curpos>=end)
               break;
			}
			else
			{
            if(curpos<start&&curpos>=end)
               break;
			}
         AUpdateAudioEx(actsamples);
         wt++;
		}
	}
//stream update
   for(i=0;i<NUMSTREAMS;i++)
   {
      if(Streams[i].bUpdated)
      {
         setvol(i-basechannel,Streams[i].nVol);
         updatestream(i);
      }
   }
   streampos+=actsamples;
   if(streampos>=streamlen)
      streampos-=streamlen;

   return;
}

void playstreamedsample(int channel,signed char *data,int len,int vol)
{
   Streams[channel].bUpdated=TRUE;
   Streams[channel].nVol=vol;
   memcpy(Streams[channel].pStreamUpdate,data,len);
}


void updatesound(void)
{
   int n;
   BOOL stopped;
   int upd;

   SILENCE_CHECK


   if(usestreams&&!syspaused)
      updatestreams();

   if(usestreams)
      AUpdateAudioEx(actsamples);
   else
      AUpdateAudioEx(actsamples+20);


   for(n=basechannel;n<NO_CHANNELS;n++)
   {
      if(channel[n].playing)
      {

         AGetVoiceStatus(hVoice[n],&stopped);
         if(stopped&&!channel[n].paused)
         {
//check for linked list
            if(sampstart[channel[n].sampleno])
            {
               playq(n-basechannel,sampstart[channel[n].sampleno]);
               sampstart[channel[n].sampleno]=sampstart[channel[n].sampleno]->pNext;
               channel[n].playing=TRUE;
            }
            else
            {
               if(channel[n].looping&&channel[n].looping!=LOOP)
                  channel[n].looping--;

               channel[n].playing=FALSE;
               if(channel[n].looping)
                  playsample(n-basechannel,channel[n].sampleno,channel[n].looping,channel[n].freq);
               else
               {
                  if(channel[n].queueno!=-1)
                  {
                     if(channel[n].queuechannel==n)
                        playsample(n-basechannel,channel[n].queueno,channel[n].queueloop,channel[n].queuefreq);
                     else
                     {
                        if(channel[channel[n].queuechannel].paused&&!syspaused)
                           resumesample(channel[n].queuechannel);
                        else
                           playsample(channel[n].queuechannel,channel[n].queueno,channel[n].queueloop,channel[n].queuefreq);
                     }
                  }
                  channel[n].queueno=-1;
               }
            }
         }
      }
   }
}

int initsound(int streams)
{
   AUDIOINFO info;
   int n;
   int len=32;

   pread=&command_queue[0];
   pwrite=&command_queue[0];

   usestreams=streams;
//clear samples
   AInitialize();

   sampperframe=(int)((double)samplerate/60.0F);

   info.nDeviceId=soundcard;
   info.wFormat=AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
   info.nSampleRate=samplerate;

   for(n=0;n<NUMSTREAMS;n++)
      Streams[n].pStreamUpdate=NULL;

   if(AOpenAudio(&info)!=AUDIO_ERROR_NONE)
   {
      printf("Unable to initialise sound device\n(soundcard=%d , will be reset to 0)\n",soundcard);
      loginfo("Unable to initialise sound device\n(soundcard=%d , will be reset to 0)",soundcard);
      soundcard=0;
      return FALSE;
   }
   AOpenVoices(NO_CHANNELS);

   for(n=0;n<NO_CHANNELS;n++)
   {
      ACreateAudioVoice(&hVoice[n]);
      ASetVoiceVolume(hVoice[n],64);
      ASetVoicePanning(hVoice[n],128);
   }
   for(n=0;n<NO_SAMPLES;n++)
   {
      lpWave[n]=NULL;
      samplist[n].pHead=NULL;
      sampleloaded[n]=FALSE;
   }

   ASetAudioMixerValue(AUDIO_MIXER_MASTER_VOLUME,(int)(((float)vol/15.0F)*256.0F));

   clearchannels();
   calcrealsamprate();

   if(streams)
      startstreams();


   return TRUE;

}

int updatevolume(void)
{
   ASetAudioMixerValue(AUDIO_MIXER_MASTER_VOLUME,(int)(((float)vol/15.0F)*256.0F));
   return 0;
}

void clearchannels(void)
{
   int i;
//clear channels
   for(i=0;i<NO_CHANNELS;i++)
   {
      memset(&channel[i],0,sizeof(CHANNEL));
      channel[i].queueno=-1;
      setvol(i,15);
   }
}

void setvol(int cno,int invol)
{
   CHANNEL_CHECK
   ASetVoiceVolume(hVoice[CHANNEL_NO],(int)(((float)invol/15.0f)*64.0F));
}



void setblanksample(void)
{
   int thisload=curload++;
   sampleloaded[thisload]=FALSE;
}

int readsample(pBYTE buf,DWORD len)
{
   unsigned long int idx;
   unsigned long int odx;
   LPAUDIOWAVE lpAudioWork;
   DWORD longin;
   DWORD temp32;
   DWORD remain=0;
   DWORD remwritten;
   short int shortin;
   short int bitres;
   SAMPITEM SampItem;
   int srate;
   pBYTE pWork;

   int thisload=curload++;


   pWork=buf;


   if(len<48)
   {
      loginfo("File not a valid WAV file");
      return FALSE;
   }

//check the header
   if(memcmp(buf,"RIFF", 4)||memcmp(buf+8,"WAVE",4))
   {
      loginfo("File not a valid WAV file");
      return FALSE;
   }
   buf+=12;
//format chunk
   if(memcmp(buf,"fmt",3))
   {
      loginfo("File not a valid WAV file");
      return FALSE;
   }
   buf+=4;
//get size (should be 16)
   buf+=4;
//format (should be PCM)
   shortin=*((short int *)buf);
   if(shortin!=1)
   {
      loginfo("File is not in PCM format");
      return FALSE;
   }
   buf+=2;
//channels
   shortin=*((short int *)buf);
   if(shortin!=1)
   {
      loginfo("File is a stereo WAV file, not supported by VAntAGE");
      return FALSE;
   }
   buf+=2;
//sample rate
   longin=*((long int *)buf);
   buf+=4;
   buf+=6;

   bitres=*((short int *)buf);

   if (bitres!=8&&bitres!=16)
   {
      loginfo("Only 16bit and 8bit WAV files supported (WAV is %dbit)",bitres);
      return FALSE;
   }


   len-=48L;


   if(len>MAX_SAMPLE_LEN)
   {
      remain=len-MAX_SAMPLE_LEN;
      loginfo("Sample %d is too big, creating link list len=%u, remain=%u",thisload,len,remain);
      len=MAX_SAMPLE_LEN;
   }

   lpWave[thisload]=(LPAUDIOWAVE)myalloc(sizeof(AUDIOWAVE));
   if(bitres==8)
      lpWave[thisload]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
   else
      lpWave[thisload]->wFormat = AUDIO_FORMAT_16BITS | AUDIO_FORMAT_MONO;
   lpWave[thisload]->nSampleRate = longin;
   lpWave[thisload]->dwLength = len;
   lpWave[thisload]->dwLoopStart = lpWave[thisload]->dwLoopEnd = 0;
   ACreateAudioData(lpWave[thisload]);
            /* copy the data into the waveform object */
   pWork+=46;
   memcpy(lpWave[thisload]->lpData, pWork, len);

   if(bitres==8)
   {
      for (temp32 = 0; temp32 < len; temp32++)
         lpWave[thisload]->lpData[temp32] ^= 0x80;
   }
   pWork+=len;

   AWriteAudioData(lpWave[thisload],0L,len);


   while(remain)
   {
      if(remain>MAX_SAMPLE_LEN)
         remwritten=MAX_SAMPLE_LEN;
      else
         remwritten=remain;

      lpAudioWork=(LPAUDIOWAVE)myalloc(sizeof(AUDIOWAVE));
      if(bitres==8)
         lpAudioWork->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
      else
         lpAudioWork->wFormat = AUDIO_FORMAT_16BITS | AUDIO_FORMAT_MONO;
      lpAudioWork->nSampleRate = longin;
      lpAudioWork->dwLength = remwritten;
      lpAudioWork->dwLoopStart = lpWave[thisload]->dwLoopEnd = 0;

      ACreateAudioData(lpAudioWork);
      memcpy(lpAudioWork->lpData,pWork,remwritten);

      if(bitres==8)
      {
         for(temp32=0;temp32<remwritten;temp32++)
            lpAudioWork->lpData[temp32]^=0x80;
      }

      remain-=remwritten;
      pWork+=remwritten;
      AWriteAudioData(lpAudioWork,0L,remwritten);
      SampItem.lpWave=lpAudioWork;
      addsampleq(&SampItem,thisload);
   }

   sampleloaded[thisload]=TRUE;
   return TRUE;
}


void addsampleq(pSAMPITEM pSampItem,int nIdx)
{
   pSAMPITEM pWork;
   pSAMPITEM pLast;
   pSAMPITEM pNew;
   pWork=samplist[nIdx].pHead;
   pLast=pWork;
   while(pWork)
   {
      pWork=(pSAMPITEM)pWork->pNext;
      if(pWork)
         pLast=pWork;
   }
   pNew=(pSAMPITEM)myalloc(sizeof(SAMPITEM));
   pNew->pNext=NULL;
   pNew->lpWave=pSampItem->lpWave;
   if(pLast)
      pLast->pNext=pNew;
   else
      samplist[nIdx].pHead=pNew;
}


int createsample(pBYTE pData,int len,int *no,int loop)
{
   int idx;
   int actlen;
   int copies=1;
   int frames;
   long int temp32;

   *no=curload++;
   actlen=len;
//if it's not a looping sample - make copies of it to fill at least one buffer update
   if(!loop)
   {
      frames=samplerate/60;
      if(actlen<frames)
      {
         copies=frames/len;
         actlen=len*copies;
      }
   }

   lpWave[*no]=(LPAUDIOWAVE)myalloc(sizeof(AUDIOWAVE));
   if(!lpWave[*no])
      return FALSE;
   if(loop)
      lpWave[*no]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
   else
      lpWave[*no]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
   lpWave[*no]->nSampleRate = 22050;
   lpWave[*no]->dwLength = actlen;
   lpWave[*no]->dwLoopStart = 0;
   lpWave[*no]->dwLoopEnd = actlen;
   if(ACreateAudioData(lpWave[*no])!=AUDIO_ERROR_NONE)
      return FALSE;

   for(idx=0;idx<copies;idx++)
   {
      memcpy(&lpWave[*no]->lpData[len*idx], pData, len);
      for (temp32 = 0; temp32 < len; temp32++)
         lpWave[*no]->lpData[(len*idx)+temp32] ^= 0x80;
   }


   AWriteAudioData(lpWave[*no],0L,actlen);

   sampleloaded[*no]=TRUE;

   return TRUE;
}

pBYTE createemptysample(int len,int *no,int loop)
{

   *no=curload++;


   lpWave[*no]=(LPAUDIOWAVE)myalloc(sizeof(AUDIOWAVE));
   if(!lpWave[*no])
      return FALSE;
   if(loop)
      lpWave[*no]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
   else
      lpWave[*no]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;

   lpWave[*no]->nSampleRate = samplerate;
   lpWave[*no]->dwLength = len;
   lpWave[*no]->dwLoopStart = 0;
   lpWave[*no]->dwLoopEnd = len;

   if(ACreateAudioData(lpWave[*no])!=AUDIO_ERROR_NONE)
      return FALSE;



   memset(lpWave[*no]->lpData,0,len);

   AWriteAudioData(lpWave[*no],0L,len);

   APrimeVoice(hVoice[0],lpWave[*no]);
   ASetVoiceFrequency(hVoice[0],samplerate);
   sampleloaded[*no]=TRUE;

   return (pBYTE)lpWave[*no]->lpData;

}


void playq(int cno,pSAMPITEM pSampItem)
{
   CHANNEL_CHECK
   APlayVoice(hVoice[CHANNEL_NO],pSampItem->lpWave);
}

void pauseallsamples(void)
{
   int n;


   for(n=basechannel;n<NO_CHANNELS;n++)
   {
      if(channel[n-basechannel].playing&&!channel[n-basechannel].paused)
      {
         pausesample(n);
         channel[n].syspaused=TRUE;
      }
   }
   for(n=0;n<basechannel;n++)
   {
      pausesample(n);
      channel[n].syspaused=TRUE;
   }


}

void resumeallsamples(void)
{
   int n;

   for(n=0;n<NO_CHANNELS;n++)
   {
      if(channel[n].syspaused)
         resumesample(n);
      channel[n].syspaused=FALSE;
   }
}


void playsample(int cno,int sampleno,int looping,int freq)
{

   CHANNEL_CHECK
   LOAD_CHECK

   channel[cno].sampleno=sampleno;
   channel[cno].playing=TRUE;
   channel[cno].freq=freq;

   sampstart[sampleno]=samplist[sampleno].pHead;
//let card handle looping if it's just one sample
   if(looping==LOOP&&!sampstart[sampleno])
   {
      lpWave[sampleno]->wFormat|=AUDIO_FORMAT_LOOP;
      lpWave[sampleno]->dwLoopStart=0;
      lpWave[sampleno]->dwLoopEnd=lpWave[sampleno]->dwLength;
   }
   else
      lpWave[sampleno]->wFormat&=~AUDIO_FORMAT_LOOP;

   channel[cno].looping=looping;
   APlayVoice(hVoice[CHANNEL_NO],lpWave[sampleno]);
   setfreq(cno,freq);
}




void queuesampleext(int cno,int cnoext,int sampleno,int looping,int freq)
{
   if(channel[cnoext].playing)
   {
      channel[cno].queuechannel=cnoext;
      channel[cno].queueno=sampleno;
      channel[cno].queueloop=looping;
      channel[cno].queuefreq=freq;
   }
   else
      playsample(cno,sampleno,looping,freq);
}

void queuesample(int cno,int sampleno,int looping,int freq)
{
   queuesampleext(cno,cno,sampleno,looping,freq);
}


void play1sample(int cno,int sampleno,int looping,int freq)
{
   if(channel[cno].playing)
      queuesample(cno,sampleno,looping,freq);
   else
      playsample(cno,sampleno,looping,freq);
}


void stopsample(int cno)
{
   CHANNEL_CHECK
   channel[cno].queueno=-1;
   channel[cno].looping=ONE_SHOT;
   sampstart[channel[cno].sampleno]=NULL;
   AStopVoice(hVoice[CHANNEL_NO]);
}

void pausesample(int cno)
{
   channel[cno].paused=TRUE;
   AStopVoice(hVoice[cno]);
}

void resumesample(int cno)
{
   channel[cno].paused=FALSE;
   AStartVoice(hVoice[cno]);
}


void setfreq(int cno,int freq)
{
   int freq2;
   CHANNEL_CHECK
   freq2=(int)((float)((float)lpWave[channel[cno].sampleno]->nSampleRate*(float)freq)/(float)DEFAULT_FREQ);
   ASetVoiceFrequency(hVoice[CHANNEL_NO],freq2);
}

void setstreamfreq(int cno,int freq)
{
   int freq2;
   if(cno>=NO_CHANNELS)
      return;
   freq2=(int)((float)((float)lpStreamWave[channel[cno].sampleno]->nSampleRate*(float)freq)/(float)DEFAULT_FREQ);
   ASetVoiceFrequency(hVoice[cno],freq2);
}

void setstreamfreqHz(int cno,int freq)
{
   if(cno>=NO_CHANNELS)
      return;
   ASetVoiceFrequency(hVoice[cno],freq);
}

void clearsound(void)
{
   int n;

   if(usestreams)
      stopstreams();

   for(n=0;n<NO_CHANNELS;n++)
   {
      AStopVoice(hVoice[n]);
      ADestroyAudioVoice(hVoice[n]);
   }

   for(n=0;n<NO_SAMPLES;n++)
      if(lpWave[n])
         ADestroyAudioData(lpWave[n]);

   ACloseVoices();
   ACloseAudio();
}

void updateDMA(int idx)
{
   AWriteAudioData(lpWave[idx],0L,lpWave[idx]->dwLength);
}

void getvoicepos(int cno,LONG *ppos)
{
   CHANNEL_CHECK
   AGetVoicePosition(hVoice[CHANNEL_NO],ppos);
}




int sound_command_r(void)
{
   int res=0;


	if (pending_commands > 0)
	{
      res=*pread;
      pread++;

      if(pread==&command_queue[QUEUE_LENGTH])
         pread=&command_queue[0];
      pending_commands--;
	}
   else
      res=0;

	return res;
}


int sndlatchread(void)
{
   static int res=0;

	if (pending_commands > 0)
	{
      res=*pread;
      pread++;

      if(pread==&command_queue[QUEUE_LENGTH])
         pread=&command_queue[0];
      pending_commands--;
	}

	return res;
}

UINT16 sndlatchportr(UINT16 offset, struct z80PortRead *zpr)
{
   return sndlatchread();
}

void sound_command_w(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   *pwrite=value;
   pwrite++;
   pending_commands++;
   if(pwrite==&command_queue[QUEUE_LENGTH])
      pwrite=&command_queue[0];

}

void calcrealsamprate(void)
{
   if(soundcard==0)
      actsamples=100;
   else
      actsamples=sampperframe+((sampleidx+1)*4);

   fixsamples=int2fixed(actsamples);
}

