#ifndef _TWEAK_H_
#define _TWEAK_H_
//CRTC indices
#define  HZ_DISPLAY_TOTAL        0x00
#define  HZ_DISPLAY_END          0x01
#define  CRTC_OVERFLOW           0x07
#define  VT_DISPLAY_END          0x12
#define  MEM_OFFSET              0x13
//register array indices
#define CLOCK_INDEX              0
#define H_TOTAL_INDEX            1
#define H_DISPLAY_INDEX          2
#define H_BLANKING_START_INDEX   3
#define H_BLANKING_END_INDEX     4
#define H_RETRACE_START_INDEX    5
#define H_RETRACE_END_INDEX      6
#define V_TOTAL_INDEX            7
#define OVERFLOW_INDEX           8
#define MAXIMUM_SCANLINE_INDEX   10
#define V_RETRACE_START_INDEX    11
#define V_RETRACE_END_INDEX      12
#define V_END_INDEX              13
#define MEM_OFFSET_INDEX         14
#define UNDERLINE_LOC_INDEX      15
#define V_BLANKING_START_INDEX   16
#define V_BLANKING_END_INDEX     17
#define MODE_CONTROL_INDEX       18
#define CLOCKING_MODE_INDEX		19
#define MEMORY_MODE_INDEX        20

typedef struct tweakvalTAG
{
   char basename[16];
   int centx;
   int centy;
   int htotal;
   int vtotal;
} TWEAKVAL;
typedef TWEAKVAL *pTWEAKVAL;


void setarcademode(void);
void settweakmode(void);
void choosetweakmode(int mode);
void setgmode(int mode);
void put(pBYTE pData,int xsize,int ysize,long addr, short seg);
void putdirty(pBYTE pData,int xsize,int ysize,long addr, short seg);
void putscale(pBYTE pData,int xsize,int ysize,long addr, short seg);
void putvesa(pBYTE pData,int xsize,int ysize,long addr);
void putvesadirty(pBYTE pData,int xsize,int ysize,long addr);
void putvesadbl(pBYTE pData,int xsize,int ysize,long addr);
void putvesascan(pBYTE pData,int xsize,int ysize,long addr);
void putvesavertscan(pBYTE pData,int xsize,int ysize,long addr);
void putvesadirtydbl(pBYTE pData,int xsize,int ysize,long addr);
void putvesadirtyscan(pBYTE pData,int xsize,int ysize,long addr);
void putvesadirtyvertscan(pBYTE pData,int xsize,int ysize,long addr);
void setupdirty(int ysize);
void fastclear(void);
void fastclearcolor(int col);
void waitsync(void);
void waitsync2(void);
void centermode(int centerx,int centery);
int movescreen(int xmove,int ymove);
int readCRTC(int nIndex);
void writeCRTC(int nIndex, int nValue);
void clearVGAregs(void);
void getCRTChv(int *htot, int *vtot, int *ovrflow,int *hsize);
int getVtEndDisplay(void);
void calcvideorates(float *hrate,float *vrate);
void writetweakvals(void);
void readtweakvals(void);
int gettweak(char *intext,char *base,char *suffix,int *pval);
void getcurtweakvals(int *htotal,int *vtotal,int *centx,int *centy);
void setcurtweakvals(int htotal,int vtotal,int centx,int centy);
int adjusttweaktotals(int hmove, int vmove);
void dumpsettings(void);
void pandisplay(void);
void setstdpal(void);
void clearvesamem(int col);
#endif
