#include "main.h"
#include "globals.h"
#include "ui_lc.h"
#include "twk.h"
#include "control.h"

void markjrdirty(void);

pBYTE pCharSet;
pBYTE pInvCharSet;
extern int tiledirty[16*16];
extern DIPSWITCH   dipswitch[MAX_DIPS];
extern BYTE KeyPressed;
extern int uiids[NO_UI_KEYS];
extern int dsize;
extern int *dpage[4];
static int oldcentx;
static int oldcenty;
static int oldhtotal;
static int oldvtotal;
static int origcentx;
static int origcenty;
static int orightotal;
static int origvtotal;
static int tcentx;
static int tcenty;
extern int setbyui;
static int setjoyidx[NO_JOY_CONFIGS];
extern int joyidx[NO_JOY_CONFIGS];
extern int defjoyidx[NO_JOY_CONFIGS];

static char textvals[64][32];
static int curvals[256];
BYTE savepal[256*3];
static pMENU pCurMenu;
static int curpos;
static char blankpanel[32];
static pMENU pDipMenu;
static pMENU pKeyMenu;
static pMENU pJoyMenu;
static int savecur=0;
static int setdef=FALSE;

void fastclear(void);
//allocate dynamic dip setting menu
void initui(void)
{

   pDipMenu=(pMENU)myalloc(sizeof(MENU));
   pKeyMenu=(pMENU)myalloc(sizeof(MENU));
   pJoyMenu=(pMENU)myalloc(sizeof(MENU));
   memset(pKeyMenu,0,sizeof(MENU));
   memset(pDipMenu,0,sizeof(MENU));
   memset(pJoyMenu,0,sizeof(MENU));
   memset(blankpanel,32,32);
   blankpanel[20]=0;
   if(pBoard->background)
      memcpy(&mainmenu.menuitem[mainmenu.noitems++],&backmenuitem,sizeof(MENUITEM));
   memcpy(&mainmenu.menuitem[mainmenu.noitems++],&exitmenuitem,sizeof(MENUITEM));
}

//clear down dip setting menu
void clearui(void)
{
   myfree(pDipMenu);
   myfree(pKeyMenu);
   myfree(pJoyMenu);
}

int createdefkeymenu(void)
{
   return createkeymenu(DEFAULT_KEYS);
}

int createthiskeymenu(void)
{
   return createkeymenu(GAME_KEYS);
}


int choosekey(void)
{
   int starty=((pBoard->boardScreen[realorient].ysize-(pKeyMenu->noitems<<3))>>1)+(curpos<<3);
   uidispcentrestring(starty,blankpanel,0);
   pKeyMenu->menuitem[curpos].pvalue=scantoname(0);
   pKeyMenu->menuitem[curpos].waitstate=1;
   KeyPressed=0;
   return 0;
}

int waitkey(void)
{
   if(KeyPressed)
   {
      if(setdef)
      {
         defcodes[pKeyMenu->menuitem[curpos].dipidx]=KeyPressed;
         if(!GameHasSetKeys)
            scancodes[pKeyMenu->menuitem[curpos].dipidx]=KeyPressed;
      }
      else
      {
         scancodes[pKeyMenu->menuitem[curpos].dipidx]=KeyPressed;
         GameHasSetKeys=TRUE;
      }
      pKeyMenu->menuitem[curpos].pvalue=scantoname(KeyPressed);
      pKeyMenu->menuitem[curpos].waitstate=0;
   }
   return 0;
}

int createkeymenu(int mtype)
{
   int i,outidx,j;
   int nonpergame=FALSE;
   outidx=0;
   if(mtype==DEFAULT_KEYS)
      setdef=TRUE;
   else
      setdef=FALSE;

   for(i=0;i<NO_OF_KEYS;i++)
   {
      if(mtype==GAME_KEYS)
      {
         for(j=0;j<NO_UI_KEYS;j++)
         {
            if(i==uiids[j])
            {
               nonpergame=TRUE;
               break;
            }
         }
      }

      if(!nonpergame)
      {
         strcpy(pKeyMenu->menuitem[outidx].szDisplay,keynames[i]);
         if(mtype==GAME_KEYS)
            pKeyMenu->menuitem[outidx].pvalue=scantoname(scancodes[i]);
         else
            pKeyMenu->menuitem[outidx].pvalue=scantoname(defcodes[i]);
         pKeyMenu->menuitem[outidx].dipswitch=0;
         pKeyMenu->menuitem[outidx].dipsub=0;
         pKeyMenu->menuitem[outidx].dipidx=i;
         pKeyMenu->menuitem[outidx].nType=MENU_ACTION|MENU_TEXT_STRING;
         pKeyMenu->menuitem[outidx].value=0;
         pKeyMenu->menuitem[outidx].itemproc=choosekey;
         pKeyMenu->menuitem[outidx].min=0;
         pKeyMenu->menuitem[outidx].max=0;
         pKeyMenu->menuitem[outidx].waitstate=0;
         pKeyMenu->menuitem[outidx].waitproc=waitkey;
         outidx++;
      }
   }

   strcpy(pKeyMenu->menuitem[outidx].szDisplay,"Return to Main Menu");
   pKeyMenu->menuitem[outidx].nType=MENU_ACTION;
   pKeyMenu->menuitem[outidx].itemproc=exitsub;
   pKeyMenu->menuitem[outidx].min=0;
   pKeyMenu->menuitem[outidx++].max=0;

   pKeyMenu->noitems=outidx;
   pKeyMenu->offset=0;
   menuclear();
   pCurMenu=pKeyMenu;
   savecur=curpos;
   curpos=0;
   markalldirty();
   return 0;
}

//create dip menu for current game
int createdipmenu(void)
{
   int i,j,k,min,max,outidx;
   int outtext=0;
   int outitem=0;
   int outvalue=0;
//read through dipswitches
   for(i=0;i<MAX_DIPS;i++)
   {
//stop if we've fallen off the end
      if(!dipswitch[i].id)
         break;
//read through dip values
      for(j=0;j<32;j++)
      {
//stop if we've fallen off the end
         if(!*dipswitch[i].dipsetting[j].szName)
            break;
         outidx=max=min=outtext;
//read through possible values for this dip
         for(k=0;k<16;k++)
         {

            if(!*dipswitch[i].dipsetting[j].valuesetting[k].szValue)
               break;
            strcpy(textvals[outtext++],dipswitch[i].dipsetting[j].valuesetting[k].szValue);
            if(dipswitch[i].dipsetting[j].valuesetting[k].thisvalue)
               outidx=min+k;

            max++;
         }
//add the item to our menu
         curvals[outvalue]=outidx;
         strcpy(pDipMenu->menuitem[outitem].szDisplay,dipswitch[i].dipsetting[j].szName);
         pDipMenu->menuitem[outitem].dipswitch=i;
         pDipMenu->menuitem[outitem].dipsub=j;
         pDipMenu->menuitem[outitem].dipidx=outvalue;
         pDipMenu->menuitem[outitem].nType=MENU_TEXT_VALUE;
         pDipMenu->menuitem[outitem].value=&curvals[outvalue++];
         pDipMenu->menuitem[outitem].itemproc=updatedipsetting;
         pDipMenu->menuitem[outitem].min=min;
         pDipMenu->menuitem[outitem].max=max-1;
         pDipMenu->menuitem[outitem].waitstate=0;
         pDipMenu->menuitem[outitem].waitproc=0;
         outitem++;
      }
   }
//add the exit command
   strcpy(pDipMenu->menuitem[outitem].szDisplay,"Return to Main Menu");
   pDipMenu->menuitem[outitem].nType=MENU_ACTION;
   pDipMenu->menuitem[outitem].itemproc=exitsub;
   pDipMenu->menuitem[outitem].min=0;
   pDipMenu->menuitem[outitem].max=0;
   pDipMenu->menuitem[outitem].waitstate=0;
   pDipMenu->menuitem[outitem++].waitproc=0;

//set total + this as our current menu
   pDipMenu->noitems=outitem;
   menuclear();
   pDipMenu->offset=0;
   pCurMenu=pDipMenu;
   savecur=curpos;
   curpos=0;
   markalldirty();

   return 0;
}

void menuclear(void)
{
   int idx;
   int starty;

   if(pBoard->menuclear)
      pBoard->menuclear();
      return;

   starty=((pBoard->boardScreen[realorient].ysize-(pCurMenu->noitems*8))>>1);

   for(idx=0;idx<pCurMenu->noitems;idx++)
   {
      uidispcentrestring(starty,blankpanel,0);
      starty+=8;
   }
}

int updatedipsetting(void)
{
   int dip,dipsub,dipidx;
   int curval;
//get dip switch + value we're on
   dip=pDipMenu->menuitem[curpos].dipswitch;
   dipsub=pDipMenu->menuitem[curpos].dipsub;
   dipidx=pDipMenu->menuitem[curpos].dipidx;
   curval=curvals[dipidx]-pDipMenu->menuitem[curpos].min;
//update the current value for this dipswitch setting
   cleardipset(dip,dipsub);
   dipswitch[dip].dipsetting[dipsub].valuesetting[curval].thisvalue=1;
   updatedip();
   return 0;
}


int resetgame(void)
{
   int i;
   for(i=0;i<pBoard->nocpus;i++)
   {
//reset the z80 emulator
      mz80SetContext(&context[i]);
      mz80reset();
      mz80GetContext(&context[i]);
      CPURunning[i]=1;
   }
//clear sound
   clearchannels();
//call game specific reset code
   if(pBoard->forcedreset)
      pBoard->forcedreset();

//unpause game
   syspaused=0;
//update dips
   writedip();
   readdip();
   return 0;
}


int exitmain(void)
{
   uiactive=0;
   if(!syspaused)
      uirestorepal();
   markalldirty();
   menuclear();
   return 0;
}

void uireadkeys(void)
{

   if(uikeys[K_UI])
   {
      uiactive=!uiactive;
      if(uiactive)
      {
         pCurMenu=&mainmenu;
         pCurMenu->offset=0;
         curpos=0;
      }
      else
         exitmain();

      if(!syspaused)
      {
         if(uiactive)
            uisetpal();
         else
         {
            uirestorepal();
            markalldirty();
         }

      }
   }

   if(uikeys[K_PAUSE])
   {
      syspaused=!syspaused;
      updatepause();
      if(!uiactive)
      {
         if(syspaused)
            uisetpal();
         else
            uirestorepal();
      }
   }

   if(uikeys[K_RESET])
      resetgame();
   if(uikeys[K_THROTTLE])
   {
      markthorttle();
      throttle=!throttle;
   }
   if(uikeys[K_FPS])
   {
      ShowFPS=!ShowFPS;
      if(!ShowFPS)
         markalldirty();
   }
   if(uikeys[K_FRAMESKIP])
   {
      frameskip++;
      markalldirty();
      if(frameskip>=MAX_SKIPS)
         frameskip=0;
   }

   if(uikeys[K_SCREENSHOT])
      savesshot();
}

void uidispmenu(void)
{
   int idx,starty;
   char buffer[256];
   int col;
   int allowmove=TRUE;
   int maxitems;//=pBoard->boardScreen[realorient].xsize>>3;
   int tot;
   if(!pCurMenu)
      return;

   setbyui=1;

   if(realorient)
   {
      starty=((pBoard->boardScreen[realorient].xsize-(pCurMenu->noitems<<3))>>1);
      maxitems=pBoard->boardScreen[realorient].xsize>>3;
   }
   else
   {
      starty=((pBoard->boardScreen[realorient].ysize-(pCurMenu->noitems<<3))>>1);
      maxitems=pBoard->boardScreen[realorient].ysize>>3;
   }


   if(starty<0)
      starty=0;

   if(pCurMenu->noitems>maxitems)
      tot=maxitems;
   else
      tot=pCurMenu->noitems;



   for(idx=pCurMenu->offset;idx<(tot+pCurMenu->offset);idx++)
   {
      col=(idx==curpos);
      if(pBoard->menuclear)
         uidispcentrestring(starty,blankpanel,0);
      switch(pCurMenu->menuitem[idx].nType&254)
      {
         case MENU_FIXED_INT:
         case MENU_INT_VALUE:
            sprintf(buffer,"%s : %d",pCurMenu->menuitem[idx].szDisplay,*pCurMenu->menuitem[idx].value);
            uidispcentrestring(starty,buffer,col);
            break;
         case MENU_YESNO_VALUE:
            sprintf(buffer,"%s : %s",pCurMenu->menuitem[idx].szDisplay,yesno[*pCurMenu->menuitem[idx].value]);
            uidispcentrestring(starty,buffer,col);
            break;
         case MENU_NOYES_VALUE:
            sprintf(buffer,"%s : %s",pCurMenu->menuitem[idx].szDisplay,yesno[1-*pCurMenu->menuitem[idx].value]);
            uidispcentrestring(starty,buffer,col);
            break;
         case MENU_TEXT_VALUE:
            sprintf(buffer,"%s : %s",pCurMenu->menuitem[idx].szDisplay,textvals[*pCurMenu->menuitem[idx].value]);
            uidispcentrestring(starty,buffer,col);
            break;
         case MENU_TEXT_STRING:
            sprintf(buffer,"%s : %s",pCurMenu->menuitem[idx].szDisplay,pCurMenu->menuitem[idx].pvalue);
            uidispcentrestring(starty,buffer,col);
            break;
         default:
            uidispcentrestring(starty,pCurMenu->menuitem[idx].szDisplay,col);
      }
      if(pCurMenu->menuitem[idx].waitstate&&pCurMenu->menuitem[idx].waitproc)
      {
         allowmove=FALSE;
         pCurMenu->menuitem[idx].waitproc();
      }
      starty+=8;
   }
   if(escpressed)
   {
      if(pCurMenu==&mainmenu)
      {
         exitmain();
      }
      else
      {
         if(pCurMenu==&tweakmenu)
            exitnosave();
         else
            exitsub();
      }
   }
   if(allowmove)
      uimovecursor();
}

void uimovecursor(void)
{
   int maxitems;
   static int lastoffset=0;

   if(realorient)
      maxitems=pBoard->boardScreen[realorient].xsize>>3;
   else
      maxitems=pBoard->boardScreen[realorient].ysize>>3;

   if(uikeys[K_UI_LEFT])
   {
      if(pCurMenu->menuitem[curpos].nType==MENU_INT_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_YESNO_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_NOYES_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_TEXT_VALUE)
      {
         *pCurMenu->menuitem[curpos].value-=1;
         if(*pCurMenu->menuitem[curpos].value<pCurMenu->menuitem[curpos].min)
            *pCurMenu->menuitem[curpos].value=pCurMenu->menuitem[curpos].max;
         if(pCurMenu->menuitem[curpos].itemproc)
            pCurMenu->menuitem[curpos].itemproc();
         markalldirty();

      }

   }

   if(uikeys[K_UI_RIGHT])
   {
      if(pCurMenu->menuitem[curpos].nType==MENU_INT_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_YESNO_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_NOYES_VALUE||
         pCurMenu->menuitem[curpos].nType==MENU_TEXT_VALUE)
      {
         *pCurMenu->menuitem[curpos].value+=1;
         if(*pCurMenu->menuitem[curpos].value>pCurMenu->menuitem[curpos].max)
            *pCurMenu->menuitem[curpos].value=pCurMenu->menuitem[curpos].min;
         if(pCurMenu->menuitem[curpos].itemproc)
            pCurMenu->menuitem[curpos].itemproc();
         markalldirty();

      }
   }

   if(uikeys[K_UI_SELECT])
   {
      if(pCurMenu->menuitem[curpos].nType&MENU_ACTION)
      {
         if(pCurMenu->menuitem[curpos].itemproc)
            pCurMenu->menuitem[curpos].itemproc();
      }
   }

   if(uikeys[K_UI_UP])
   {
      curpos--;
      if(curpos<0)
         curpos=pCurMenu->noitems-1;
      markalldirty();
   }

   if(uikeys[K_UI_DOWN])
   {
      curpos++;
      if(curpos==pCurMenu->noitems)
         curpos=0;
      markalldirty();
   }
   if(curpos>=maxitems)
      pCurMenu->offset=(curpos-maxitems)+1;
   else
      pCurMenu->offset=0;
   if(lastoffset!=pCurMenu->offset)
      markalldirty();
   lastoffset=pCurMenu->offset;
}

void showfps(int fps)
{
   char buffer[128];
   sprintf(buffer,"FSkp:%d FPS:%d ",frameskip,fps);

   uidispstring(0,0,buffer,0);
}

//display a string
void uidispstring(int x,int y,char *data,int color)
{
   int n;
   int slen=strlen(data);
   if(realorient)
   {
      if(FlipScreen)
      {
         y=(pBoard->boardScreen[realorient].xsize-y)-8;
         for(n=0;n<slen;n++,x+=6)
            uidispchar(y,x,data[n],color);
      }
      else
      {
         x=(pBoard->boardScreen[realorient].ysize-x)-8;
         for(n=0;n<slen;n++,x-=6)
            uidispchar(y,x,data[n],color);
      }
   }
   else
   {
      if(FlipScreen)
      {
         x=(pBoard->boardScreen[realorient].xsize-8)-x;
         y=(pBoard->boardScreen[realorient].ysize-y)-8;

         for(n=0;n<slen;n++,x-=6)
            uidispchar(x,y,data[n],color);
      }
      else
      {
         for(n=0;n<slen;n++,x+=6)
            uidispchar(x,y,data[n],color);
      }
   }
}

void uidispcentrestring(int y,char *data,int color)
{
   int x,len,slen,n;
   slen=strlen(data);
   len=slen*6;


   if(realorient)
   {
      if(FlipScreen)
      {
         x=((pBoard->boardScreen[realorient].ysize-len)>>1);
         y=(pBoard->boardScreen[realorient].xsize-y)-8;

         for(n=0;n<slen;n++,x+=6)
            uidispchar(y,x,data[n],color);
      }
      else
      {
         x=pBoard->boardScreen[realorient].ysize-((pBoard->boardScreen[realorient].ysize-len)>>1);
         for(n=0;n<slen;n++,x-=6)
            uidispchar(y,x,data[n],color);
      }
   }
   else
   {
      if(FlipScreen)
      {
         x=pBoard->boardScreen[realorient].xsize-((pBoard->boardScreen[realorient].xsize-len)>>1);
         y=(pBoard->boardScreen[realorient].ysize-y)-8;

         for(n=0;n<slen;n++,x-=6)
            uidispchar(x,y,data[n],color);
      }
      else
      {
         x=(pBoard->boardScreen[realorient].xsize-len)>>1;
         for(n=0;n<slen;n++,x+=6)
            uidispchar(x,y,data[n],color);
      }
   }
}

//display a character
void uidispchar(int x,int y,BYTE data,int color)
{
   int dummy1,dummy2,dummy3;

   pBYTE pcwork;
   pBYTE pcout;
   int dy1;

   if(color)
      pcwork=pInvCharSet+(data<<6);
   else
      pcwork=pCharSet+(data<<6);


   dy1=y-dyoff;
   if(dy1<0)
      dy1=0;
   *dpage[dy1/dsize]=1;
   *dpage[(dy1+7)/dsize]=1;

   pcout=pBoard->pScreen+x+(y<<9);


   if(realorient)
   {
      pcwork+=16;
      if(FlipScreen)
      {
         pcout+=3591;
         for(y=0;y<6;y++)
         {
            for(x=0;x<8;x++)
               *pcout--=*pcwork++;
            pcout-=504;
         }
      }
      else
      {

         for(y=0;y<6;y++)
         {
            for(x=0;x<8;x++)
               *pcout++=*pcwork++;
            pcout+=504;
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         pcout+=3591;
         for(y=0;y<8;y++)
         {
            for(x=0;x<6;x++)
               *pcout--=*pcwork++;
            pcout-=506;
            pcwork+=2;
         }
      }
      else
      {
         for(y=0;y<8;y++)
         {
            for(x=0;x<6;x++)
               *pcout++=*pcwork++;
            pcout+=506;
            pcwork+=2;
         }
      }
   }
}

//dim palette
void uisetpal(void)
{
   int i;

   for(i=0;i<255;i++)
   {
      outportb(0x3c7,i);
      savepal[i*3]=inportb(0x3c9);
      savepal[(i*3)+1]=inportb(0x3c9);
      savepal[(i*3)+2]=inportb(0x3c9);
   }

   for(i=0;i<255;i++)
   {
      outportb(0x3c8,i);
      outportb(0x3c9,(int)(((float)savepal[i*3]/100.0f)*40.0f));
      outportb(0x3c9,(int)(((float)savepal[(i*3)+1]/100.0f)*40.0f));
      outportb(0x3c9,(int)(((float)savepal[(i*3)+2]/100.0f)*40.0f));
   }
}


void baseuipal(void)
{
   outportb(0x3c8,255);
   outportb(0x3c9,63);
   outportb(0x3c9,63);
   outportb(0x3c9,63);
}
//restore palette
void uirestorepal(void)
{
   int i;
   for(i=0;i<255;i++)
   {
      outportb(0x3c8,i);
      outportb(0x3c9,savepal[i*3]);
      outportb(0x3c9,savepal[(i*3)+1]);
      outportb(0x3c9,savepal[(i*3)+2]);
   }

}
//exit sub menu
int exitsub(void)
{
   pCurMenu=&mainmenu;
   curpos=savecur;
   markalldirty();
   menuclear();
   return 0;
}

//load in the UI font
int loadfont(void)
{
   int   pcloop;
   char  buffer[64];
   char  buffer2[64];
   char  work;

   int   outer,inner,winc;
   BYTE  cAnd,cOut;
   pBYTE romchar;
   pBYTE pcout;
   pBYTE pcout2;
   pBYTE pFileFont;
	FILE	*fin;
   int x,y;

   pCharSet=myalloc(16384);
   if(!pCharSet)
      return FALSE;

   pInvCharSet=myalloc(16384);
   if(!pInvCharSet)
      return FALSE;

   pcout=pCharSet;
   pcout2=pInvCharSet;

   pFileFont=myalloc(2048);

	if(!pFileFont)
   {
      myfree(pCharSet);
      myfree(pInvCharSet);
      return FALSE;
   }

   fin=fopen("vantage.fnt","rb");
	if(!fin)
	{
		myfree(pFileFont);
      myfree(pCharSet);
      myfree(pInvCharSet);
      return FALSE;
	}

	fread(pFileFont,1,2048,fin);

   for(pcloop=0;pcloop<256;pcloop++)
   {
      memset(buffer,0,64);
      memset(buffer2,0,64);
      romchar=pFileFont+(pcloop*8);
      if(realorient)
      {
         for(outer=0;outer<8;outer++)
         {
            cAnd=128;
            for(inner=0;inner<8;inner++)
            {
               if(*romchar&cAnd)
                  buffer[((7-inner)*8)+outer]=255;
               else
                  buffer2[((7-inner)*8)+outer]=255;

               cAnd>>=1;

            }
            romchar++;
         }
      }
      else
      {
         for(outer=0;outer<8;outer++)
         {
            cAnd=128;
            for(inner=0;inner<8;inner++)
            {
               if(*romchar&cAnd)
                  buffer[(outer*8)+inner]=255;
               else
                  buffer2[(outer*8)+inner]=255;

               cAnd>>=1;
            }
            romchar++;
			}
      }
      memcpy(pcout,buffer,64);
      memcpy(pcout2,buffer2,64);
      pcout+=64;
      pcout2+=64;
	}
	myfree(pFileFont);
   return TRUE;
}
//free the UI font
void clearfont(void)
{
   myfree(pCharSet);
   myfree(pInvCharSet);
}

void markalldirty(void)
{
   memset(pacdirty,-1,sizeof(int)*36*32);
   memset(tiledirty,-1,sizeof(int)*16*16);
   memset(gendirty,-1,sizeof(int)*48*48);
   markjrdirty();
}

int centervalchange(void)
{
   if(oldcentx!=wrkcentx)
      if(movescreen((wrkcentx-oldcentx),0))
         oldcentx=wrkcentx;


   if(oldcenty!=wrkcenty)
     if(movescreen(0,(wrkcenty-oldcenty)))
      oldcenty=wrkcenty;

   wrkcentx=oldcentx;
   wrkcenty=oldcenty;
   return 0;
}

int totalchange(void)
{
   if(oldhtotal!=htotal)
      if(adjusttweaktotals((htotal-oldhtotal),0))
         oldhtotal=htotal;

   if(oldvtotal!=vtotal)
      if(adjusttweaktotals(0,(vtotal-oldvtotal)))
         oldvtotal=vtotal;

   htotal=oldhtotal;
   vtotal=oldvtotal;
   updaterates();
   return 0;
}


//create tweak screen menu
int createtweakmenu(void)
{

//get current totals
   getcurtweakvals(&htotal,&vtotal,&tcentx,&tcenty);

   wrkcentx=origcentx=oldcentx=(tcentx+centerx);
   wrkcenty=origcenty=oldcenty=(tcenty+centery);
   orightotal=oldhtotal=htotal;
   origvtotal=oldvtotal=vtotal;
//calc ~ rates
   updaterates();
   menuclear();
   if(UsingVESA)
      pCurMenu=&VEAStweakmenu;
   else
      pCurMenu=&tweakmenu;
   pCurMenu->offset=0;
   savecur=curpos;
   curpos=0;
   markalldirty();
   return 0;
}

void updaterates(void)
{
   float hrate,vrate;
   calcvideorates(&hrate,&vrate);
   sprintf(curhzrate,"(~%.2f kHz)]",hrate);
   sprintf(curvtrate,"(~%.2f Hz)]",vrate);
}

int restoretweakdefs(void)
{
   wrkcentx=origcentx;
   centervalchange();
   wrkcenty=origcenty;
   centervalchange();
   htotal=orightotal;
   totalchange();
   vtotal=origvtotal;
   totalchange();
   markalldirty();
   return 0;
}

int exitnosave(void)
{
   restoretweakdefs();
   return exitsub();
}

int exitsave(void)
{
   tcentx+=(wrkcentx-origcentx);
   tcenty+=(wrkcenty-origcenty);
   setcurtweakvals(htotal,vtotal,tcentx,tcenty);
   return exitsub();
}


int createdefjoymenu(void)
{
   return createjoymenu(DEFAULT_KEYS);
}

int createthisjoymenu(void)
{
   return createjoymenu(GAME_KEYS);
}

int createjoymenu(int mtype)
{
   int i;
   for(i=0;i<NO_OF_KEYS;i++)
      strcpy(textvals[i],keynames[i]);


   for(i=0;i<NO_JOY_CONFIGS;i++)
   {
      strcpy(pJoyMenu->menuitem[i].szDisplay,joydisp[i]);
      if(mtype==GAME_KEYS)
      {
         setjoyidx[i]=joyidx[i];
         setdef=FALSE;
      }
      else
      {
         setjoyidx[i]=defjoyidx[i];
         setdef=TRUE;
      }
      pJoyMenu->menuitem[i].value=&setjoyidx[i];
      pJoyMenu->menuitem[i].dipswitch=0;
      pJoyMenu->menuitem[i].dipsub=0;
      pJoyMenu->menuitem[i].dipidx=i;
      pJoyMenu->menuitem[i].nType=MENU_TEXT_VALUE;
      pJoyMenu->menuitem[i].itemproc=joychange;
      pJoyMenu->menuitem[i].min=0;
      pJoyMenu->menuitem[i].max=NO_OF_KEYS;
      pJoyMenu->menuitem[i].waitstate=0;
      pJoyMenu->menuitem[i].waitproc=0;
   }

   strcpy(pJoyMenu->menuitem[i].szDisplay,"Return to Main Menu");
   pJoyMenu->menuitem[i].nType=MENU_ACTION;
   pJoyMenu->menuitem[i].itemproc=exitsub;
   pJoyMenu->menuitem[i].min=0;
   pJoyMenu->menuitem[i++].max=0;

   pJoyMenu->noitems=i;
   menuclear();
   pCurMenu=pJoyMenu;
   pCurMenu->offset=0;
   savecur=curpos;
   curpos=0;
   markalldirty();
   return 0;
}

int joychange(void)
{
   if(setdef)
   {
      defjoyidx[curpos]=setjoyidx[curpos];
      if(!GameHasSetJoy)
         joyidx[curpos]=setjoyidx[curpos];
   }
   else
   {
      joyidx[curpos]=setjoyidx[curpos];
      GameHasSetJoy=TRUE;
   }
   return 0;
}

int updatepause(void)
{
   if(syspaused)
      pauseallsamples();
   else
      resumeallsamples();
   return 0;
}
