#ifndef _VESA_H_
#define _VESA_H_

#define __PACKED__   __attribute__ ((packed))

typedef struct vesainfoTAG
{
   unsigned char VESASignature[4];
   unsigned short VESAVersion;
   unsigned long OEMStringPtr;
   unsigned char Capabilities[4];
   unsigned long VideoModePtr;
   unsigned short TotalMemory;
   unsigned short OemSoftwareRev;
   unsigned long OemVendorNamePtr;
   unsigned long OemProductNamePtr;
   unsigned long OemProductRevPtr;
   unsigned char Reserved[222];
   unsigned char OemData[256];
} __PACKED__ VESAINFO;



typedef struct modeinfoTAG
{
   unsigned short ModeAttributes      ;
   unsigned char  WinAAttributes      ;
   unsigned char  WinBAttributes      ;
   unsigned short WinGranularity      ;
   unsigned short WinSize             ;
   unsigned short WinASegment         ;
   unsigned short WinBSegment         ;
   unsigned long  WinFuncPtr          ;
   unsigned short BytesPerScanLine    ;
   unsigned short XResolution         ;
   unsigned short YResolution         ;
   unsigned char  XCharSize           ;
   unsigned char  YCharSize           ;
   unsigned char  NumberOfPlanes      ;
   unsigned char  BitsPerPixel        ;
   unsigned char  NumberOfBanks       ;
   unsigned char  MemoryModel         ;
   unsigned char  BankSize            ;
   unsigned char  NumberOfImagePages  ;
   unsigned char  Reserved_page       ;
   unsigned char  RedMaskSize         ;
   unsigned char  RedMaskPos          ;
   unsigned char  GreenMaskSize       ;
   unsigned char  GreenMaskPos        ;
   unsigned char  BlueMaskSize        ;
   unsigned char  BlueMaskPos         ;
   unsigned char  ReservedMaskSize    ;
   unsigned char  ReservedMaskPos     ;
   unsigned char  DirectColorModeInfo ;

   /* VBE 2.0 extensions */
   unsigned long  PhysBasePtr         ;
   unsigned long  OffScreenMemOffset  ;
   unsigned short OffScreenMemSize    ;

   /* VBE 3.0 extensions */
   unsigned short LinBytesPerScanLine ;
   unsigned char  BnkNumberOfPages    ;
   unsigned char  LinNumberOfPages    ;
   unsigned char  LinRedMaskSize      ;
   unsigned char  LinRedFieldPos      ;
   unsigned char  LinGreenMaskSize    ;
   unsigned char  LinGreenFieldPos    ;
   unsigned char  LinBlueMaskSize     ;
   unsigned char  LinBlueFieldPos     ;
   unsigned char  LinRsvdMaskSize     ;
   unsigned char  LinRsvdFieldPos     ;
   unsigned long  MaxPixelClock       ;

   unsigned char  Reserved[190]       ;
}  __PACKED__ MODEINFO;



typedef struct pminfoTAG
{
   unsigned short setWindow           ;
   unsigned short setDisplayStart     ;
   unsigned short setPalette          ;
   unsigned short IOPrivInfo          ;
}  __PACKED__ PMINFO;



#define PM_MASK(x) ((x << 4) & 0xfffff)
#define RM_MASK(x) (((x & 0xFFFF0000) >> 12) + (x & 0xFFFF))

#define QUICK_LOCK(x)   _go32_dpmi_lock_data(&x,sizeof(x))

#define MEM_MATCH(mem, wanted_mem) \
   ((mem == wanted_mem) || ((mem == 4) && (wanted_mem == 6)))

#define BPP_MATCH(bpp, wanted_bpp) \
   ((bpp == wanted_bpp) || ((bpp == 16) && (wanted_bpp == 15)))

#define RES_SIZE_MATCH(size, wanted_size, bpp) \
   ((size == wanted_size) || ((size == 0) && ((bpp == 15) || (bpp == 32))))

#define RES_POS_MATCH(pos, wanted_pos, bpp) \
   ((pos == wanted_pos) || ((pos == 0) && ((bpp == 15) || (bpp == 32))))

#define MAX_VESA_MODES 1024
#define MAX(x,y)     (((x) > (y)) ? (x) : (y))

int getvesamode(int *xsize,int *ysize,int *mode);
int getvesainfo(void);
int findvesamode(int w,int h,int *pmode);
int getmodeinfo(int mode);
int setvesamode(int vmode);
void clearvesa(void);

int createphysicalmapping(unsigned long *linear, int *segment, unsigned long physaddr, int size);
int createlinearmapping(unsigned long *linear, unsigned long physaddr, int size);

int createselector(int *segment, unsigned long linear, int size);
void removelinearmapping(unsigned long *linear);
void removeselector(int *segment);



#endif
