#ifndef _VIDEO_H_
#define _VIDEO_H_

#define WRITE_MEM pCode[offset]=value;

#define NO_PRECALC   0
#define PRECALC_REAL 1
#define PRECALC_ROT  2

#define TYPE_CHAR 0
#define TYPE_SPR  1
#define TYPE_BIG  2
#define TYPE_TILE 3

typedef struct sprlayoutTAG
{
   int nocols;
   int total;
   int noplanes;
   int planeoffsets[8];
   int xoffsets[32];
   int yoffsets[32];
   int sproff;
} SPRLAYOUT;
typedef SPRLAYOUT *pSPRLAYOUT;

typedef struct gfxdetailsTAG
{
   int startoffset;
   int coffset;
   int xsize;
   int ysize;
   pSPRLAYOUT pSprLayout;
   int lookupidx;
   int nType;
}GFXDETAILS;

typedef GFXDETAILS *pGFXDETAILS;

typedef struct paletteTAG
{
   BYTE r;
   BYTE g;
   BYTE b;
} PALETTE;

typedef PALETTE *pPALETTE;

#define DIRTYCHAR \
   { \
      int dy1; \
      dy1=y-dyoff; \
      if(dy1>=0&&(dy1/dsize)<4) \
      { \
         *dpage[dy1/dsize]=1; \
         *dpage[(dy1+7)/dsize]=1; \
      } \
   } \

#define PRECALC_RETURN \
   if(nType==(2-realorient)) \
      return;

extern BYTE collookups[8][1024];

#define COL_CHAR     (col<<16)
#define COL_SPRITE   (col<<17)
#define COL_TILE     (col<<17)
#define COL_BIG      (col<<17)

//shared char/sprite arrays
extern pBYTE Gfx;
extern pBYTE Mask;
extern pBYTE FlipGfx;
extern pBYTE FlipMask;
extern pBYTE Sprites;
extern pBYTE Tiles;
extern pBYTE BigSprites;

void initgfx(void);
void readgfxs(pBYTE pIn,int nType);
void decodespr(pGFXDETAILS pGfxDetails,pBYTE pIn);

int dispchar(int x,int y,int value,BYTE col);
void dispopqchar(int x,int y,int value,BYTE col);
void dispflipchar(int x,int y,int value,BYTE col,int flpx,int flpy);
void disptranschar(int x,int y,int value,BYTE col);
void disptranschar2(int x,int y,int value,BYTE col);
void disp32sprite(int x,int y,int value,BYTE col,int flipx,int flipy);
void flipchars(int cols,int chars);
void rotchars(int cols,int chars);
void rotsprites(int cols,int sprites);
void rottiles(int cols,int tiles);
void rotbigsprites(int cols,int sprites);
void flipscreenw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void ivflipscreenw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
int remapcolour(int coltomap,pPALETTE pPalette,int nocols);
#endif
