#include "main.h"
#include "zaxvid.h"
#include "globals.h"
#include "twk.h"


#define TOTAL_SOUNDS 22
static int soundplaying[TOTAL_SOUNDS];

struct sa
{
	int channel;
	int num;
	int looped;
	int stoppable;
	int restartable;
};

struct sa sa[TOTAL_SOUNDS] =
{
   {  0,  0, LOOP, 1, 1 }, /* Line  4 - Homing Missile  (channel 1) */
   {  1,  1, ONE_SHOT, 1, 1 }, /* Line  5 - Base Missile */
   {  2,  2, LOOP, 1, 1 }, /* Line  6 - Laser (force field) (channel 1) */
   {  3,  3, LOOP, 1, 1 }, /* Line  7 - Battleship (end of level boss) (channel 1) */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line  8 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line  9 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 10 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 11 - unused */
   {  4,  4, ONE_SHOT, 0, 1 }, /* Line 12 - S-Exp (enemy explosion) */
   {  5,  5, ONE_SHOT, 0, 0 }, /* Line 13 - M-Exp (ship explosion) (channel 1) */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 14 - unused */
   {  6,  6, ONE_SHOT, 0, 1 }, /* Line 15 - Cannon (ship fire) */
   {  7,  7, ONE_SHOT, 0, 1 }, /* Line 16 - Shot (enemy fire) */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 17 - unused */
   {  8,  8, ONE_SHOT, 0, 1 }, /* Line 18 - Alarm 2 (target lock) */
   {  9,  9, ONE_SHOT, 0, 0 }, /* Line 19 - Alarm 3 (low fuel) (channel 1) */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 20 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 21 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 22 - unused */
   { -1,  0, ONE_SHOT, 0, 0 },              /* Line 23 - unused */
   { 10, 10, LOOP, 1, 1 }, /* background */
   { 11, 11, LOOP, 1, 1 }, /* background */
};


void zaxsoundw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;
	int line;
	int noise;

   WRITE_MEM

   work=offset-mwb->lowAddr;


   if(work==0)
	{
      switch (value & 0x0c)
		{
			case 0x04:

				soundplaying[20] = 0;
            stopsample(sa[20].channel);
				if (soundplaying[21] == 0)
				{
					soundplaying[21] = 1;
               playsample(sa[21].channel,sa[21].num,sa[21].looped,DEFAULT_FREQ);
				}
				break;
			case 0x00:
			case 0x08:
				if (soundplaying[20] == 0)
				{
					soundplaying[20] = 1;
               playsample(sa[20].channel,sa[20].num,sa[20].looped,DEFAULT_FREQ);
				}
				soundplaying[21] = 0;
            stopsample(sa[21].channel);
				break;
			case 0x0c:
				soundplaying[20] = 0;
            stopsample(sa[20].channel);
				soundplaying[21] = 0;
            stopsample(sa[21].channel);
				break;
		}
	}

	for (line = 0;line < 8;line++)
	{
      noise = 8 * work + line - 4;

		if (noise >= 0)
		{
         if ((value & (1 << line)) == 0)
			{
				if (soundplaying[noise] == 0)
				{
					soundplaying[noise] = 1;
					if (sa[noise].channel != -1)
					{
                  if (sa[noise].restartable||!channel[sa[noise].channel].playing)
                     playsample(sa[noise].channel,sa[noise].num,sa[noise].looped,DEFAULT_FREQ);
					}
				}
			}
			else
			{
				if (soundplaying[noise])
				{
					soundplaying[noise] = 0;
					if (sa[noise].channel != -1 && sa[noise].stoppable)
                  stopsample(sa[noise].channel);
				}
			}
		}
	}
}
